
unit /home/pluto/Desktop/xinepascal/test1/xine;
interface

{
  Automatically converted by H2Pas 1.0.0 from /home/pluto/Desktop/xinepascal/test1/xine.tmp.h
  The following command line parameters were used:
    -o
    /home/pluto/Desktop/xinepascal/test1/xine.inc
    /home/pluto/Desktop/xinepascal/test1/xine.tmp.h
}

  Type
  Pdouble  = ^double;
  Plongint  = ^longint;
  Pxine_cfg_entry_t  = ^xine_cfg_entry_t;
  Pxine_event_t  = ^xine_event_t;
  Pxine_post_out_t  = ^xine_post_out_t;
  Pxine_post_t  = ^xine_post_t;
{$IFDEF FPC}
{$PACKRECORDS C}
{$ENDIF}


  {
   * Copyright (C) 2000-2006 the xine project
   *
   * This file is part of xine, a free video player.
   *
   * xine is free software; you can redistribute it and/or modify
   * it under the terms of the GNU General Public License as published by
   * the Free Software Foundation; either version 2 of the License, or
   * (at your option) any later version.
   *
   * xine is distributed in the hope that it will be useful,
   * but WITHOUT ANY WARRANTY; without even the implied warranty of
   * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   * GNU General Public License for more details.
   *
   * You should have received a copy of the GNU General Public License
   * along with this program; if not, write to the Free Software
   * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA
   *
   * $Id: xine.h.in,v 1.162 2006/12/21 00:09:18 dsalt Exp $
   *
   * public xine-lib (libxine) interface and documentation
   *
   *
   * some programming guidelines about this api:
   * -------------------------------------------
   *
   * (1) libxine has (per stream instance) a fairly static memory
   *     model
   * (2) as a rule of thumb, never free() or realloc() any pointers
   *     returned by the xine engine (unless stated otherwise)
   *     or, in other words:
   *     do not free() stuff you have not malloc()ed
   * (3) xine is multi-threaded, make sure your programming environment
   *     can handle this.
   *     for x11-related stuff this means that you either have to properly
   *     use xlockdisplay() or use two seperate connections to the x-server
   *
    }
  { This enables some experimental features. These are not part of the
   * official libxine API, so use them only, if you absolutely need them.
   * Although we make efforts to keep even this part of the API as stable
   * as possible, this is not guaranteed. Incompatible changes can occur.
    }
  { #define XINE_ENABLE_EXPERIMENTAL_FEATURES  }
  { This disables some deprecated features. These are still part of the
   * official libxine API and you may still use them. During the current
   * major release series, these will always be available and will stay
   * compatible. However, removal is likely to occur as soon as possible.
    }
  { #define XINE_DISABLE_DEPRECATED_FEATURES  }
  {********************************************************************
   * xine opaque data types                                            *
   ******************************************************************** }

  type
     xine_s = xine_t;
     xine_stream_s = xine_stream_t;
     xine_audio_port_s = xine_audio_port_t;
     xine_video_port_s = xine_video_port_t;
  { convenience types: simple player UIs might want to call ports drivers  }

     xine_ao_driver_t = xine_audio_port_t;

     xine_vo_driver_t = xine_video_port_t;
  {********************************************************************
   * global engine handling                                            *
   ******************************************************************** }
  {
   * version information
    }
  { dynamic info from actually linked libxine  }
(* Const before type ignored *)
(* error 
const char *xine_get_version_string (void) XINE_PROTECTED;
 in declarator_list *)

    var
 : char;
(* error 
void xine_get_version (int *major, int *minor, int *sub) XINE_PROTECTED;
 in declarator_list *)
 : pointer;
  { compare given version to libxine version,
     return 1 if compatible, 0 otherwise  }
(* error 
int  xine_check_version (int major, int minor, int sub) XINE_PROTECTED;
 in declarator_list *)
 : longint;
  { static info - which libxine release this header came from  }

  const
     XINE_MAJOR_VERSION = 1;     
     XINE_MINOR_VERSION = 1;     
     XINE_SUB_VERSION = 4;     
     XINE_VERSION = '1.1.4';     
  {
   * pre-init the xine engine
   *
   * will first malloc and init a xine_t, create an empty config
   * system, then scan through all installed plugins and add them
   * to an internal list for later use.
   *
   * to fully init the xine engine, you have to load config values
   * (either using your own storage method and calling
   * xine_config_register_entry, or by using the xine_load_config
   * utility function - see below) and then call xine_init
   *
   * the only proper way to shut down the xine engine is to
   * call xine_exit() - do not try to free() the xine pointer
   * yourself and do not try to access any internal data structures
    }
(* error 
xine_t *xine_new (void) XINE_PROTECTED;
 in declarator_list *)

    var
 : xine_t;
  {
   * post_init the xine engine
    }
(* error 
void xine_init (xine_t *self) XINE_PROTECTED;
 in declarator_list *)
 : pointer;
  {
   * helper functions to find and init audio/video drivers
   * from xine's plugin collection
   *
   * id    : identifier of the driver, may be NULL for auto-detection
   * data  : special data struct for ui/driver communications, depends
   *         on driver
   * visual: video driver flavor selector, constants see below
   *
   * both functions may return NULL if driver failed to load, was not
   * found ...
   *
   * use xine_close_audio/video_driver() to close loaded drivers
   * and free resources allocated by them
    }
(* Const before type ignored *)
(* error 
					   void *data) XINE_PROTECTED;
 in declarator_list *)
 : xine_audio_port_t;
(* Const before type ignored *)
(* error 
					   int visual, void *data) XINE_PROTECTED;
 in declarator_list *)
 : xine_video_port_t;
(* error 
void xine_close_audio_driver (xine_t *self, xine_audio_port_t  *driver) XINE_PROTECTED;
 in declarator_list *)
 : pointer;
(* error 
void xine_close_video_driver (xine_t *self, xine_video_port_t  *driver) XINE_PROTECTED;
 in declarator_list *)
 : pointer;
  { valid visual types  }

  const
     XINE_VISUAL_TYPE_NONE = 0;     
     XINE_VISUAL_TYPE_X11 = 1;     
     XINE_VISUAL_TYPE_X11_2 = 10;     
     XINE_VISUAL_TYPE_AA = 2;     
     XINE_VISUAL_TYPE_FB = 3;     
     XINE_VISUAL_TYPE_GTK = 4;     
     XINE_VISUAL_TYPE_DFB = 5;     
  { used by the OS/2 port  }
     XINE_VISUAL_TYPE_PM = 6;     
  { used by the win32/msvc port  }
     XINE_VISUAL_TYPE_DIRECTX = 7;     
     XINE_VISUAL_TYPE_CACA = 8;     
     XINE_VISUAL_TYPE_MACOSX = 9;     
  {
   * free all resources, close all plugins, close engine.
   * self pointer is no longer valid after this call.
    }
(* error 
void xine_exit (xine_t *self) XINE_PROTECTED;
 in declarator_list *)

    var
 : pointer;
  {********************************************************************
   * stream handling                                                   *
   ******************************************************************** }
  {
   * create a new stream for media playback/access
   *
   * returns xine_stream_t* if OK,
   *         NULL on error (use xine_get_error for details)
   *
   * the only proper way to free the stream pointer returned by this
   * function is to call xine_dispose() on it. do not try to access any
   * fields in xine_stream_t, they're all private and subject to change
   * without further notice.
    }
(* error 
				xine_audio_port_t *ao, xine_video_port_t *vo) XINE_PROTECTED;
 in declarator_list *)
 : xine_stream_t;
  {
   * Make one stream the slave of another.
   * This establishes a binary master slave relation on streams, where
   * certain operations (specified by parameter "affection") on the master
   * stream are also applied to the slave stream.
   * If you want more than one stream to react to one master, you have to
   * apply the calls in a top down way:
   *  xine_stream_master_slave(stream1, stream2, 3);
   *  xine_stream_master_slave(stream2, stream3, 3);
   * This will make stream1 affect stream2 and stream2 affect stream3, so
   * effectively, operations on stream1 propagate to stream2 and 3.
   *
   * Please note that subsequent master_slave calls on the same streams
   * will overwrite their previous master/slave setting.
   * Be sure to not mess around.
   *
   * returns 1 on success, 0 on failure
    }
(* error 
                             int affection) XINE_PROTECTED;
 in declarator_list *)
 : longint;
  { affection is some of the following ORed together:  }
  { playing the master plays the slave  }

  const
     XINE_MASTER_SLAVE_PLAY = 1 shl 0;     
  { slave stops on master stop  }
     XINE_MASTER_SLAVE_STOP = 1 shl 1;     
  { slave is synced to master's speed  }
     XINE_MASTER_SLAVE_SPEED = 1 shl 2;     
  {
   * open a stream
   *
   * look for input / demux / decoder plugins, find out about the format
   * see if it is supported, set up internal buffers and threads
   *
   * returns 1 if OK, 0 on error (use xine_get_error for details)
    }
(* Const before type ignored *)
(* error 
int xine_open (xine_stream_t *stream, const char *mrl) XINE_PROTECTED;
 in declarator_list *)

    var
 : longint;
  {
   * play a stream from a given position
   *
   * start_pos:  0..65535
   * start_time: milliseconds
   * if both start position parameters are != 0 start_pos will be used
   * for non-seekable streams both values will be ignored
   *
   * returns 1 if OK, 0 on error (use xine_get_error for details)
    }
(* error 
int  xine_play (xine_stream_t *stream, int start_pos, int start_time) XINE_PROTECTED;
 in declarator_list *)
 : longint;
  {
   * set xine to a trick mode for fast forward, backwards playback,
   * low latency seeking. Please note that this works only with some
   * input plugins. mode constants see below.
   *
   * returns 1 if OK, 0 on error (use xine_get_error for details)
    }
(* error 
int  xine_trick_mode (xine_stream_t *stream, int mode, int value) XINE_PROTECTED;
 in declarator_list *)
 : longint;
  { trick modes  }

  const
     XINE_TRICK_MODE_OFF = 0;     
     XINE_TRICK_MODE_SEEK_TO_POSITION = 1;     
     XINE_TRICK_MODE_SEEK_TO_TIME = 2;     
     XINE_TRICK_MODE_FAST_FORWARD = 3;     
     XINE_TRICK_MODE_FAST_REWIND = 4;     
  {
   * stop stream playback
   * xine_stream_t stays valid for new xine_open or xine_play
    }
(* error 
void xine_stop (xine_stream_t *stream) XINE_PROTECTED;
 in declarator_list *)

    var
 : pointer;
  {
   * stop stream playback, free all stream-related resources
   * xine_stream_t stays valid for new xine_open
    }
(* error 
void xine_close (xine_stream_t *stream) XINE_PROTECTED;
 in declarator_list *)
 : pointer;
  {
   * ask current/recent input plugin to eject media - may or may not work,
   * depending on input plugin capabilities
    }
(* error 
int  xine_eject (xine_stream_t *stream) XINE_PROTECTED;
 in declarator_list *)
 : longint;
  {
   * stop playback, dispose all stream-related resources
   * xine_stream_t no longer valid when after this
    }
(* error 
void xine_dispose (xine_stream_t *stream) XINE_PROTECTED;
 in declarator_list *)
 : pointer;
  {
   * set/get engine parameters.
    }
(* error 
void xine_engine_set_param(xine_t *self, int param, int value) XINE_PROTECTED;
 in declarator_list *)
 : pointer;
(* error 
int xine_engine_get_param(xine_t *self, int param) XINE_PROTECTED;
 in declarator_list *)
 : longint;

  const
     XINE_ENGINE_PARAM_VERBOSITY = 1;     
  {
   * set/get xine stream parameters
   * e.g. playback speed, constants see below
    }
(* error 
void xine_set_param (xine_stream_t *stream, int param, int value) XINE_PROTECTED;
 in declarator_list *)

    var
 : pointer;
(* error 
int  xine_get_param (xine_stream_t *stream, int param) XINE_PROTECTED;
 in declarator_list *)
 : longint;
  {
   * xine stream parameters
    }
  { see below                    }

  const
     XINE_PARAM_SPEED = 1;     
  { unit: 1/90000 sec            }
     XINE_PARAM_AV_OFFSET = 2;     
  { -1 => auto, -2 => off        }
     XINE_PARAM_AUDIO_CHANNEL_LOGICAL = 3;     
     XINE_PARAM_SPU_CHANNEL = 4;     
     XINE_PARAM_VIDEO_CHANNEL = 5;     
  { 0..100                       }
     XINE_PARAM_AUDIO_VOLUME = 6;     
  { 1=>mute, 0=>unmute           }
     XINE_PARAM_AUDIO_MUTE = 7;     
  { <100=>off, % compress otherw }
     XINE_PARAM_AUDIO_COMPR_LEVEL = 8;     
  { 0..200, 100=>100% (default)  }
     XINE_PARAM_AUDIO_AMP_LEVEL = 9;     
  { 1=>send events, 0=> don't    }
     XINE_PARAM_AUDIO_REPORT_LEVEL = 10;     
  { control console output       }
     XINE_PARAM_VERBOSITY = 11;     
  { unit: 1/90000 sec            }
     XINE_PARAM_SPU_OFFSET = 12;     
  { disable video decoding       }
     XINE_PARAM_IGNORE_VIDEO = 13;     
  { disable audio decoding       }
     XINE_PARAM_IGNORE_AUDIO = 14;     
  { disable spu decoding         }
     XINE_PARAM_IGNORE_SPU = 15;     
  { 0: disable, x: server port   }
     XINE_PARAM_BROADCASTER_PORT = 16;     
  { unit: 1/90000 sec            }
     XINE_PARAM_METRONOM_PREBUFFER = 17;     
  { equalizer gains -100..100    }
     XINE_PARAM_EQ_30HZ = 18;     
  { equalizer gains -100..100    }
     XINE_PARAM_EQ_60HZ = 19;     
  { equalizer gains -100..100    }
     XINE_PARAM_EQ_125HZ = 20;     
  { equalizer gains -100..100    }
     XINE_PARAM_EQ_250HZ = 21;     
  { equalizer gains -100..100    }
     XINE_PARAM_EQ_500HZ = 22;     
  { equalizer gains -100..100    }
     XINE_PARAM_EQ_1000HZ = 23;     
  { equalizer gains -100..100    }
     XINE_PARAM_EQ_2000HZ = 24;     
  { equalizer gains -100..100    }
     XINE_PARAM_EQ_4000HZ = 25;     
  { equalizer gains -100..100    }
     XINE_PARAM_EQ_8000HZ = 26;     
  { equalizer gains -100..100    }
     XINE_PARAM_EQ_16000HZ = 27;     
  { force closing audio device   }
     XINE_PARAM_AUDIO_CLOSE_DEVICE = 28;     
  { 1=>mute, 0=>unmute  }
     XINE_PARAM_AUDIO_AMP_MUTE = 29;     
  { 1.000.000 => normal speed    }     XINE_PARAM_FINE_SPEED = 30;     
  { send event when demux finish }
     XINE_PARAM_EARLY_FINISHED_EVENT = 31;     
  { next stream only gapless swi }
     XINE_PARAM_GAPLESS_SWITCH = 32;     
  { 1/10sec,0=>disable,-1=>forev }
     XINE_PARAM_DELAY_FINISHED_EVENT = 33;     
  {
   * speed values for XINE_PARAM_SPEED parameter.
   *
   * alternatively, one may use XINE_PARAM_FINE_SPEED for greater
   * control of the speed value, where:
   * XINE_PARAM_SPEED / 4 <-> XINE_PARAM_FINE_SPEED / 1000000
    }
     XINE_SPEED_PAUSE = 0;     
     XINE_SPEED_SLOW_4 = 1;     
     XINE_SPEED_SLOW_2 = 2;     
     XINE_SPEED_NORMAL = 4;     
     XINE_SPEED_FAST_2 = 8;     
     XINE_SPEED_FAST_4 = 16;     
  { normal speed value for XINE_PARAM_FINE_SPEED parameter  }
     XINE_FINE_SPEED_NORMAL = 1000000;     
  { video parameters  }
  { bool                }
     XINE_PARAM_VO_DEINTERLACE = $01000000;     
  { see below           }
     XINE_PARAM_VO_ASPECT_RATIO = $01000001;     
  { 0..65535            }
     XINE_PARAM_VO_HUE = $01000002;     
  { 0..65535            }
     XINE_PARAM_VO_SATURATION = $01000003;     
  { 0..65535            }
     XINE_PARAM_VO_CONTRAST = $01000004;     
  { 0..65535            }
     XINE_PARAM_VO_BRIGHTNESS = $01000005;     
  { percent             }
     XINE_PARAM_VO_ZOOM_X = $01000008;     
  { percent             }
     XINE_PARAM_VO_ZOOM_Y = $0100000d;     
  { bool                }
     XINE_PARAM_VO_PAN_SCAN = $01000009;     
  { ???                 }
     XINE_PARAM_VO_TVMODE = $0100000a;     
  { readonly            }
     XINE_PARAM_VO_WINDOW_WIDTH = $0100000f;     
  { readonly            }
     XINE_PARAM_VO_WINDOW_HEIGHT = $01000010;     
  { crop frame pixels   }
     XINE_PARAM_VO_CROP_LEFT = $01000020;     
  { crop frame pixels   }
     XINE_PARAM_VO_CROP_RIGHT = $01000021;     
  { crop frame pixels   }
     XINE_PARAM_VO_CROP_TOP = $01000022;     
  { crop frame pixels   }
     XINE_PARAM_VO_CROP_BOTTOM = $01000023;     
     XINE_VO_ZOOM_STEP = 100;     
     XINE_VO_ZOOM_MAX = 400;     
     XINE_VO_ZOOM_MIN = -(85);     
  { possible ratios for XINE_PARAM_VO_ASPECT_RATIO  }
     XINE_VO_ASPECT_AUTO = 0;     
  { 1:1     }
     XINE_VO_ASPECT_SQUARE = 1;     
  { 4:3     }
     XINE_VO_ASPECT_4_3 = 2;     
  { 16:9    }
     XINE_VO_ASPECT_ANAMORPHIC = 3;     
  { 2.11:1  }
     XINE_VO_ASPECT_DVB = 4;     
     XINE_VO_ASPECT_NUM_RATIOS = 5;     
     XINE_VO_ASPECT_PAN_SCAN = 41;     
     XINE_VO_ASPECT_DONT_TOUCH = 42;     
  { stream format detection strategies  }
  { recognize stream type first by content then by extension.  }
     XINE_DEMUX_DEFAULT_STRATEGY = 0;     
  { recognize stream type first by extension then by content.  }
     XINE_DEMUX_REVERT_STRATEGY = 1;     
  { recognize stream type by content only.                     }
     XINE_DEMUX_CONTENT_STRATEGY = 2;     
  { recognize stream type by extension only.                   }
     XINE_DEMUX_EXTENSION_STRATEGY = 3;     
  { verbosity settings  }
     XINE_VERBOSITY_NONE = 0;     
     XINE_VERBOSITY_LOG = 1;     
     XINE_VERBOSITY_DEBUG = 2;     
  {
   * snapshot function
   *
   * image format can be YUV 4:2:0 or 4:2:2
   * will copy the image data into memory that <img> points to
   * (interleaved for yuv 4:2:2 or planary for 4:2:0)
   *
   * returns 1 on success, 0 failure.
    }
(* error 
			     uint8_t *img) XINE_PROTECTED;
 in declarator_list *)

    var
 : longint;
  { xine image formats  }

  const
     XINE_IMGFMT_YV12 = ((('2' shl 24) or ('1' shl 16)) or ('V' shl 8)) or 'Y';     
     XINE_IMGFMT_YUY2 = ((('2' shl 24) or ('Y' shl 16)) or ('U' shl 8)) or 'Y';     
     XINE_IMGFMT_XVMC = ((('C' shl 24) or ('M' shl 16)) or ('v' shl 8)) or 'X';     
     XINE_IMGFMT_XXMC = ((('C' shl 24) or ('M' shl 16)) or ('x' shl 8)) or 'X';     
  { get current xine's virtual presentation timestamp (1/90000 sec)
   * note: this is mostly internal data.
   * one can use vpts with xine_osd_show() and xine_osd_hide().
    }
(* error 
int64_t xine_get_current_vpts(xine_stream_t *stream) XINE_PROTECTED;
 in declarator_list *)

    var
 : int64_t;
  {********************************************************************
   * media processing                                                  *
   ******************************************************************** }
  {********************************************************************
   * post plugin handling                                              *
   ******************************************************************** }
  {
   * post effect plugin functions
   *
   * after the data leaves the decoder it can pass an arbitrary tree
   * of post plugins allowing for effects to be applied to the video
   * frames/audio buffers before they reach the output stage
    }

  type
     xine_post_s = xine_post_t;
  { a NULL-terminated array of audio input ports this post plugin
     * provides; you can hand these to other post plugin's outputs or
     * pass them to the initialization of streams
      }
  { a NULL-terminated array of video input ports this post plugin
     * provides; you can hand these to other post plugin's outputs or
     * pass them to the initialization of streams
      }
  { the type of the post plugin
     * one of XINE_POST_TYPE_* can be used here
      }
     xine_post_s = record
          audio_input : ^^xine_audio_port_t;
          video_input : ^^xine_video_port_t;
          _type : longint;
       end;

  {
   * initialize a post plugin
   *
   * returns xine_post_t* on success, NULL on failure
   *
   * Initializes the post plugin with the given name and connects its
   * outputs to the NULL-terminated arrays of audio and video ports.
   * Some plugins also care about the number of inputs you request
   * (e.g. mixer plugins), others simply ignore this number.
    }
(* Const before type ignored *)
(* error 
			    xine_video_port_t **video_target) XINE_PROTECTED;
 in declarator_list *)

    var
 : xine_post_t;
  { get a list of all available post plugins  }
(* Const before type ignored *)
(* error 
const char *const *xine_list_post_plugins(xine_t *xine) XINE_PROTECTED;
 in declarator_list *)
 : char;
  { get a list of all post plugins of one type  }
(* Const before type ignored *)
(* error 
const char *const *xine_list_post_plugins_typed(xine_t *xine, int type) XINE_PROTECTED;
 in declarator_list *)
 : char;
  {
   * post plugin input/output
   *
   * These structures encapsulate inputs/outputs for post plugins
   * to transfer arbitrary data. Frontends can also provide inputs
   * and outputs and connect them to post plugins to exchange data
   * with them.
    }

  type
     xine_post_in_s = xine_post_in_t;
     xine_post_out_s = xine_post_out_t;
  { the name identifying this input  }
(* Const before type ignored *)
  { the datatype of this input, use one of XINE_POST_DATA_* here  }
  { the data pointer; input is directed to this memory location,
     * so you simply access the pointer to access the input data  }
     xine_post_in_s = record
          name : ^char;
          _type : longint;
          data : pointer;
       end;

  { the name identifying this output  }
(* Const before type ignored *)
  { the datatype of this output, use one of XINE_POST_DATA_* here  }
  { the data pointer; output should be directed to this memory location,
     * so in the easy case you simply write through the pointer  }
  { this function is called, when the output should be redirected
     * to another input, you sould set the data pointer to direct
     * any output to this new input;
     * a special situation is, when this function is called with a NULL
     * argument: in this case you should disconnect the data pointer
     * from any output and if necessary to avoid writing to some stray
     * memory you should make it point to some dummy location,
     * returns 1 on success, 0 on failure;
     * if you do not implement rewiring, set this to NULL  }
     xine_post_out_s = record
          name : ^char;
          _type : longint;
          data : pointer;
          rewire : function (self:pxine_post_out_t; data:pointer):longint;cdecl;
       end;

  { get a list of all inputs of a post plugin  }
(* Const before type ignored *)
(* error 
const char *const *xine_post_list_inputs(xine_post_t *self) XINE_PROTECTED;
 in declarator_list *)

    var
 : char;
  { get a list of all outputs of a post plugin  }
(* Const before type ignored *)
(* error 
const char *const *xine_post_list_outputs(xine_post_t *self) XINE_PROTECTED;
 in declarator_list *)
 : char;
  { retrieve one specific input of a post plugin  }
(* Const before type ignored *)
(* error 
xine_post_in_t *xine_post_input(xine_post_t *self, const char *name) XINE_PROTECTED;
 in declarator_list *)
 : xine_post_in_t;
  { retrieve one specific output of a post plugin  }
(* Const before type ignored *)
(* error 
xine_post_out_t *xine_post_output(xine_post_t *self, const char *name) XINE_PROTECTED;
 in declarator_list *)
 : xine_post_out_t;
  {
   * wire an input to an output
   * returns 1 on success, 0 on failure
    }
(* error 
int xine_post_wire(xine_post_out_t *source, xine_post_in_t *target) XINE_PROTECTED;
 in declarator_list *)
 : longint;
  {
   * wire a video port to a video output
   * This can be used to rewire different post plugins to the video output
   * plugin layer. The ports you hand in at xine_post_init() will already
   * be wired with the post plugin, so you need this function for
   * _re_connecting only.
   *
   * returns 1 on success, 0 on failure
    }
(* error 
int xine_post_wire_video_port(xine_post_out_t *source, xine_video_port_t *vo) XINE_PROTECTED;
 in declarator_list *)
 : longint;
  {
   * wire an audio port to an audio output
   * This can be used to rewire different post plugins to the audio output
   * plugin layer. The ports you hand in at xine_post_init() will already
   * be wired with the post plugin, so you need this function for
   * _re_connecting only.
   *
   * returns 1 on success, 0 on failure
    }
(* error 
int xine_post_wire_audio_port(xine_post_out_t *source, xine_audio_port_t *ao) XINE_PROTECTED;
 in declarator_list *)
 : longint;
  {
   * Extracts an output for a stream. Use this to rewire the outputs of streams.
    }
(* error 
xine_post_out_t * xine_get_video_source(xine_stream_t *stream) XINE_PROTECTED;
 in declarator_list *)
 : xine_post_out_t;
(* error 
xine_post_out_t * xine_get_audio_source(xine_stream_t *stream) XINE_PROTECTED;
 in declarator_list *)
 : xine_post_out_t;
  {
   * disposes the post plugin
   * please make sure that no other post plugin and no stream is
   * connected to any of this plugin's inputs
    }
(* error 
void xine_post_dispose(xine_t *xine, xine_post_t *self) XINE_PROTECTED;
 in declarator_list *)
 : pointer;
  { post plugin types  }

  const
     XINE_POST_TYPE_VIDEO_FILTER = $010000;     
     XINE_POST_TYPE_VIDEO_VISUALIZATION = $010001;     
     XINE_POST_TYPE_VIDEO_COMPOSE = $010002;     
     XINE_POST_TYPE_AUDIO_FILTER = $020000;     
     XINE_POST_TYPE_AUDIO_VISUALIZATION = $020001;     
  { post plugin data types  }
  { video port data
   * input->data is a xine_video_port_t*
   * output->data usually is a xine_video_port_t**
    }
     XINE_POST_DATA_VIDEO = 0;     
  { audio port data
   * input->data is a xine_audio_port_t*
   * output->data usually is a xine_audio_port_t**
    }
     XINE_POST_DATA_AUDIO = 1;     
  { integer data
   * input->data is a int*
   * output->data usually is a int*
    }
     XINE_POST_DATA_INT = 3;     
  { double precision floating point data
   * input->data is a double*
   * output->data usually is a double*
    }
     XINE_POST_DATA_DOUBLE = 4;     
  { parameters api (used by frontends)
   * input->data is xine_post_api_t*  (see below)
    }
     XINE_POST_DATA_PARAMETERS = 5;     
  { defines a single parameter entry.  }
  { POST_PARAM_TYPE_xxx              }
  { name of this parameter           }
  { sizeof(parameter)                }
  { offset in bytes from struct ptr  }
  { enumeration (first=0) or NULL    }
  { minimum value                    }
  { maximum value                    }
  { 0 = read/write, 1=read-only      }
  { user-friendly description        }

  type

     xine_post_api_parameter_t = record
          _type : longint;
          name : ^char;
          size : longint;
          offset : longint;
          enum_values : ^^char;
          range_min : double;
          range_max : double;
          readonly : longint;
          description : ^char;
       end;
  { description of parameters struct (params).  }
  { sizeof(params)      }
  { list of parameters  }

     xine_post_api_descr_t = record
          struct_size : longint;
          parameter : ^xine_post_api_parameter_t;
       end;
  {
     * method to set all the read/write parameters.
     * params is a struct * defined by xine_post_api_descr_t
      }
  {
     * method to get all parameters.
      }
  {
     * method to get params struct definition
      }
  {
     * method to get plugin and parameters help (UTF-8)
     * the help string must be word wrapped by the frontend.
     * it might contain \n to mark paragraph breaks.
      }

     xine_post_api_t = record
          set_parameters : function (self:pxine_post_t; params:pointer):longint;cdecl;
          get_parameters : function (self:pxine_post_t; params:pointer):longint;
          get_param_descr : function :^xine_post_api_descr_t;
          get_help : function :^char;
       end;
  { post parameter types  }
  { terminator of parameter list        }

  const
     POST_PARAM_TYPE_LAST = 0;     
  { integer (or vector of integers)     }
     POST_PARAM_TYPE_INT = 1;     
  { double (or vector of doubles)       }
     POST_PARAM_TYPE_DOUBLE = 2;     
  { char (or vector of chars = string)  }
     POST_PARAM_TYPE_CHAR = 3;     
  { (char *), ASCIIZ                    }
     POST_PARAM_TYPE_STRING = 4;     
  { (char **) list, NULL terminated     }
     POST_PARAM_TYPE_STRINGLIST = 5;     
  { integer (0 or 1)                    }
     POST_PARAM_TYPE_BOOL = 6;     
  {********************************************************************
   * information retrieval                                             *
   ******************************************************************** }
  {
   * xine log functions
   *
   * frontends can display xine log output using these functions
    }
(* error 
int    xine_get_log_section_count(xine_t *self) XINE_PROTECTED;
 in declarator_list *)

    var
 : longint;
  { return a NULL terminated array of log sections names  }
(* Const before type ignored *)
(* error 
const char *const *xine_get_log_names(xine_t *self) XINE_PROTECTED;
 in declarator_list *)
 : char;
  { print some log information to <buf> section  }
(* Const before type ignored *)
(* error 
		 const char *format, ...) XINE_PROTECTED;
 in declarator_list *)
 : pointer;
(* Const before type ignored *)
(* error 
		  const char *format, va_list args) XINE_PROTECTED;
 in declarator_list *)
 : pointer;
  { get log messages of specified section  }
(* Const before type ignored *)
(* error 
const char *const *xine_get_log (xine_t *self, int buf) XINE_PROTECTED;
 in declarator_list *)
 : char;
  { log callback will be called whenever something is logged  }

  type

     xine_log_cb_t = procedure (user_data:pointer; section:longint);cdecl;
(* error 
			     void *user_data) XINE_PROTECTED;
 in declarator_list *)

    var
 : pointer;
  {
   * error handling / engine status
    }
  { return last error   }
(* error 
int  xine_get_error (xine_stream_t *stream) XINE_PROTECTED;
 in declarator_list *)
 : longint;
  { get current xine engine status (constants see below)  }
(* error 
int  xine_get_status (xine_stream_t *stream) XINE_PROTECTED;
 in declarator_list *)
 : longint;
  {
   * engine status codes
    }
  { no mrl assigned  }

  const
     XINE_STATUS_IDLE = 0;     
     XINE_STATUS_STOP = 1;     
     XINE_STATUS_PLAY = 2;     
     XINE_STATUS_QUIT = 3;     
  {
   * xine error codes
    }
     XINE_ERROR_NONE = 0;     
     XINE_ERROR_NO_INPUT_PLUGIN = 1;     
     XINE_ERROR_NO_DEMUX_PLUGIN = 2;     
     XINE_ERROR_DEMUX_FAILED = 3;     
     XINE_ERROR_MALFORMED_MRL = 4;     
     XINE_ERROR_INPUT_FAILED = 5;     
  {
   * try to find out audio/spu language of given channel
   * (use -1 for current channel)
   *
   * returns 1 on success, 0 on failure
    }
(* error 
			 char *lang) XINE_PROTECTED;
 in declarator_list *)

    var
 : longint;
(* error 
			 char *lang) XINE_PROTECTED;
 in declarator_list *)
 : longint;

  const
     XINE_LANG_MAX = 32;     
  {
   * get position / length information
   *
   * depending of the nature and system layer of the stream,
   * some or all of this information may be unavailable or incorrect
   * (e.g. live network streams may not have a valid length)
   *
   * returns 1 on success, 0 on failure (data was not updated,
   * probably because it's not known yet... try again later)
    }
  { 0..65535      }
  { milliseconds  }
  { milliseconds  }
(* error 
  XINE_PROTECTED;
 in declarator_list *)

    var
 : longint;
  {
   * get information about the stream such as
   * video width/height, codecs, audio format, title, author...
   * strings are UTF-8 encoded.
   *
   * constants see below
    }
(* error 
uint32_t    xine_get_stream_info (xine_stream_t *stream, int info) XINE_PROTECTED;
 in declarator_list *)
 : uint32_t;
(* Const before type ignored *)
(* error 
const char *xine_get_meta_info   (xine_stream_t *stream, int info) XINE_PROTECTED;
 in declarator_list *)
 : char;
  { xine_get_stream_info  }

  const
     XINE_STREAM_INFO_BITRATE = 0;     
     XINE_STREAM_INFO_SEEKABLE = 1;     
     XINE_STREAM_INFO_VIDEO_WIDTH = 2;     
     XINE_STREAM_INFO_VIDEO_HEIGHT = 3;     
  { *10000  }
     XINE_STREAM_INFO_VIDEO_RATIO = 4;     
     XINE_STREAM_INFO_VIDEO_CHANNELS = 5;     
     XINE_STREAM_INFO_VIDEO_STREAMS = 6;     
     XINE_STREAM_INFO_VIDEO_BITRATE = 7;     
     XINE_STREAM_INFO_VIDEO_FOURCC = 8;     
  { codec available?  }
     XINE_STREAM_INFO_VIDEO_HANDLED = 9;     
  { 1/90000 sec  }
     XINE_STREAM_INFO_FRAME_DURATION = 10;     
     XINE_STREAM_INFO_AUDIO_CHANNELS = 11;     
     XINE_STREAM_INFO_AUDIO_BITS = 12;     
     XINE_STREAM_INFO_AUDIO_SAMPLERATE = 13;     
     XINE_STREAM_INFO_AUDIO_BITRATE = 14;     
     XINE_STREAM_INFO_AUDIO_FOURCC = 15;     
  { codec available?  }
     XINE_STREAM_INFO_AUDIO_HANDLED = 16;     
     XINE_STREAM_INFO_HAS_CHAPTERS = 17;     
     XINE_STREAM_INFO_HAS_VIDEO = 18;     
     XINE_STREAM_INFO_HAS_AUDIO = 19;     
     XINE_STREAM_INFO_IGNORE_VIDEO = 20;     
     XINE_STREAM_INFO_IGNORE_AUDIO = 21;     
     XINE_STREAM_INFO_IGNORE_SPU = 22;     
     XINE_STREAM_INFO_VIDEO_HAS_STILL = 23;     
     XINE_STREAM_INFO_MAX_AUDIO_CHANNEL = 24;     
     XINE_STREAM_INFO_MAX_SPU_CHANNEL = 25;     
     XINE_STREAM_INFO_AUDIO_MODE = 26;     
  { for 1000 frames delivered  }
     XINE_STREAM_INFO_SKIPPED_FRAMES = 27;     
  { for 1000 frames delivered  }
     XINE_STREAM_INFO_DISCARDED_FRAMES = 28;     
     XINE_STREAM_INFO_VIDEO_AFD = 29;     
     XINE_STREAM_INFO_DVD_TITLE_NUMBER = 30;     
     XINE_STREAM_INFO_DVD_TITLE_COUNT = 31;     
     XINE_STREAM_INFO_DVD_CHAPTER_NUMBER = 32;     
     XINE_STREAM_INFO_DVD_CHAPTER_COUNT = 33;     
     XINE_STREAM_INFO_DVD_ANGLE_NUMBER = 34;     
     XINE_STREAM_INFO_DVD_ANGLE_COUNT = 35;     
  { possible values for XINE_STREAM_INFO_VIDEO_AFD  }
     XINE_VIDEO_AFD_NOT_PRESENT = -(1);     
     XINE_VIDEO_AFD_RESERVED_0 = 0;     
     XINE_VIDEO_AFD_RESERVED_1 = 1;     
     XINE_VIDEO_AFD_BOX_16_9_TOP = 2;     
     XINE_VIDEO_AFD_BOX_14_9_TOP = 3;     
     XINE_VIDEO_AFD_BOX_GT_16_9_CENTRE = 4;     
     XINE_VIDEO_AFD_RESERVED_5 = 5;     
     XINE_VIDEO_AFD_RESERVED_6 = 6;     
     XINE_VIDEO_AFD_RESERVED_7 = 7;     
     XINE_VIDEO_AFD_SAME_AS_FRAME = 8;     
     XINE_VIDEO_AFD_4_3_CENTRE = 9;     
     XINE_VIDEO_AFD_16_9_CENTRE = 10;     
     XINE_VIDEO_AFD_14_9_CENTRE = 11;     
     XINE_VIDEO_AFD_RESERVED_12 = 12;     
     XINE_VIDEO_AFD_4_3_PROTECT_14_9 = 13;     
     XINE_VIDEO_AFD_16_9_PROTECT_14_9 = 14;     
     XINE_VIDEO_AFD_16_9_PROTECT_4_3 = 15;     
  { xine_get_meta_info  }
     XINE_META_INFO_TITLE = 0;     
     XINE_META_INFO_COMMENT = 1;     
     XINE_META_INFO_ARTIST = 2;     
     XINE_META_INFO_GENRE = 3;     
     XINE_META_INFO_ALBUM = 4;     
     XINE_META_INFO_YEAR = 5;     
     XINE_META_INFO_VIDEOCODEC = 6;     
     XINE_META_INFO_AUDIOCODEC = 7;     
     XINE_META_INFO_SYSTEMLAYER = 8;     
     XINE_META_INFO_INPUT_PLUGIN = 9;     
     XINE_META_INFO_CDINDEX_DISCID = 10;     
     XINE_META_INFO_TRACK_NUMBER = 11;     
  {********************************************************************
   * plugin management / autoplay / mrl browsing                       *
   ******************************************************************** }
  {
   * note: the pointers to strings or string arrays returned
   *       by some of these functions are pointers to statically
   *       alloced internal xine memory chunks.
   *       they're only valid between xine function calls
   *       and should never be free()d.
    }
  { file plugin: path  }
  { <type>://<location>  }
  { see below  }
  { size of this source, may be 0  }

  type

     xine_mrl_t = record
          origin : ^char;
          mrl : ^char;
          link : ^char;
          _type : uint32_t;
          size : off_t;
       end;
  { mrl types  }

  const
     XINE_MRL_TYPE_unknown = 0 shl 0;     
     XINE_MRL_TYPE_dvd = 1 shl 0;     
     XINE_MRL_TYPE_vcd = 1 shl 1;     
     XINE_MRL_TYPE_net = 1 shl 2;     
     XINE_MRL_TYPE_rtp = 1 shl 3;     
     XINE_MRL_TYPE_stdin = 1 shl 4;     
     XINE_MRL_TYPE_cda = 1 shl 5;     
     XINE_MRL_TYPE_file = 1 shl 6;     
     XINE_MRL_TYPE_file_fifo = 1 shl 7;     
     XINE_MRL_TYPE_file_chardev = 1 shl 8;     
     XINE_MRL_TYPE_file_directory = 1 shl 9;     
     XINE_MRL_TYPE_file_blockdev = 1 shl 10;     
     XINE_MRL_TYPE_file_normal = 1 shl 11;     
     XINE_MRL_TYPE_file_symlink = 1 shl 12;     
     XINE_MRL_TYPE_file_sock = 1 shl 13;     
     XINE_MRL_TYPE_file_exec = 1 shl 14;     
     XINE_MRL_TYPE_file_backup = 1 shl 15;     
     XINE_MRL_TYPE_file_hidden = 1 shl 16;     
  { get a list of browsable input plugin ids  }
(* Const before type ignored *)
(* error 
const char *const *xine_get_browsable_input_plugin_ids (xine_t *self)  XINE_PROTECTED;
 in declarator_list *)

    var
 : char;
  {
   * ask input plugin named <plugin_id> to return
   * a list of available MRLs in domain/directory <start_mrl>.
   *
   * <start_mrl> may be NULL indicating the toplevel domain/dir
   * returns <start_mrl> if <start_mrl> is a valid MRL, not a directory
   * returns NULL if <start_mrl> is an invalid MRL, not even a directory.
    }
(* Const before type ignored *)
(* Const before type ignored *)
(* error 
				   int *num_mrls) XINE_PROTECTED;
 in declarator_list *)
 : xine_mrl_t;
  { get a list of plugins that support the autoplay feature  }
(* Const before type ignored *)
(* error 
const char *const *xine_get_autoplay_input_plugin_ids (xine_t *self) XINE_PROTECTED;
 in declarator_list *)
 : char;
  { get autoplay MRL list from input plugin named <plugin_id>  }
(* Const before type ignored *)
(* error 
			       int *num_mrls) XINE_PROTECTED;
 in declarator_list *)
 : char;
  { get a list of file extensions for file types supported by xine
   * the list is separated by spaces
   *
   * the pointer returned can be free()ed when no longer used  }
(* error 
char *xine_get_file_extensions (xine_t *self) XINE_PROTECTED;
 in declarator_list *)
 : char;
  { get a list of mime types supported by xine
   *
   * the pointer returned can be free()ed when no longer used  }
(* error 
char *xine_get_mime_types (xine_t *self) XINE_PROTECTED;
 in declarator_list *)
 : char;
  { get the demuxer identifier that handles a given mime type
   *
   * the pointer returned can be free()ed when no longer used
   * returns NULL if no demuxer is available to handle this.  }
(* Const before type ignored *)
(* error 
char *xine_get_demux_for_mime_type (xine_t *self, const char *mime_type) XINE_PROTECTED;
 in declarator_list *)
 : char;
  { get a description string for a plugin  }
(* Const before type ignored *)
(* Const before type ignored *)
(* error 
					       const char *plugin_id) XINE_PROTECTED;
 in declarator_list *)
 : char;
(* Const before type ignored *)
(* Const before type ignored *)
(* error 
					       const char *plugin_id) XINE_PROTECTED;
 in declarator_list *)
 : char;
(* Const before type ignored *)
(* Const before type ignored *)
(* error 
					       const char *plugin_id) XINE_PROTECTED;
 in declarator_list *)
 : char;
(* Const before type ignored *)
(* Const before type ignored *)
(* error 
					       const char *plugin_id) XINE_PROTECTED;
 in declarator_list *)
 : char;
(* Const before type ignored *)
(* Const before type ignored *)
(* error 
					       const char *plugin_id) XINE_PROTECTED;
 in declarator_list *)
 : char;
(* Const before type ignored *)
(* Const before type ignored *)
(* error 
					       const char *plugin_id) XINE_PROTECTED;
 in declarator_list *)
 : char;
(* Const before type ignored *)
(* Const before type ignored *)
(* error 
					       const char *plugin_id) XINE_PROTECTED;
 in declarator_list *)
 : char;
(* Const before type ignored *)
(* Const before type ignored *)
(* error 
					       const char *plugin_id) XINE_PROTECTED;
 in declarator_list *)
 : char;
  { get lists of available audio and video output plugins  }
(* Const before type ignored *)
(* error 
const char *const *xine_list_audio_output_plugins (xine_t *self) XINE_PROTECTED;
 in declarator_list *)
 : char;
(* Const before type ignored *)
(* error 
const char *const *xine_list_video_output_plugins (xine_t *self) XINE_PROTECTED;
 in declarator_list *)
 : char;
  { get list of available demultiplexor plugins  }
(* Const before type ignored *)
(* error 
const char *const *xine_list_demuxer_plugins(xine_t *self) XINE_PROTECTED;
 in declarator_list *)
 : char;
  { get list of available input plugins  }
(* Const before type ignored *)
(* error 
const char *const *xine_list_input_plugins(xine_t *self) XINE_PROTECTED;
 in declarator_list *)
 : char;
  { get list of available subpicture plugins  }
(* Const before type ignored *)
(* error 
const char *const *xine_list_spu_plugins(xine_t *self) XINE_PROTECTED;
 in declarator_list *)
 : char;
  { get list of available audio and video decoder plugins  }
(* Const before type ignored *)
(* error 
const char *const *xine_list_audio_decoder_plugins(xine_t *self) XINE_PROTECTED;
 in declarator_list *)
 : char;
(* Const before type ignored *)
(* error 
const char *const *xine_list_video_decoder_plugins(xine_t *self) XINE_PROTECTED;
 in declarator_list *)
 : char;
  { unload unused plugins  }
(* error 
void xine_plugins_garbage_collector(xine_t *self) XINE_PROTECTED;
 in declarator_list *)
 : pointer;
  {********************************************************************
   * visual specific gui <-> xine engine communication                 *
   ******************************************************************** }
  { talk to video output driver - old method  }
(* error 
			      int type, void *data) XINE_PROTECTED;
 in declarator_list *)
 : longint;
  { new (preferred) method to talk to video driver.  }
(* error 
			        int type, void *data) XINE_PROTECTED;
 in declarator_list *)
 : longint;
  { area of that drawable to be used by video  }

  type

     x11_rectangle_t = record
          x : longint;
          y : longint;
          w : longint;
          h : longint;
       end;
  {
   * this is the visual data struct any x11 gui
   * must supply to the xine_open_video_driver call
   * ("data" parameter)
    }
  { some information about the display  }
  { Display*  }
  { drawable to display the video in/on  }
  { Drawable  }
  {
     * dest size callback
     *
     * this will be called by the video driver to find out
     * how big the video output area size will be for a
     * given video size. The ui should _not_ adjust it's
     * video out area, just do some calculations and return
     * the size. This will be called for every frame, ui
     * implementation should be fast.
     * dest_pixel_aspect should be set to the used display pixel aspect.
     * NOTE: Semantics has changed: video_width and video_height
     * are no longer pixel aspect corrected. Get the old semantics
     * in the UI with
     *   *dest_pixel_aspect = display_pixel_aspect;
     *   if (video_pixel_aspect >= display_pixel_aspect)
     *     video_width  = video_width * video_pixel_aspect / display_pixel_aspect + .5;
     *   else
     *     video_height = video_height * display_pixel_aspect / video_pixel_aspect + .5;
      }
  {
     * frame output callback
     *
     * this will be called by the video driver for every frame
     * it's about to draw. ui can adapt it's size if necessary
     * here.
     * note: the ui doesn't have to adjust itself to this
     * size, this is just to be taken as a hint.
     * ui must return the actual size of the video output
     * area and the video output driver will do it's best
     * to adjust the video frames to that size (while
     * preserving aspect ratio and stuff).
     *    dest_x, dest_y: offset inside window
     *    dest_width, dest_height: available drawing space
     *    dest_pixel_aspect: display pixel aspect
     *    win_x, win_y: window absolute screen position
     * NOTE: Semantics has changed: video_width and video_height
     * are no longer pixel aspect corrected. Get the old semantics
     * in the UI with
     *   *dest_pixel_aspect = display_pixel_aspect;
     *   if (video_pixel_aspect >= display_pixel_aspect)
     *     video_width  = video_width * video_pixel_aspect / display_pixel_aspect + .5;
     *   else
     *     video_height = video_height * display_pixel_aspect / video_pixel_aspect + .5;
      }
  {
     * lock display callback
     *
     * this callback is called when the video driver
     * needs access to the x11 display connection
     *
     * note: to enable this you MUST use XINE_VISUAL_TYPE_X11_2
     * note: if display_lock is NULL, the fallback is used
     * note: fallback for this function is XLockDisplay(display)
      }
  {
     * unlock display callback
     *
     * this callback is called when the video driver
     * doesn't need access to the x11 display connection anymore
     *
     * note: to enable this you MUST use XINE_VISUAL_TYPE_X11_2
     * note: if display_unlock is NULL, the fallback is used
     * note: fallback for this function is XUnlockDisplay(display)
      }

     x11_visual_t = record
          display : pointer;
          screen : longint;
          d : dword;
          user_data : pointer;
          dest_size_cb : procedure (user_data:pointer; video_width:longint; video_height:longint; video_pixel_aspect:double; dest_width:plongint; 
                        dest_height:plongint; dest_pixel_aspect:pdouble);cdecl;
          frame_output_cb : procedure (user_data:pointer; video_width:longint; video_height:longint; video_pixel_aspect:double; dest_x:plongint; 
                        dest_y:plongint; dest_width:plongint; dest_height:plongint; dest_pixel_aspect:pdouble; win_x:plongint; 
                        win_y:plongint);
          lock_display : procedure (user_data:pointer);
          unlock_display : procedure (user_data:pointer);
       end;
  {
   * this is the visual data struct any fb gui
   * may supply to the xine_open_video_driver call
   * ("data" parameter) to get frame_output_cd calls
    }

     fb_visual_t = record
          frame_output_cb : procedure (user_data:pointer; video_width:longint; video_height:longint; video_pixel_aspect:double; dest_x:plongint; 
                        dest_y:plongint; dest_width:plongint; dest_height:plongint; dest_pixel_aspect:pdouble; win_x:plongint; 
                        win_y:plongint);cdecl;
          user_data : pointer;
       end;
  {
   * "type" constants for xine_port_send_gui_data(...)
    }
  { xevent *data  }
  { DEPRECATED  }

  const
     XINE_GUI_SEND_COMPLETION_EVENT = 1;     
  { Drawable data  }
     XINE_GUI_SEND_DRAWABLE_CHANGED = 2;     
  { xevent *data  }
     XINE_GUI_SEND_EXPOSE_EVENT = 3;     
  { x11_rectangle_t *data  }
     XINE_GUI_SEND_TRANSLATE_GUI_TO_VIDEO = 4;     
  { int data  }
     XINE_GUI_SEND_VIDEOWIN_VISIBLE = 5;     
  { *data contains chosen visual, select a new one or change it to NULL
   * to indicate the visual to use or that no visual will work  }
  { XVisualInfo **data  }
     XINE_GUI_SEND_SELECT_VISUAL = 8;     
  { Gui is about to destroy drawable  }
     XINE_GUI_SEND_WILL_DESTROY_DRAWABLE = 9;     
  {********************************************************************
   * xine health check stuff                                           *
   ******************************************************************** }
     XINE_HEALTH_CHECK_OK = 0;     
     XINE_HEALTH_CHECK_FAIL = 1;     
     XINE_HEALTH_CHECK_UNSUPPORTED = 2;     
     XINE_HEALTH_CHECK_NO_SUCH_CHECK = 3;     
     CHECK_KERNEL = 0;     
     CHECK_MTRR = 1;     
     CHECK_CDROM = 2;     
     CHECK_DVDROM = 3;     
     CHECK_DMA = 4;     
     CHECK_X = 5;     
     CHECK_XV = 6;     
(* Const before type ignored *)
(* Const before type ignored *)

  type
     xine_health_check_s = record
          status : longint;
          cdrom_dev : ^char;
          dvd_dev : ^char;
          msg : ^char;
          title : ^char;
          explanation : ^char;
       end;

     xine_health_check_s = xine_health_check_t;
(* error 
xine_health_check_t* xine_health_check(xine_health_check_t*, int check_num) XINE_PROTECTED;
 in declarator_list *)

    var
 : xine_health_check_t;
  {********************************************************************
   * configuration system                                              *
   ******************************************************************** }
  {
   * config entry data types
    }

  const
     XINE_CONFIG_TYPE_UNKNOWN = 0;     
     XINE_CONFIG_TYPE_RANGE = 1;     
     XINE_CONFIG_TYPE_STRING = 2;     
     XINE_CONFIG_TYPE_ENUM = 3;     
     XINE_CONFIG_TYPE_NUM = 4;     
     XINE_CONFIG_TYPE_BOOL = 5;     
  { For the string type (1.1.4 and later). These are stored in num_value.  }     XINE_CONFIG_STRING_IS_STRING = 0;     
     XINE_CONFIG_STRING_IS_FILENAME = 1;     
     XINE_CONFIG_STRING_IS_DEVICE_NAME = 2;     
     XINE_CONFIG_STRING_IS_DIRECTORY_NAME = 3;     

  type
     xine_cfg_entry_s = xine_cfg_entry_t;

     xine_config_cb_t = procedure (user_data:pointer; entry:pxine_cfg_entry_t);cdecl;
(* Const before type ignored *)
  { unique id (example: gui.logo_mrl)  }
  { type unknown  }
  { type string  }
  { common to range, enum, num, bool;
     * num_value is also used by string to indicate what's required:
     * plain string, file name, device name, directory name
      }
  { type range specific:  }
  { type enum specific:  }
  { help info for the user (UTF-8)
     * the help string must be word wrapped by the frontend.
     * it might contain \n to mark paragraph breaks.
      }
(* Const before type ignored *)
(* Const before type ignored *)
  { user experience level  }
  { 0 => beginner,
  			        10 => advanced user,
  			        20 => expert  }
  { callback function and data for live changeable values  }
  { some config entries will take effect immediately, although they
     * do not have a callback registered; such values will have some
     * non-NULL dummy value in callback_data; so if you want to check,
     * if a config change will require restarting xine, check for
     * callback_data == NULL  }
     xine_cfg_entry_s = record
          key : ^char;cdecl;
          _type : longint;
          unknown_value : ^char;
          str_value : ^char;
          str_default : ^char;
          str_sticky : ^char;
          num_value : longint;
          num_default : longint;
          range_min : longint;
          range_max : longint;
          enum_values : ^^char;
          description : ^char;
          help : ^char;
          exp_level : longint;
          callback : xine_config_cb_t;
          callback_data : pointer;
       end;

(* Const before type ignored *)
(* Const before type ignored *)
(* Const before type ignored *)
(* Const before type ignored *)
(* Const before type ignored *)
(* error 
					 void *cb_data) XINE_PROTECTED;
 in declarator_list *)

    var
 : char;
(* Const before type ignored *)
(* Const before type ignored *)
(* Const before type ignored *)
  { XINE_CONFIG_STRING_IS_*  }
(* Const before type ignored *)
(* Const before type ignored *)
(* error 
					   void *cb_data) XINE_PROTECTED;
 in declarator_list *)
 : char;
(* Const before type ignored *)
(* Const before type ignored *)
(* Const before type ignored *)
(* error 
				   void *cb_data) XINE_PROTECTED;
 in declarator_list *)
 : longint;
(* Const before type ignored *)
(* Const before type ignored *)
(* Const before type ignored *)
(* error 
				   void *cb_data) XINE_PROTECTED;
 in declarator_list *)
 : longint;
(* Const before type ignored *)
(* Const before type ignored *)
(* Const before type ignored *)
(* error 
				   void *cb_data) XINE_PROTECTED;
 in declarator_list *)
 : longint;
(* Const before type ignored *)
(* Const before type ignored *)
(* Const before type ignored *)
(* error 
				   void *cb_data) XINE_PROTECTED;
 in declarator_list *)
 : longint;
  {
   * the following functions will copy data from the internal xine_config
   * data database to the xine_cfg_entry_t *entry you provide
   *
   * they return 1 on success, 0 on failure
    }
  { get first config item  }
(* error 
int  xine_config_get_first_entry (xine_t *self, xine_cfg_entry_t *entry) XINE_PROTECTED;
 in declarator_list *)
 : longint;
  { get next config item (iterate through the items)  }
(* error 
int  xine_config_get_next_entry (xine_t *self, xine_cfg_entry_t *entry) XINE_PROTECTED;
 in declarator_list *)
 : longint;
  { search for a config entry by key  }
(* Const before type ignored *)
(* error 
			       xine_cfg_entry_t *entry) XINE_PROTECTED;
 in declarator_list *)
 : longint;
  {
   * update a config entry (which was returned from lookup_entry() )
   *
   * xine will make a deep copy of the data in the entry into it's internal
   * config database.
    }
(* Const before type ignored *)
(* error 
			       const xine_cfg_entry_t *entry) XINE_PROTECTED;
 in declarator_list *)
 : pointer;
  {
   * load/save config data from/to afile (e.g. $HOME/.xine/config)
    }
(* Const before type ignored *)
(* error 
void xine_config_load  (xine_t *self, const char *cfg_filename) XINE_PROTECTED;
 in declarator_list *)
 : pointer;
(* Const before type ignored *)
(* error 
void xine_config_save  (xine_t *self, const char *cfg_filename) XINE_PROTECTED;
 in declarator_list *)
 : pointer;
(* error 
void xine_config_reset (xine_t *self) XINE_PROTECTED;
 in declarator_list *)
 : pointer;
  {********************************************************************
   * asynchroneous xine event mechanism                                *
   ******************************************************************** }
  {
   * to receive events you have to register an event queue with
   * the xine engine (xine_event_new_queue, see below).
   *
   * then you can either
   * 1) check for incoming events regularly (xine_event_get/wait),
   *    process them and free them using xine_event_free
   * 2) use xine_event_create_listener_thread and specify a callback
   *    which will then be called for each event
   *
   * to send events to every module listening you don't need
   * to register an event queue but simply call xine_event_send.
   *
   * front ends should listen for one of MRL_REFERENCE and MRL_REFERENCE_EXT
   * since both will be sent for compatibility reasons
    }
  { event types  }
  { frontend can e.g. move on to next playlist entry  }

  const
     XINE_EVENT_UI_PLAYBACK_FINISHED = 1;     
  { inform ui that new channel info is available  }
     XINE_EVENT_UI_CHANNELS_CHANGED = 2;     
  { request title display change in ui  }
     XINE_EVENT_UI_SET_TITLE = 3;     
  { message (dialog) for the ui to display  }
     XINE_EVENT_UI_MESSAGE = 4;     
  { e.g. aspect ratio change during dvd playback  }
     XINE_EVENT_FRAME_FORMAT_CHANGE = 5;     
  { report current audio level (l/r/mute)  }
     XINE_EVENT_AUDIO_LEVEL = 6;     
  { last event sent when stream is disposed  }
     XINE_EVENT_QUIT = 7;     
  { index creation/network connections  }
     XINE_EVENT_PROGRESS = 8;     
  { (deprecated) demuxer->frontend: MRL reference(s) for the real stream  }
     XINE_EVENT_MRL_REFERENCE = 9;     
  { number of buttons for interactive menus  }
     XINE_EVENT_UI_NUM_BUTTONS = 10;     
  { the mouse pointer enter/leave a button  }
     XINE_EVENT_SPU_BUTTON = 11;     
  { number of dropped frames is too high  }
     XINE_EVENT_DROPPED_FRAMES = 12;     
  { demuxer->frontend: MRL reference(s) for the real stream  }
     XINE_EVENT_MRL_REFERENCE_EXT = 13;     
  { input events coming from frontend  }
     XINE_EVENT_INPUT_MOUSE_BUTTON = 101;     
     XINE_EVENT_INPUT_MOUSE_MOVE = 102;     
     XINE_EVENT_INPUT_MENU1 = 103;     
     XINE_EVENT_INPUT_MENU2 = 104;     
     XINE_EVENT_INPUT_MENU3 = 105;     
     XINE_EVENT_INPUT_MENU4 = 106;     
     XINE_EVENT_INPUT_MENU5 = 107;     
     XINE_EVENT_INPUT_MENU6 = 108;     
     XINE_EVENT_INPUT_MENU7 = 109;     
     XINE_EVENT_INPUT_UP = 110;     
     XINE_EVENT_INPUT_DOWN = 111;     
     XINE_EVENT_INPUT_LEFT = 112;     
     XINE_EVENT_INPUT_RIGHT = 113;     
     XINE_EVENT_INPUT_SELECT = 114;     
     XINE_EVENT_INPUT_NEXT = 115;     
     XINE_EVENT_INPUT_PREVIOUS = 116;     
     XINE_EVENT_INPUT_ANGLE_NEXT = 117;     
     XINE_EVENT_INPUT_ANGLE_PREVIOUS = 118;     
     XINE_EVENT_INPUT_BUTTON_FORCE = 119;     
     XINE_EVENT_INPUT_NUMBER_0 = 120;     
     XINE_EVENT_INPUT_NUMBER_1 = 121;     
     XINE_EVENT_INPUT_NUMBER_2 = 122;     
     XINE_EVENT_INPUT_NUMBER_3 = 123;     
     XINE_EVENT_INPUT_NUMBER_4 = 124;     
     XINE_EVENT_INPUT_NUMBER_5 = 125;     
     XINE_EVENT_INPUT_NUMBER_6 = 126;     
     XINE_EVENT_INPUT_NUMBER_7 = 127;     
     XINE_EVENT_INPUT_NUMBER_8 = 128;     
     XINE_EVENT_INPUT_NUMBER_9 = 129;     
     XINE_EVENT_INPUT_NUMBER_10_ADD = 130;     
  { specific event types  }
     XINE_EVENT_SET_V4L2 = 200;     
     XINE_EVENT_PVR_SAVE = 201;     
     XINE_EVENT_PVR_REPORT_NAME = 202;     
     XINE_EVENT_PVR_REALTIME = 203;     
     XINE_EVENT_PVR_PAUSE = 204;     
     XINE_EVENT_SET_MPEG_DATA = 205;     
  { VDR specific event types  }
     XINE_EVENT_VDR_RED = 300;     
     XINE_EVENT_VDR_GREEN = 301;     
     XINE_EVENT_VDR_YELLOW = 302;     
     XINE_EVENT_VDR_BLUE = 303;     
     XINE_EVENT_VDR_PLAY = 304;     
     XINE_EVENT_VDR_PAUSE = 305;     
     XINE_EVENT_VDR_STOP = 306;     
     XINE_EVENT_VDR_RECORD = 307;     
     XINE_EVENT_VDR_FASTFWD = 308;     
     XINE_EVENT_VDR_FASTREW = 309;     
     XINE_EVENT_VDR_POWER = 310;     
     XINE_EVENT_VDR_CHANNELPLUS = 311;     
     XINE_EVENT_VDR_CHANNELMINUS = 312;     
     XINE_EVENT_VDR_SCHEDULE = 313;     
     XINE_EVENT_VDR_CHANNELS = 314;     
     XINE_EVENT_VDR_TIMERS = 315;     
     XINE_EVENT_VDR_RECORDINGS = 316;     
     XINE_EVENT_VDR_SETUP = 317;     
     XINE_EVENT_VDR_COMMANDS = 318;     
     XINE_EVENT_VDR_BACK = 319;     
     XINE_EVENT_VDR_USER1 = 320;     
     XINE_EVENT_VDR_USER2 = 321;     
     XINE_EVENT_VDR_USER3 = 322;     
     XINE_EVENT_VDR_USER4 = 323;     
     XINE_EVENT_VDR_USER5 = 324;     
     XINE_EVENT_VDR_USER6 = 325;     
     XINE_EVENT_VDR_USER7 = 326;     
     XINE_EVENT_VDR_USER8 = 327;     
     XINE_EVENT_VDR_USER9 = 328;     
     XINE_EVENT_VDR_VOLPLUS = 329;     
     XINE_EVENT_VDR_VOLMINUS = 330;     
     XINE_EVENT_VDR_MUTE = 331;     
     XINE_EVENT_VDR_AUDIO = 332;     
     XINE_EVENT_VDR_INFO = 333;     
     XINE_EVENT_VDR_CHANNELPREVIOUS = 334;     
  { some space for further keys  }
     XINE_EVENT_VDR_SETVIDEOWINDOW = 350;     
     XINE_EVENT_VDR_FRAMESIZECHANGED = 351;     
     XINE_EVENT_VDR_SELECTAUDIO = 352;     
     XINE_EVENT_VDR_TRICKSPEEDMODE = 353;     
     XINE_EVENT_VDR_PLUGINSTARTED = 354;     
  { events generated from post plugins  }
     XINE_EVENT_POST_TVTIME_FILMMODE_CHANGE = 400;     
  {
   * xine event struct
    }
  { event type (constants see above)  }
  { stream this event belongs to      }
  { contents depending on type  }
  { you do not have to provide this, it will be filled in by xine_event_send()  }
  { timestamp of event creation  }

  type

     xine_event_t = record
          _type : longint;
          stream : ^xine_stream_t;
          data : pointer;
          data_length : longint;
          tv : timeval;
       end;
  {
   * input event dynamic data
    }
  { Generally 1 = left, 2 = mid, 3 = right  }
  { In Image space  }

     xine_input_data_t = record
          event : xine_event_t;
          button : uint8_t;
          x : uint16_t;
          y : uint16_t;
       end;
  {
   * UI event dynamic data - send information to/from UI.
    }
  { might be longer  }

     xine_ui_data_t = record
          num_buttons : longint;
          str_len : longint;
          str : array[0..255] of char;
       end;
  {
   * Send messages to UI. used mostly to report errors.
    }
  {
     * old xine-ui versions expect xine_ui_data_t type.
     * this struct is added for compatibility.
      }
  { See XINE_MSG_xxx for defined types.  }
  { defined types are provided with a standard explanation.
     * note: zero means no explanation.
      }
  { add to struct address to get a valid (char *)  }
  { parameters are zero terminated strings  }
  { add to struct address to get a valid (char *)  }
  { where messages are stored, will be longer
     *
     * this field begins with the message text itself (\0-terminated),
     * followed by (optional) \0-terminated parameter strings
     * the end marker is \0 \0
      }

     xine_ui_message_data_t = record
          compatibility : xine_ui_data_t;
          _type : longint;
          explanation : longint;
          num_parameters : longint;
          parameters : longint;
          messages : array[0..0] of char;
       end;
  {
   * notify frame format change
    }
  { these are aspect codes as defined in MPEG2, because this
     * is only used for DVD playback, pan_scan is a boolean flag  }

     xine_format_change_data_t = record
          width : longint;
          height : longint;
          aspect : longint;
          pan_scan : longint;
       end;
  {
   * audio level for left/right channel
    }
  { 0..100 %  }

     xine_audio_level_data_t = record
          left : longint;
          right : longint;
          mute : longint;
       end;
  {
   * index generation / buffering
    }
(* Const before type ignored *)
  { e.g. "connecting..."  }

     xine_progress_data_t = record
          description : ^char;
          percent : longint;
       end;
  {
   * mrl reference data is sent by demuxers when a reference stream is found.
   * this stream just contains pointers (urls) to the real data, which are
   * passed to frontend using this event type. (examples: .asx, .mov and .ram)
   * 
   * ideally, frontends should add these mrls to a "hierarchical playlist". 
   * that is, instead of the original file, the ones provided here should be
   * played instead. on pratice, just using a simple playlist should work.
   *
   * mrl references should be played in the same order they are received, just
   * after the current stream finishes.
   * alternative entries may be provided and should be used in case of
   * failure of the primary stream (the one with alternative=0).
   *
   * sample playlist:
   *   1) http://something/something.ram
   *     1a) rtsp://something/realsomething1.rm (alternative=0)
   *     1b) pnm://something/realsomething1.rm (alternative=1)
   *   2) http://another/another.avi
   *
   * 1 and 2 are the original items on this playlist. 1a and 1b were received
   * by events (they are the mrl references enclosed in 1). 1a is played after 
   * receiving the finished event from 1. note: 1b is usually ignored, it should
   * only be used in case 1a fails to open.
   *
   * An event listener which accepts XINE_EVENT_MRL_REFERENCE_EXT events
   * *must* ignore XINE_EVENT_MRL_REFERENCE events.
    }
  { alternative playlist number, usually 0  }
  { might (will) be longer  }

     xine_mrl_reference_data_t = record
          alternative : longint;
          mrl : array[0..0] of char;
       end;
  { as above  }
  { milliseconds  }
  { for future expansion  }
(* Const before type ignored *)
  { might (will) be longer  }
  {const char          title*; ** immediately follows MRL's terminating NUL  }

     xine_mrl_reference_data_ext_t = record
          alternative : longint;
          start_time : uint32_t;
          duration : uint32_t;
          spare : array[0..19] of uint32_t;
          mrl : array[0..0] of char;
       end;
  { 
   * configuration options for video4linux-like input plugins
    }
  { input selection  }
  { select active input from card  }  { channel number  }
  { ask for a radio channel  }
  { frequency divided by 62.5KHz or 62.5 Hz  }
  { The transmission standard.  }
  { video parameters  }
  { framerate as numerator/denominator  }
  { Total lines per frame including blanking  }
  { One of the V4L2_STD_* values  }
  { One of the V4L2_COLOR_STD_* values  }
  { The color subcarrier frequency  }
  { scaled frame width  }
  { scaled frame height  }
  { let some spare space so we can add new fields without breaking
     * binary api compatibility. 
      }
  { used by pvr plugin  }
  { -1 stops pvr recording  }

     xine_set_v4l2_data_t = record
          input : longint;
          channel : longint;
          radio : longint;
          frequency : uint32_t;
          transmission : uint32_t;
          framerate_numerator : uint32_t;
          framerate_denominator : uint32_t;
          framelines : uint32_t;
          standard_id : uint64_t;
          colorstandard : uint32_t;
          colorsubcarrier : uint32_t;
          frame_width : longint;
          frame_height : longint;
          spare : array[0..19] of uint32_t;
          session_id : int32_t;
       end;
  {
   * configuration options for plugins that can do a kind of mpeg encoding
   * note: highly experimental api :)
    }
  { mpeg2 parameters  }
  { 1 = vbr, 0 = cbr  }
  { mean (target) bitrate in kbps }
  { peak (max) bitrate in kbps  }
  { GOP size in frames  }
  { open/closed GOP  }
  { number of B frames to use  }
  { XINE_VO_ASPECT_xxx  }
  { let some spare space so we can add new fields without breaking
     * binary api compatibility.
      }

     xine_set_mpeg_data_t = record
          bitrate_vbr : longint;
          bitrate_mean : longint;
          bitrate_peak : longint;
          gop_size : longint;
          gop_closure : longint;
          b_frames : longint;
          aspect_ratio : longint;
          spare : array[0..19] of uint32_t;
       end;
  { 0 leave, 1 enter  }
  { button number  }

     xine_spu_button_t = record
          direction : longint;
          button : int32_t;
       end;
  { event XINE_EVENT_DROPPED_FRAMES is generated if libxine detects a
   * high number of dropped frames (above configured thresholds). it can
   * be used by the front end to warn about performance problems.
    }
  { these values are given for 1000 frames delivered  }
  { (that is, divide by 10 to get percentages)  }

     xine_dropped_frames_t = record
          skipped_frames : longint;
          skipped_threshold : longint;
          discarded_frames : longint;
          discarded_threshold : longint;
       end;
  {
   * Defined message types for XINE_EVENT_UI_MESSAGE
   * This is the mechanism to report async errors from engine.
   *
   * If frontend knows about the XINE_MSG_xxx type it may safely 
   * ignore the 'explanation' field and provide it's own custom
   * dialog to the 'parameters'.
   *
   * right column specifies the usual parameters.
    }
  { (messages to UI)    }

  const
     XINE_MSG_NO_ERROR = 0;     
  { (warning message)   }
     XINE_MSG_GENERAL_WARNING = 1;     
  { (host name)         }
     XINE_MSG_UNKNOWN_HOST = 2;     
  { (device name)       }
     XINE_MSG_UNKNOWN_DEVICE = 3;     
  { none                }
     XINE_MSG_NETWORK_UNREACHABLE = 4;     
  { (host name)         }
     XINE_MSG_CONNECTION_REFUSED = 5;     
  { (file name or mrl)  }
     XINE_MSG_FILE_NOT_FOUND = 6;     
  { (device/file/mrl)   }
     XINE_MSG_READ_ERROR = 7;     
  { (library/decoder)   }
     XINE_MSG_LIBRARY_LOAD_ERROR = 8;     
  { none                }
     XINE_MSG_ENCRYPTED_SOURCE = 9;     
  { (security message)  }
     XINE_MSG_SECURITY = 10;     
  { none                }
     XINE_MSG_AUDIO_OUT_UNAVAILABLE = 11;     
  { (file name or mrl)  }
     XINE_MSG_PERMISSION_ERROR = 12;     
  { file is empty       }
     XINE_MSG_FILE_EMPTY = 13;     
  { opaque xine_event_queue_t  }

  type
     xine_event_queue_s = xine_event_queue_t;
  {
   * register a new event queue
   *
   * you have to receive messages from this queue regularly
   *
   * use xine_event_dispose_queue to unregister and free the queue
    }
(* error 
xine_event_queue_t *xine_event_new_queue (xine_stream_t *stream) XINE_PROTECTED;
 in declarator_list *)

    var
 : xine_event_queue_t;
(* error 
void xine_event_dispose_queue (xine_event_queue_t *queue) XINE_PROTECTED;
 in declarator_list *)
 : pointer;
  {
   * receive events (poll)
   *
   * use xine_event_free on the events received from these calls
   * when they're no longer needed
    }
(* error 
xine_event_t *xine_event_get  (xine_event_queue_t *queue) XINE_PROTECTED;
 in declarator_list *)
 : xine_event_t;
(* error 
xine_event_t *xine_event_wait (xine_event_queue_t *queue) XINE_PROTECTED;
 in declarator_list *)
 : xine_event_t;
(* error 
void          xine_event_free (xine_event_t *event) XINE_PROTECTED;
 in declarator_list *)
 : pointer;
  {
   * receive events (callback)
   *
   * a thread is created which will receive all events from
   * the specified queue, call your callback on each of them
   * and will then free the event when your callback returns
   *
    }
(* Const before type ignored *)

  type

     xine_event_listener_cb_t = procedure (user_data:pointer; event:pxine_event_t);cdecl;
(* error 
					void *user_data) XINE_PROTECTED;
 in declarator_list *)

    var
 : pointer;
  {
   * send an event to all queues
   *
   * the event will be copied so you can free or reuse
   * *event as soon as xine_event_send returns.
    }
(* Const before type ignored *)
(* error 
void xine_event_send (xine_stream_t *stream, const xine_event_t *event) XINE_PROTECTED;
 in declarator_list *)
 : pointer;
  {********************************************************************
   * OSD (on screen display)                                           *
   ******************************************************************** }

  const
     XINE_TEXT_PALETTE_SIZE = 11;     
     XINE_OSD_TEXT1 = 0*XINE_TEXT_PALETTE_SIZE;     
     XINE_OSD_TEXT2 = 1*XINE_TEXT_PALETTE_SIZE;     
     XINE_OSD_TEXT3 = 2*XINE_TEXT_PALETTE_SIZE;     
     XINE_OSD_TEXT4 = 3*XINE_TEXT_PALETTE_SIZE;     
     XINE_OSD_TEXT5 = 4*XINE_TEXT_PALETTE_SIZE;     
     XINE_OSD_TEXT6 = 5*XINE_TEXT_PALETTE_SIZE;     
     XINE_OSD_TEXT7 = 6*XINE_TEXT_PALETTE_SIZE;     
     XINE_OSD_TEXT8 = 7*XINE_TEXT_PALETTE_SIZE;     
     XINE_OSD_TEXT9 = 8*XINE_TEXT_PALETTE_SIZE;     
     XINE_OSD_TEXT10 = 9*XINE_TEXT_PALETTE_SIZE;     
  { white text, black border, transparent background   }
     XINE_TEXTPALETTE_WHITE_BLACK_TRANSPARENT = 0;     
  { white text, noborder, transparent background       }
     XINE_TEXTPALETTE_WHITE_NONE_TRANSPARENT = 1;     
  { white text, no border, translucid background       }
     XINE_TEXTPALETTE_WHITE_NONE_TRANSLUCID = 2;     
  { yellow text, black border, transparent background  }
     XINE_TEXTPALETTE_YELLOW_BLACK_TRANSPARENT = 3;     
  { freetype2 support compiled in      }
     XINE_OSD_CAP_FREETYPE2 = $0001;     
  { unscaled overlays supp. by vo drv  }
     XINE_OSD_CAP_UNSCALED = $0002;     

  type
     xine_osd_s = xine_osd_t;
(* error 
				    int width, int height) XINE_PROTECTED;
 in declarator_list *)

    var
 : xine_osd_t;
(* error 
uint32_t    xine_osd_get_capabilities (xine_osd_t *self) XINE_PROTECTED;
 in declarator_list *)
 : uint32_t;
(* error 
void        xine_osd_draw_point    (xine_osd_t *self, int x, int y, int color) XINE_PROTECTED;
 in declarator_list *)
 : pointer;
(* error 
				    int x2, int y2, int color) XINE_PROTECTED;
 in declarator_list *)
 : pointer;
(* error 
				    int color, int filled ) XINE_PROTECTED;
 in declarator_list *)
 : pointer;
  { x1 and y1 specifies the upper left corner of the text to be rendered  }
(* Const before type ignored *)
(* error 
				    const char *text, int color_base) XINE_PROTECTED;
 in declarator_list *)
 : pointer;
(* error 
				    uint8_t *palette_map) XINE_PROTECTED;
 in declarator_list *)
 : pointer;
  { for freetype2 fonts the height is the maximum height for the whole font and not
   * only for the specified text  }
(* Const before type ignored *)
(* error 
				    int *width, int *height) XINE_PROTECTED;
 in declarator_list *)
 : pointer;
  { with freetype2 support compiled in, you can also specify a font file
     as 'fontname' here  }
(* Const before type ignored *)
(* error 
				    int size) XINE_PROTECTED;
 in declarator_list *)
 : longint;
  { 
   * specifying encoding of texts
   *   ""   ... means current locale encoding (default)
   *   NULL ... means latin1
    }
(* Const before type ignored *)
(* error 
void        xine_osd_set_encoding(xine_osd_t *self, const char *encoding) XINE_PROTECTED;
 in declarator_list *)
 : pointer;
  { set position were overlay will be blended  }
(* error 
void        xine_osd_set_position  (xine_osd_t *self, int x, int y) XINE_PROTECTED;
 in declarator_list *)
 : pointer;
(* error 
void        xine_osd_show          (xine_osd_t *self, int64_t vpts) XINE_PROTECTED;
 in declarator_list *)
 : pointer;
(* error 
void        xine_osd_show_unscaled (xine_osd_t *self, int64_t vpts) XINE_PROTECTED;
 in declarator_list *)
 : pointer;
(* error 
void        xine_osd_hide          (xine_osd_t *self, int64_t vpts) XINE_PROTECTED;
 in declarator_list *)
 : pointer;
  { empty drawing area  }
(* error 
void        xine_osd_clear         (xine_osd_t *self) XINE_PROTECTED;
 in declarator_list *)
 : pointer;
  {
   * set on existing text palette
   * (-1 to set used specified palette)
   *
   * color_base specifies the first color index to use for this text
   * palette. The OSD palette is then modified starting at this
   * color index, up to the size of the text palette.
   *
   * Use OSD_TEXT1, OSD_TEXT2, ... for some preassigned color indices.
   *
   * These palettes are not working well with the true type fonts.
   * First thing is that these fonts cannot have a border. So you get
   * the best results by loading a linearly blending palette from the
   * background (at index 0) to the forground color (at index 10).
    }
(* error 
				       int color_base ) XINE_PROTECTED;
 in declarator_list *)
 : pointer;
  { get palette (color and transparency)  }
(* error 
				    uint8_t *trans) XINE_PROTECTED;
 in declarator_list *)
 : pointer;
(* Const before type ignored *)
(* Const before declarator ignored *)
(* Const before type ignored *)
(* Const before declarator ignored *)
(* error 
				    const uint8_t *const trans ) XINE_PROTECTED;
 in declarator_list *)
 : pointer;
  {
   * close osd rendering engine
   * loaded fonts are unloaded
   * osd objects are closed
    }
(* error 
void        xine_osd_free          (xine_osd_t *self) XINE_PROTECTED;
 in declarator_list *)
 : pointer;
  {********************************************************************
   * TV-mode API, to make it possible to use nvtvd to view movies      *
   ******************************************************************** }
  { These functions are just dummies to maintain API compatibility.
   * You should use libnvtvsimple in your frontend instead.  }

  type

     xine_tvsystem = (XINE_TVSYSTEM_PAL := 0,XINE_TVSYSTEM_NTSC
       );
  { connect to nvtvd server and save current TV and X settings  }
(* error 
int xine_tvmode_init (xine_t *self) XINE_PROTECTED;
 in declarator_list *)

    var
 : longint;
  { Turn tvmode on/off (1/0) }
(* error 
int xine_tvmode_use(xine_t *self, int use_tvmode) XINE_PROTECTED;
 in declarator_list *)
 : longint;
  { Set which tv system to use: XINE_TVSYSTEM_PAL or XINE_TVSYSTEM_NTSC  }
(* error 
void xine_tvmode_set_tvsystem(xine_t *self, xine_tvsystem system) XINE_PROTECTED;
 in declarator_list *)
 : pointer;
  { try to change TV state if enabled
   *   type select 'regular' (0) or 'TV' (1) state
   *   width frame width the mode should match best or 0 if unknown
   *   height frame height the mode should match best or 0 if unknown
   *   fps frame rate the mode should match best or 0 if unknown
   * returns: finally selected state
    }
(* error 
int xine_tvmode_switch (xine_t *self, int type, int width, int height, double fps) XINE_PROTECTED;
 in declarator_list *)
 : longint;
  { adapt (maximum) output size to visible area if necessary and return pixel
   * aspect and real frame rate if available
    }
(* error 
		       double *pixelratio, double *fps) XINE_PROTECTED;
 in declarator_list *)
 : pointer;
  { restore old TV and X settings and close nvtvd connection  }
(* error 
void xine_tvmode_exit (xine_t *self) XINE_PROTECTED;
 in declarator_list *)
 : pointer;

implementation


end.
