{
                                 xine.pas
                             -------------------
    copyright            : (C) 2002 by Ryan Rusaw
    email                : rrusaw@sasktel.net

 Note: This a Kylix translation of the xine.h and related header files required
 to link against libxine.so.1.

 The original xine.h is Copyright (C) 2000-2001 the xine project and is
 licensed under the GNU General Public License as well.

 ***************************************************************************
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************

 Geändert von Michael Springwald. Für Lazarus angepasst.
}

unit xine;
{$mode delphi}{$H+}
interface

uses Types, Xlib, Classes, LCLType,libc,LCLIntf, gtk, gdk,x;

{$DEFINE USE_INTERNAL_XINE_DEFINES}
const
   { xine.h defines }
   XINESHAREDLIB                  = 'libxine.so';

   XINE_MAJOR_VERSION		    = 1;
   {$EXTERNALSYM XINE_MAJOR_VERSION}
   XINE_MINOR_VERSION		    = 0;
   {$EXTERNALSYM XINE_MINOR_VERSION}
   XINE_SUB_VERSION		         = 0;
   {$EXTERNALSYM XINE_SUB_VERSION}
   XINE_VERSION			    = '1-rc3a';
   {$EXTERNALSYM XINE_VERSION}

   XINE_VISUAL_TYPE_NONE          = 0;
   {$EXTERNALSYM XINE_VISUAL_TYPE_NONE}
   XINE_VISUAL_TYPE_X11           = 1;
   {$EXTERNALSYM XINE_VISUAL_TYPE_X11}
   XINE_VISUAL_TYPE_AA            = 2;
   {$EXTERNALSYM XINE_VISUAL_TYPE_AA}
   XINE_VISUAL_TYPE_FB            = 3;
   {$EXTERNALSYM XINE_VISUAL_TYPE_FB}
   XINE_VISUAL_TYPE_GTK           = 4;
   {$EXTERNALSYM XINE_VISUAL_TYPE_GTK}
   XINE_VISUAL_TYPE_DFB           = 5;
   {$EXTERNALSYM XINE_VISUAL_TYPE_DFB}
   XINE_VISUAL_TYPE_PM            = 6;
   {$EXTERNALSYM XINE_VISUAL_TYPE_PM}
   XINE_VISUAL_TYPE_DIRECTX	    = 7;
   {$EXTERNALSYM XINE_VISUAL_TYPE_DIRECTX}

   XINE_MASTER_SLAVE_PLAY	    = $01;
   {$EXTERNALSYM XINE_MASTER_SLAVE_PLAY}
   XINE_MASTER_SLAVE_STOP	    = $10;
   {$EXTERNALSYM XINE_MASTER_SLAVE_STOP}

   XINE_TRICK_MODE_OFF              = 0;
   {$EXTERNALSYM XINE_TRICK_MODE_OFF}
   XINE_TRICK_MODE_SEEK_TO_POSITION = 1;
   {$EXTERNALSYM XINE_TRICK_MODE_SEEK_TO_POSITION}
   XINE_TRICK_MODE_SEEK_TO_TIME     = 2;
   {$EXTERNALSYM XINE_TRICK_MODE_SEEK_TO_TIME}
   XINE_TRICK_MODE_FAST_FORWARD     = 3;
   {$EXTERNALSYM XINE_TRICK_MODE_FAST_FORWARD}
   XINE_TRICK_MODE_FAST_REWIND      = 4;
   {$EXTERNALSYM XINE_TRICK_MODE_FAST_REWIND}

   XINE_ENGINE_PARAM_VERBOSITY      = 1;
   {$EXTERNALSYM XINE_ENGINE_PARAM_VERBOSITY}

   XINE_PARAM_SPEED                 = 1;
   {$EXTERNALSYM XINE_PARAM_SPEED}
   XINE_PARAM_AV_OFFSET             = 2;
   {$EXTERNALSYM XINE_PARAM_AV_OFFSET}
   XINE_PARAM_AUDIO_CHANNEL_LOGICAL = 3;
   {$EXTERNALSYM XINE_PARAM_AUDIO_CHANNEL_LOGICAL}
   XINE_PARAM_SPU_CHANNEL           = 4;
   {$EXTERNALSYM XINE_PARAM_SPU_CHANNEL}
   XINE_PARAM_VIDEO_CHANNEL         = 5;
   {$EXTERNALSYM XINE_PARAM_VIDEO_CHANNEL}
   XINE_PARAM_AUDIO_VOLUME          = 6;
   {$EXTERNALSYM XINE_PARAM_AUDIO_VOLUME}
   XINE_PARAM_AUDIO_MUTE            = 7;
   {$EXTERNALSYM XINE_PARAM_AUDIO_MUTE}
   XINE_PARAM_AUDIO_COMPR_LEVEL     = 8;
   {$EXTERNALSYM XINE_PARAM_AUDIO_COMPR_LEVEL}
   XINE_PARAM_AUDIO_AMP_LEVEL       = 9;
   {$EXTERNALSYM XINE_PARAM_AUDIO_AMP_LEVEL}
   XINE_PARAM_AUDIO_REPORT_LEVEL    = 10;
   {$EXTERNALSYM XINE_PARAM_AUDIO_REPORT_LEVEL}
   XINE_PARAM_VERBOSITY             = 11;
   {$EXTERNALSYM XINE_PARAM_VERBOSITY}
   XINE_PARAM_SPU_OFFSET	           = 12;
   {$EXTERNALSYM XINE_PARAM_SPU_OFFSET}
   XINE_PARAM_IGNORE_VIDEO	      = 13;
   {$EXTERNALSYM XINE_PARAM_IGNORE_VIDEO}
   XINE_PARAM_IGNORE_AUDIO	      = 14;
   {$EXTERNALSYM XINE_PARAM_IGNORE_AUDIO}
   XINE_PARAM_IGNORE_SPU	           = 15;
   {$EXTERNALSYM XINE_PARAM_IGNORE_SPU}
   XINE_PARAM_ENABLE_BROADCAST      = 16;
   {$EXTERNALSYM XINE_PARAM_ENABLE_BROADCAST}
   XINE_PARAM_METRONOM_PREBUFFER    = 17;
   {$EXTERNALSYM XINE_PARAM_METRONOM_PREBUFFER}
   XINE_PARAM_EQ_30HZ               = 18;
   {$EXTERNALSYM XINE_PARAM_EQ_30HZ}
   XINE_PARAM_EQ_60HZ               = 19;
   {$EXTERNALSYM XINE_PARAM_EQ_60HZ}
   XINE_PARAM_EQ_125HZ              = 20;
   {$EXTERNALSYM XINE_PARAM_EQ_125HZ}
   XINE_PARAM_EQ_250HZ              = 21;
   {$EXTERNALSYM XINE_PARAM_EQ_250HZ}
   XINE_PARAM_EQ_500HZ              = 22;
   {$EXTERNALSYM XINE_PARAM_EQ_500HZ}
   XINE_PARAM_EQ_1000HZ             = 23;
   {$EXTERNALSYM XINE_PARAM_EQ_1000HZ}
   XINE_PARAM_EQ_2000HZ             = 24;
   {$EXTERNALSYM XINE_PARAM_EQ_2000HZ}
   XINE_PARAM_EQ_4000HZ             = 25;
   {$EXTERNALSYM XINE_PARAM_EQ_4000HZ}
   XINE_PARAM_EQ_8000HZ             = 26;
   {$EXTERNALSYM XINE_PARAM_EQ_8000HZ}
   XINE_PARAM_EQ_16000HZ            = 27;
   {$EXTERNALSYM XINE_PARAM_EQ_16000HZ}

   XINE_SPEED_PAUSE                 = 0;
   {$EXTERNALSYM XINE_SPEED_PAUSE}
   XINE_SPEED_SLOW_4                = 1;
   {$EXTERNALSYM XINE_SPEED_SLOW_4}
   XINE_SPEED_SLOW_2                = 2;
   {$EXTERNALSYM XINE_SPEED_SLOW_2}
   XINE_SPEED_NORMAL                = 4;
   {$EXTERNALSYM XINE_SPEED_NORMAL}
   XINE_SPEED_FAST_2                = 8;
   {$EXTERNALSYM XINE_SPEED_FAST_2}
   XINE_SPEED_FAST_4                = 16;
   {$EXTERNALSYM XINE_SPEED_FAST_4}

   XINE_PARAM_VO_DEINTERLACE        = $01000000;
   {$EXTERNALSYM XINE_PARAM_VO_DEINTERLACE}
   XINE_PARAM_VO_ASPECT_RATIO       = $01000001;
   {$EXTERNALSYM XINE_PARAM_VO_ASPECT_RATIO}
   XINE_PARAM_VO_HUE                = $01000002;
   {$EXTERNALSYM XINE_PARAM_VO_HUE}
   XINE_PARAM_VO_SATURATION         = $01000003;
   {$EXTERNALSYM XINE_PARAM_VO_SATURATION}
   XINE_PARAM_VO_CONTRAST           = $01000004;
   {$EXTERNALSYM XINE_PARAM_VO_CONTRAST}
   XINE_PARAM_VO_BRIGHTNESS         = $01000005;
   {$EXTERNALSYM XINE_PARAM_VO_BRIGHTNESS}
   XINE_PARAM_VO_ZOOM_X             = $01000008;
   {$EXTERNALSYM XINE_PARAM_VO_ZOOM_X}
   XINE_PARAM_VO_ZOOM_Y             = $0100000d;
   {$EXTERNALSYM XINE_PARAM_VO_ZOOM_X}
   XINE_PARAM_VO_PAN_SCAN           = $01000009;
   {$EXTERNALSYM XINE_PARAM_VO_PAN_SCAN}
   XINE_PARAM_VO_TVMODE             = $0100000a;
   {$EXTERNALSYM XINE_PARAM_VO_TVMODE}

   XINE_VO_ZOOM_STEP                = 100;
   {$EXTERNALSYM XINE_VO_ZOOM_STEP}
   XINE_VO_ZOOM_MAX                 = 400;
   {$EXTERNALSYM XINE_VO_ZOOM_MAX}
   XINE_VO_ZOOM_MIN                 = -85;
   {$EXTERNALSYM XINE_VO_ZOOM_MIN}
   XINE_VO_ASPECT_AUTO              = 0;
   {$EXTERNALSYM XINE_VO_ASPECT_AUTO}
   XINE_VO_ASPECT_SQUARE            = 1;
   {$EXTERNALSYM XINE_VO_ASPECT_SQUARE}
   XINE_VO_ASPECT_4_3               = 2;
   {$EXTERNALSYM XINE_VO_ASPECT_4_3}
   XINE_VO_ASPECT_ANAMORPHIC        = 3;
   {$EXTERNALSYM XINE_VO_ASPECT_ANAMORPHIC}
   XINE_VO_ASPECT_DVB               = 4;
   {$EXTERNALSYM XINE_VO_ASPECT_DVB}
   XINE_VO_ASPECT_NUM_RATIOS        = 5;
   {$EXTERNALSYM XINE_VO_ASPECT_NUM_RATIOS}
   XINE_VO_ASPECT_PAN_SCAN          = 41;
   {$EXTERNALSYM XINE_VO_ASPECT_PAN_SCAN}
   XINE_VO_ASPECT_DONT_TOUCH        = 42;
   {$EXTERNALSYM XINE_VO_ASPECT_DONT_TOUCH}

   XINE_DEMUX_DEFAULT_STRATEGY      = 0;
   {$EXTERNALSYM XINE_DEMUX_DEFAULT_STRATEGY}
   XINE_DEMUX_REVERT_STRATEGY       = 1;
   {$EXTERNALSYM XINE_DEMUX_REVERT_STRATEGY}
   XINE_DEMUX_CONTENT_STRATEGY      = 2;
   {$EXTERNALSYM XINE_DEMUX_CONTENT_STRATEGY}
   XINE_DEMUX_EXTENSION_STRATEGY    = 3;
   {$EXTERNALSYM XINE_DEMUX_EXTENSION_STRATEGY}

   XINE_VERBOSITY_NONE              = 0;
   {$EXTERNALSYM XINE_VERBOSITY_NONE}
   XINE_VERBOSITY_LOG               = 1;
   {$EXTERNALSYM XINE_VERBOSITY_LOG}
   XINE_VERBOSITY_DEBUG             = 2;
   {$EXTERNALSYM XINE_VERBOSITY_DEBUG}

   XINE_IMGFMT_YV12                 = $32315659 ;
   {$EXTERNALSYM XINE_IMGFMT_YV12}
   XINE_IMGFMT_YUY2                 = $32595559 ;
   {$EXTERNALSYM XINE_IMGFMT_YUY2}

   XINE_POST_TYPE_VIDEO_FILTER		= $010000;
   {$EXTERNALSYM XINE_POST_TYPE_VIDEO_FILTER}
   XINE_POST_TYPE_VIDEO_VISUALIZATION	= $010001;
   {$EXTERNALSYM XINE_POST_TYPE_VIDEO_VISUALIZATION}
   XINE_POST_TYPE_VIDEO_COMPOSE		= $010002;
   {$EXTERNALSYM XINE_POST_TYPE_VIDEO_COMPOSE}
   XINE_POST_TYPE_AUDIO_FILTER		= $020000;
   {$EXTERNALSYM XINE_POST_TYPE_AUDIO_FILTER}
   XINE_POST_TYPE_AUDIO_VISUALIZATION	= $020001;
   {$EXTERNALSYM XINE_POST_TYPE_AUDIO_VISUALIZATION}

   XINE_POST_DATA_VIDEO             = 0;
   {$EXTERNALSYM XINE_POST_DATA_VIDEO}
   XINE_POST_DATA_AUDIO             = 1;
   {$EXTERNALSYM XINE_POST_DATA_AUDIO}
   XINE_POST_DATA_INT               = 3;
   {$EXTERNALSYM XINE_POST_DATA_INT}
   XINE_POST_DATA_DOUBLE            = 4;
   {$EXTERNALSYM XINE_POST_DATA_DOUBLE}

   XINE_STATUS_IDLE                 = 0;
   {$EXTERNALSYM XINE_STATUS_IDLE}
   XINE_STATUS_STOP                 = 1;
   {$EXTERNALSYM XINE_STATUS_STOP}
   XINE_STATUS_PLAY                 = 2;
   {$EXTERNALSYM XINE_STATUS_PLAY}
   XINE_STATUS_QUIT                 = 3;
   {$EXTERNALSYM XINE_STATUS_QUIT}

   XINE_ERROR_NONE                  = 0;
   {$EXTERNALSYM XINE_ERROR_NONE}
   XINE_ERROR_NO_INPUT_PLUGIN       = 1;
   {$EXTERNALSYM XINE_ERROR_NO_INPUT_PLUGIN}
   XINE_ERROR_NO_DEMUX_PLUGIN       = 2;
   {$EXTERNALSYM XINE_ERROR_NO_DEMUX_PLUGIN}
   XINE_ERROR_DEMUX_FAILED          = 3;
   {$EXTERNALSYM XINE_ERROR_DEMUX_FAILED}
   XINE_ERROR_MALFORMED_MRL         = 4;
   {$EXTERNALSYM XINE_ERROR_MALFORMED_MRL}
   XINE_ERROR_INPUT_FAILED	      = 5;
   {$EXTERNALSYM XINE_ERROR_INPUT_FAILED}

   XINE_STREAM_INFO_BITRATE             = 0;
   {$EXTERNALSYM XINE_STREAM_INFO_BITRATE}
   XINE_STREAM_INFO_SEEKABLE            = 1;
   {$EXTERNALSYM XINE_STREAM_INFO_SEEKABLE}
   XINE_STREAM_INFO_VIDEO_WIDTH         = 2;
   {$EXTERNALSYM XINE_STREAM_INFO_VIDEO_WIDTH}
   XINE_STREAM_INFO_VIDEO_HEIGHT        = 3;
   {$EXTERNALSYM XINE_STREAM_INFO_VIDEO_HEIGHT}
   XINE_STREAM_INFO_VIDEO_RATIO         = 4;
   {$EXTERNALSYM XINE_STREAM_INFO_VIDEO_RATIO}
   XINE_STREAM_INFO_VIDEO_CHANNELS      = 5;
   {$EXTERNALSYM XINE_STREAM_INFO_VIDEO_CHANNELS}
   XINE_STREAM_INFO_VIDEO_STREAMS       = 6;
   {$EXTERNALSYM XINE_STREAM_INFO_VIDEO_STREAMS}
   XINE_STREAM_INFO_VIDEO_BITRATE       = 7;
   {$EXTERNALSYM XINE_STREAM_INFO_VIDEO_BITRATE}
   XINE_STREAM_INFO_VIDEO_FOURCC        = 8;
   {$EXTERNALSYM XINE_STREAM_INFO_VIDEO_FOURCC}
   XINE_STREAM_INFO_VIDEO_HANDLED       = 9;
   {$EXTERNALSYM XINE_STREAM_INFO_VIDEO_HANDLED}
   XINE_STREAM_INFO_FRAME_DURATION      = 10;
   {$EXTERNALSYM XINE_STREAM_INFO_FRAME_DURATION}
   XINE_STREAM_INFO_AUDIO_CHANNELS      = 11;
   {$EXTERNALSYM XINE_STREAM_INFO_AUDIO_CHANNELS}
   XINE_STREAM_INFO_AUDIO_BITS          = 12;
   {$EXTERNALSYM XINE_STREAM_INFO_AUDIO_BITS}
   XINE_STREAM_INFO_AUDIO_SAMPLERATE    = 13;
   {$EXTERNALSYM XINE_STREAM_INFO_AUDIO_SAMPLERATE}
   XINE_STREAM_INFO_AUDIO_BITRATE       = 14;
   {$EXTERNALSYM XINE_STREAM_INFO_AUDIO_BITRATE}
   XINE_STREAM_INFO_AUDIO_FOURCC        = 15;
   {$EXTERNALSYM XINE_STREAM_INFO_AUDIO_FOURCC}
   XINE_STREAM_INFO_AUDIO_HANDLED       = 16;
   {$EXTERNALSYM XINE_STREAM_INFO_AUDIO_HANDLED}
   XINE_STREAM_INFO_HAS_CHAPTERS        = 17;
   {$EXTERNALSYM XINE_STREAM_INFO_HAS_CHAPTERS}
   XINE_STREAM_INFO_HAS_VIDEO           = 18;
   {$EXTERNALSYM XINE_STREAM_INFO_HAS_VIDEO}
   XINE_STREAM_INFO_HAS_AUDIO           = 19;
   {$EXTERNALSYM XINE_STREAM_INFO_HAS_AUDIO}
   XINE_STREAM_INFO_IGNORE_VIDEO        = 20;
   {$EXTERNALSYM XINE_STREAM_INFO_IGNORE_VIDEO}
   XINE_STREAM_INFO_IGNORE_AUDIO        = 21;
   {$EXTERNALSYM XINE_STREAM_INFO_IGNORE_AUDIO}
   XINE_STREAM_INFO_IGNORE_SPU          = 22;
   {$EXTERNALSYM XINE_STREAM_INFO_IGNORE_SPU}
   XINE_STREAM_INFO_VIDEO_HAS_STILL     = 23;
   {$EXTERNALSYM XINE_STREAM_INFO_VIDEO_HAS_STILL}
   XINE_STREAM_INFO_MAX_AUDIO_CHANNEL   = 24;
   {$EXTERNALSYM XINE_STREAM_INFO_MAX_AUDIO_CHANNEL}
   XINE_STREAM_INFO_MAX_SPU_CHANNEL     = 25;
   {$EXTERNALSYM XINE_STREAM_INFO_MAX_SPU_CHANNEL}
   XINE_STREAM_INFO_AUDIO_MODE          = 26;
   {$EXTERNALSYM XINE_STREAM_INFO_AUDIO_MODE}

   XINE_META_INFO_TITLE             = 0;
   {$EXTERNALSYM XINE_META_INFO_TITLE}
   XINE_META_INFO_COMMENT           = 1;
   {$EXTERNALSYM XINE_META_INFO_COMMENT}
   XINE_META_INFO_ARTIST            = 2;
   {$EXTERNALSYM XINE_META_INFO_ARTIST}
   XINE_META_INFO_GENRE             = 3;
   {$EXTERNALSYM XINE_META_INFO_GENRE}
   XINE_META_INFO_ALBUM             = 4;
   {$EXTERNALSYM XINE_META_INFO_ALBUM}
   XINE_META_INFO_YEAR              = 5;
   {$EXTERNALSYM XINE_META_INFO_YEAR}
   XINE_META_INFO_VIDEOCODEC        = 6;
   {$EXTERNALSYM XINE_META_INFO_VIDEOCODEC}
   XINE_META_INFO_AUDIOCODEC        = 7;
   {$EXTERNALSYM XINE_META_INFO_AUDIOCODEC}
   XINE_META_INFO_SYSTEMLAYER       = 8;
   {$EXTERNALSYM XINE_META_INFO_SYSTEMLAYER}
   XINE_META_INFO_INPUT_PLUGIN      = 9;
   {$EXTERNALSYM XINE_META_INFO_INPUT_PLUGIN}

   XINE_MRL_TYPE_unknown	           = $0000;
   {$EXTERNALSYM XINE_MRL_TYPE_unknown}
   XINE_MRL_TYPE_dvd                = $0001;
   {$EXTERNALSYM XINE_MRL_TYPE_dvd}
   XINE_MRL_TYPE_vcd                = $0002;
   {$EXTERNALSYM XINE_MRL_TYPE_vcd}
   XINE_MRL_TYPE_net                = $0004;
   {$EXTERNALSYM XINE_MRL_TYPE_net}
   XINE_MRL_TYPE_rtp                = $0008;
   {$EXTERNALSYM XINE_MRL_TYPE_rtp}
   XINE_MRL_TYPE_stdin              = $0010;
   {$EXTERNALSYM XINE_MRL_TYPE_stdin}
   XINE_MRL_TYPE_cda                = $0020;
   {$EXTERNALSYM XINE_MRL_TYPE_cda}
   XINE_MRL_TYPE_file               = $0040;
   {$EXTERNALSYM XINE_MRL_TYPE_file}
   XINE_MRL_TYPE_file_fifo          = $0080;
   {$EXTERNALSYM XINE_MRL_TYPE_file_fifo}
   XINE_MRL_TYPE_file_chardev       = $0100;
   {$EXTERNALSYM XINE_MRL_TYPE_file_chardev}
   XINE_MRL_TYPE_file_directory     = $0200;
   {$EXTERNALSYM XINE_MRL_TYPE_file_directory}
   XINE_MRL_TYPE_file_blockdev      = $0400;
   {$EXTERNALSYM XINE_MRL_TYPE_file_blockdev}
   XINE_MRL_TYPE_file_normal        = $0800;
   {$EXTERNALSYM XINE_MRL_TYPE_file_normal}
   XINE_MRL_TYPE_file_symlink       = $1000;
   {$EXTERNALSYM XINE_MRL_TYPE_file_symlink}
   XINE_MRL_TYPE_file_sock          = $2000;
   {$EXTERNALSYM XINE_MRL_TYPE_file_sock}
   XINE_MRL_TYPE_file_exec          = $4000;
   {$EXTERNALSYM XINE_MRL_TYPE_file_exec}
   XINE_MRL_TYPE_file_backup        = $8000;
   {$EXTERNALSYM XINE_MRL_TYPE_file_backup}
   XINE_MRL_TYPE_file_hidden        = $010000;
   {$EXTERNALSYM XINE_MRL_TYPE_file_hidden}

   XINE_GUI_SEND_COMPLETION_EVENT       = 1;
   {$EXTERNALSYM XINE_GUI_SEND_COMPLETION_EVENT}
   XINE_GUI_SEND_DRAWABLE_CHANGED       = 2;
   {$EXTERNALSYM XINE_GUI_SEND_DRAWABLE_CHANGED}
   XINE_GUI_SEND_EXPOSE_EVENT           = 3;
   {$EXTERNALSYM XINE_GUI_SEND_EXPOSE_EVENT}
   XINE_GUI_SEND_TRANSLATE_GUI_TO_VIDEO = 4;
   {$EXTERNALSYM XINE_GUI_SEND_TRANSLATE_GUI_TO_VIDEO}
   XINE_GUI_SEND_VIDEOWIN_VISIBLE	     = 5;
   {$EXTERNALSYM XINE_GUI_SEND_VIDEOWIN_VISIBLE}
   XINE_GUI_SEND_SELECT_VISUAL          = 8;
   {$EXTERNALSYM XINE_GUI_SEND_SELECT_VISUAL}

   XINE_HEALTH_CHECK_OK             = 0;
   {$EXTERNALSYM XINE_HEALTH_CHECK_OK}
   XINE_HEALTH_CHECK_FAIL           = 1;
   {$EXTERNALSYM XINE_HEALTH_CHECK_FAIL}
   XINE_HEALTH_CHECK_UNSUPPORTED    = 2;
   {$EXTERNALSYM XINE_HEALTH_CHECK_UNSUPPORTED}
   XINE_HEALTH_CHECK_NO_SUCH_CHECK  = 3;
   {$EXTERNALSYM XINE_HEALTH_CHECK_NO_SUCH_CHECK}

   CHECK_KERNEL                     = 0;
   {$EXTERNALSYM CHECK_KERNEL}
   CHECK_MTRR                       = 1;
   {$EXTERNALSYM CHECK_MTRR}
   CHECK_CDROM                      = 2;
   {$EXTERNALSYM CHECK_CDROM}
   CHECK_DVDROM                     = 3;
   {$EXTERNALSYM CHECK_DVDROM}
   CHECK_DMA                        = 4;
   {$EXTERNALSYM CHECK_DMA}
   CHECK_X                          = 5;
   {$EXTERNALSYM CHECK_X}
   CHECK_XV                         = 6;
   {$EXTERNALSYM CHECK_XV}

   XINE_CONFIG_TYPE_UNKNOWN 	      = 0;
   {$EXTERNALSYM XINE_CONFIG_TYPE_UNKNOWN}
   XINE_CONFIG_TYPE_RANGE   	      = 1;
   {$EXTERNALSYM XINE_CONFIG_TYPE_RANGE}
   XINE_CONFIG_TYPE_STRING          = 2;
   {$EXTERNALSYM XINE_CONFIG_TYPE_STRING}
   XINE_CONFIG_TYPE_ENUM            = 3;
   {$EXTERNALSYM XINE_CONFIG_TYPE_ENUM}
   XINE_CONFIG_TYPE_NUM             = 4;
   {$EXTERNALSYM XINE_CONFIG_TYPE_NUM}
   XINE_CONFIG_TYPE_BOOL            = 5;
   {$EXTERNALSYM XINE_CONFIG_TYPE_BOOL}

   XINE_EVENT_UI_PLAYBACK_FINISHED  = 1;
   {$EXTERNALSYM XINE_EVENT_UI_PLAYBACK_FINISHED}
   XINE_EVENT_UI_CHANNELS_CHANGED   = 2;
   {$EXTERNALSYM XINE_EVENT_UI_CHANNELS_CHANGED}
   XINE_EVENT_UI_SET_TITLE          = 3;
   {$EXTERNALSYM XINE_EVENT_UI_SET_TITLE}
   XINE_EVENT_UI_MESSAGE            = 4;
   {$EXTERNALSYM XINE_EVENT_UI_MESSAGE}
   XINE_EVENT_FRAME_FORMAT_CHANGE   = 5;
   {$EXTERNALSYM XINE_EVENT_FRAME_FORMAT_CHANGE}
   XINE_EVENT_AUDIO_LEVEL           = 6;
   {$EXTERNALSYM XINE_EVENT_AUDIO_LEVEL}
   XINE_EVENT_QUIT                  = 7;
   {$EXTERNALSYM XINE_EVENT_QUIT}
   XINE_EVENT_PROGRESS              = 8;
   {$EXTERNALSYM XINE_EVENT_PROGRESS}
   XINE_EVENT_MRL_REFERENCE	      = 9;
   {$EXTERNALSYM XINE_EVENT_MRL_REFERENCE}
   XINE_EVENT_UI_NUM_BUTTONS        = 10;
   {$EXTERNALSYM XINE_EVENT_UI_NUM_BUTTONS}

   XINE_EVENT_INPUT_MOUSE_BUTTON    = 101;
   {$EXTERNALSYM XINE_EVENT_INPUT_MOUSE_BUTTON}
   XINE_EVENT_INPUT_MOUSE_MOVE      = 102;
   {$EXTERNALSYM XINE_EVENT_INPUT_MOUSE_MOVE}
   XINE_EVENT_INPUT_MENU1           = 103;
   {$EXTERNALSYM XINE_EVENT_INPUT_MENU1}
   XINE_EVENT_INPUT_MENU2           = 104;
   {$EXTERNALSYM XINE_EVENT_INPUT_MENU2}
   XINE_EVENT_INPUT_MENU3           = 105;
   {$EXTERNALSYM XINE_EVENT_INPUT_MENU3}
   XINE_EVENT_INPUT_MENU4           = 106;
   {$EXTERNALSYM XINE_EVENT_INPUT_MENU4}
   XINE_EVENT_INPUT_MENU5           = 107;
   {$EXTERNALSYM XINE_EVENT_INPUT_MENU5}
   XINE_EVENT_INPUT_MENU6           = 108;
   {$EXTERNALSYM XINE_EVENT_INPUT_MENU6}
   XINE_EVENT_INPUT_MENU7           = 109;
   {$EXTERNALSYM XINE_EVENT_INPUT_MENU7}
   XINE_EVENT_INPUT_UP              = 110;
   {$EXTERNALSYM XINE_EVENT_INPUT_UP}
   XINE_EVENT_INPUT_DOWN            = 111;
   {$EXTERNALSYM XINE_EVENT_INPUT_DOWN}
   XINE_EVENT_INPUT_LEFT            = 112;
   {$EXTERNALSYM XINE_EVENT_INPUT_LEFT}
   XINE_EVENT_INPUT_RIGHT           = 113;
   {$EXTERNALSYM XINE_EVENT_INPUT_RIGHT}
   XINE_EVENT_INPUT_SELECT          = 114;
   {$EXTERNALSYM XINE_EVENT_INPUT_SELECT}
   XINE_EVENT_INPUT_NEXT            = 115;
   {$EXTERNALSYM XINE_EVENT_INPUT_NEXT}
   XINE_EVENT_INPUT_PREVIOUS        = 116;
   {$EXTERNALSYM XINE_EVENT_INPUT_PREVIOUS}
   XINE_EVENT_INPUT_ANGLE_NEXT      = 117;
   {$EXTERNALSYM XINE_EVENT_INPUT_ANGLE_NEXT}
   XINE_EVENT_INPUT_ANGLE_PREVIOUS  = 118;
   {$EXTERNALSYM XINE_EVENT_INPUT_ANGLE_PREVIOUS}
   XINE_EVENT_INPUT_BUTTON_FORCE    = 119;
   {$EXTERNALSYM XINE_EVENT_INPUT_BUTTON_FORCE}
   XINE_EVENT_INPUT_NUMBER_0        = 120;
   {$EXTERNALSYM XINE_EVENT_INPUT_NUMBER_0}
   XINE_EVENT_INPUT_NUMBER_1        = 121;
   {$EXTERNALSYM XINE_EVENT_INPUT_NUMBER_1}
   XINE_EVENT_INPUT_NUMBER_2        = 122;
   {$EXTERNALSYM XINE_EVENT_INPUT_NUMBER_2}
   XINE_EVENT_INPUT_NUMBER_3        = 123;
   {$EXTERNALSYM XINE_EVENT_INPUT_NUMBER_3}
   XINE_EVENT_INPUT_NUMBER_4        = 124;
   {$EXTERNALSYM XINE_EVENT_INPUT_NUMBER_4}
   XINE_EVENT_INPUT_NUMBER_5        = 125;
   {$EXTERNALSYM XINE_EVENT_INPUT_NUMBER_5}
   XINE_EVENT_INPUT_NUMBER_6        = 126;
   {$EXTERNALSYM XINE_EVENT_INPUT_NUMBER_6}
   XINE_EVENT_INPUT_NUMBER_7        = 127;
   {$EXTERNALSYM XINE_EVENT_INPUT_NUMBER_7}
   XINE_EVENT_INPUT_NUMBER_8        = 128;
   {$EXTERNALSYM XINE_EVENT_INPUT_NUMBER_8}
   XINE_EVENT_INPUT_NUMBER_9        = 129;
   {$EXTERNALSYM XINE_EVENT_INPUT_NUMBER_9}
   XINE_EVENT_INPUT_NUMBER_10_ADD   = 130;
   {$EXTERNALSYM XINE_EVENT_INPUT_NUMBER_10_ADD}

   XINE_EVENT_SET_V4L2		      = 200;
   {$EXTERNALSYM XINE_EVENT_SET_V4L2}
   XINE_EVENT_PVR_SAVE		      = 201;
   {$EXTERNALSYM XINE_EVENT_PVR_SAVE}
   XINE_EVENT_PVR_REPORT_NAME       = 202;
   {$EXTERNALSYM XINE_EVENT_PVR_REPORT_NAME}
   XINE_EVENT_PVR_REALTIME          = 203;
   {$EXTERNALSYM XINE_EVENT_PVR_REALTIME}
   XINE_EVENT_PVR_PAUSE		      = 204;
   {$EXTERNALSYM XINE_EVENT_PVR_PAUSE}
   XINE_EVENT_SET_MPEG_DATA         = 205;
   {$EXTERNALSYM XINE_EVENT_SET_MPEG_DATA}

   XINE_MSG_NO_ERROR		      = 0;
   {$EXTERNALSYM XINE_MSG_NO_ERROR}
   XINE_MSG_GENERAL_WARNING	      = 1;
   {$EXTERNALSYM XINE_MSG_GENERAL_WARNING}
   XINE_MSG_UNKNOWN_HOST            = 2;
   {$EXTERNALSYM XINE_MSG_UNKNOWN_HOST}
   XINE_MSG_UNKNOWN_DEVICE	      = 3;
   {$EXTERNALSYM XINE_MSG_UNKNOWN_DEVICE}
   XINE_MSG_NETWORK_UNREACHABLE	 = 4;
   {$EXTERNALSYM XINE_MSG_NETWORK_UNREACHABLE}
   XINE_MSG_CONNECTION_REFUSED	 = 5;
   {$EXTERNALSYM XINE_MSG_CONNECTION_REFUSED}
   XINE_MSG_FILE_NOT_FOUND          = 6;
   {$EXTERNALSYM XINE_MSG_FILE_NOT_FOUND}
   XINE_MSG_READ_ERROR		      = 7;
   {$EXTERNALSYM XINE_MSG_READ_ERROR}
   XINE_MSG_LIBRARY_LOAD_ERROR	 = 8;
   {$EXTERNALSYM XINE_MSG_LIBRARY_LOAD_ERROR}
   XINE_MSG_ENCRYPTED_SOURCE	      = 9;
   {$EXTERNALSYM XINE_MSG_ENCRYPTED_SOURCE}

   XINE_TEXT_PALETTE_SIZE           = 11;
   {$EXTERNALSYM XINE_TEXT_PALETTE_SIZE}
   XINE_OSD_TEXT1                   = 0*XINE_TEXT_PALETTE_SIZE;
   {$EXTERNALSYM XINE_OSD_TEXT1}
   XINE_OSD_TEXT2                   = 1*XINE_TEXT_PALETTE_SIZE;
   {$EXTERNALSYM XINE_OSD_TEXT2}
   XINE_OSD_TEXT3                   = 2*XINE_TEXT_PALETTE_SIZE;
   {$EXTERNALSYM XINE_OSD_TEXT3}
   XINE_OSD_TEXT4                   = 3*XINE_TEXT_PALETTE_SIZE;
   {$EXTERNALSYM XINE_OSD_TEXT4}
   XINE_OSD_TEXT5                   = 4*XINE_TEXT_PALETTE_SIZE;
   {$EXTERNALSYM XINE_OSD_TEXT5}
   XINE_OSD_TEXT6                   = 5*XINE_TEXT_PALETTE_SIZE;
   {$EXTERNALSYM XINE_OSD_TEXT6}
   XINE_OSD_TEXT7                   = 6*XINE_TEXT_PALETTE_SIZE;
   {$EXTERNALSYM XINE_OSD_TEXT7}
   XINE_OSD_TEXT8                   = 7*XINE_TEXT_PALETTE_SIZE;
   {$EXTERNALSYM XINE_OSD_TEXT8}
   XINE_OSD_TEXT9                   = 8*XINE_TEXT_PALETTE_SIZE;
   {$EXTERNALSYM XINE_OSD_TEXT9}
   XINE_OSD_TEXT10                  = 9*XINE_TEXT_PALETTE_SIZE;
   {$EXTERNALSYM XINE_OSD_TEXT10}

   XINE_TEXTPALETTE_WHITE_BLACK_TRANSPARENT   = 0;
   {$EXTERNALSYM XINE_TEXTPALETTE_WHITE_BLACK_TRANSPARENT}
   XINE_TEXTPALETTE_WHITE_NONE_TRANSPARENT    = 1;
   {$EXTERNALSYM XINE_TEXTPALETTE_WHITE_NONE_TRANSPARENT}
   XINE_TEXTPALETTE_WHITE_NONE_TRANSLUCID     = 2;
   {$EXTERNALSYM XINE_TEXTPALETTE_WHITE_NONE_TRANSLUCID}
   XINE_TEXTPALETTE_YELLOW_BLACK_TRANSPARENT  = 3;
   {$EXTERNALSYM XINE_TEXTPALETTE_YELLOW_BLACK_TRANSPARENT}

{$IFDEF USE_INTERNAL_XINE_DEFINES}
   AUDIO_DECODER_IFACE_VERSION      = 13;
   {$EXTERNALSYM AUDIO_DECODER_IFACE_VERSION}
   AUDIO_OUT_IFACE_VERSION          = 7;
   {$EXTERNALSYM AUDIO_OUT_IFACE_VERSION}
   AO_CAP_NOCAP                     = $00000000;
   {$EXTERNALSYM AO_CAP_NOCAP}
   AO_CAP_MODE_A52                  = $00000001;
   {$EXTERNALSYM AO_CAP_MODE_A52}
   AO_CAP_MODE_AC5                  = $00000002;
   {$EXTERNALSYM AO_CAP_MODE_AC5}
   AO_CAP_MODE_MONO                 = $00000004;
   {$EXTERNALSYM AO_CAP_MODE_MONO}
   AO_CAP_MODE_STEREO               = $00000008;
   {$EXTERNALSYM AO_CAP_MODE_STEREO}
   AO_CAP_MODE_4CHANNEL             = $00000010;
   {$EXTERNALSYM AO_CAP_MODE_4CHANNEL}
   AO_CAP_MODE_5CHANNEL             = $00000020;
   {$EXTERNALSYM AO_CAP_MODE_5CHANNEL}
   AO_CAP_MODE_5_1CHANNEL           = $00000040;
   {$EXTERNALSYM AO_CAP_MODE_5_1CHANNEL}
   AO_CAP_MIXER_VOL                 = $00000080;
   {$EXTERNALSYM AO_CAP_MIXER_VOL}
   AO_CAP_PCM_VOL                   = $00000100;
   {$EXTERNALSYM AO_CAP_PCM_VOL}
   AO_CAP_MUTE_VOL                  = $00000200;
   {$EXTERNALSYM AO_CAP_MUTE_VOL}
   AO_CAP_8BITS                     = $00000400;
   {$EXTERNALSYM AO_CAP_8BITS}
   AO_PROP_MIXER_VOL                = 0;
   {$EXTERNALSYM AO_PROP_MIXER_VOL}
   AO_PROP_PCM_VOL                  = 1;
   {$EXTERNALSYM AO_PROP_PCM_VOL}
   AO_PROP_MUTE_VOL                 = 2;
   {$EXTERNALSYM AO_PROP_MUTE_VOL}
   AO_PROP_COMPRESSOR               = 3;
   {$EXTERNALSYM AO_PROP_COMPRESSOR}
   AO_PROP_DISCARD_BUFFERS          = 4;
   {$EXTERNALSYM AO_PROP_DISCARD_BUFFERS}

   AO_PROP_PAUSED                   = 5;
   {$EXTERNALSYM AO_PROP_PAUSED}
   AO_PROP_AMP                      = 6;
   {$EXTERNALSYM AO_PROP_AMP}
   AO_PROP_EQ_30HZ                  = 7;
   {$EXTERNALSYM AO_PROP_EQ_30HZ}
   AO_PROP_EQ_60HZ                  = 8;
   {$EXTERNALSYM AO_PROP_EQ_60HZ}
   AO_PROP_EQ_125HZ                 = 9;
   {$EXTERNALSYM AO_PROP_EQ_125HZ}
   AO_PROP_EQ_250HZ                 = 10;
   {$EXTERNALSYM AO_PROP_EQ_250HZ}
   AO_PROP_EQ_500HZ                 = 11;
   {$EXTERNALSYM AO_PROP_EQ_500HZ}
   AO_PROP_EQ_1000HZ                = 12;
   {$EXTERNALSYM AO_PROP_EQ_1000HZ}
   AO_PROP_EQ_2000HZ                = 13;
   {$EXTERNALSYM AO_PROP_EQ_2000HZ}
   AO_PROP_EQ_4000HZ                = 14;
   {$EXTERNALSYM AO_PROP_EQ_4000HZ}
   AO_PROP_EQ_8000HZ                = 15;
   {$EXTERNALSYM AO_PROP_EQ_8000HZ}
   AO_PROP_EQ_16000HZ               = 16;
   {$EXTERNALSYM AO_PROP_EQ_16000HZ}
   AO_CTRL_PLAY_PAUSE               = 0;
   {$EXTERNALSYM AO_CTRL_PLAY_PAUSE}
   AO_CTRL_PLAY_RESUME              = 1;
   {$EXTERNALSYM AO_CTRL_PLAY_RESUME}
   AO_CTRL_FLUSH_BUFFERS            = 2;
   {$EXTERNALSYM AO_CTRL_FLUSH_BUFFERS}
   AO_MAX_GAP                       = 15000;
   {$EXTERNALSYM AO_MAX_GAP}

   BUF_MAJOR_MASK                   = $FF000000;
   {$EXTERNALSYM BUF_MAJOR_MASK}
   BUF_DECODER_MASK                 = $00FF0000;
   {$EXTERNALSYM BUF_DECODER_MASK}

   BUF_CONTROL_BASE                 = $01000000;
   {$EXTERNALSYM BUF_CONTROL_BASE}
   BUF_CONTROL_START                = $01000000;
   {$EXTERNALSYM BUF_CONTROL_START}
   BUF_CONTROL_END                  = $01010000;
   {$EXTERNALSYM BUF_CONTROL_END}
   BUF_CONTROL_QUIT                 = $01020000;
   {$EXTERNALSYM BUF_CONTROL_QUIT}
   BUF_CONTROL_DISCONTINUITY        = $01030000;
   {$EXTERNALSYM BUF_CONTROL_DISCONTINUITY}
   BUF_CONTROL_NOP                  = $01040000;
   {$EXTERNALSYM BUF_CONTROL_NOP}
   BUF_CONTROL_AUDIO_CHANNEL        = $01050000;
   {$EXTERNALSYM BUF_CONTROL_AUDIO_CHANNEL}
   BUF_CONTROL_SPU_CHANNEL          = $01060000;
   {$EXTERNALSYM BUF_CONTROL_SPU_CHANNEL}
   BUF_CONTROL_NEWPTS               = $01070000;
   {$EXTERNALSYM BUF_CONTROL_NEWPTS}
   BUF_CONTROL_RESET_DECODER        = $01080000;
   {$EXTERNALSYM BUF_CONTROL_RESET_DECODER}
   BUF_CONTROL_HEADERS_DONE         = $01090000;
   {$EXTERNALSYM BUF_CONTROL_HEADERS_DONE}
   BUF_CONTROL_FLUSH_DECODER        = $010a0000;
   {$EXTERNALSYM BUF_CONTROL_FLUSH_DECODER}

   BUF_VIDEO_BASE                   = $02000000;
   {$EXTERNALSYM BUF_VIDEO_BASE}
   BUF_VIDEO_UNKNOWN                = $02ff0000;
   {$EXTERNALSYM BUF_VIDEO_UNKNOWN}
   BUF_VIDEO_MPEG                   = $02000000;
   {$EXTERNALSYM BUF_VIDEO_MPEG}
   BUF_VIDEO_MPEG4                  = $02010000;
   {$EXTERNALSYM BUF_VIDEO_MPEG4}
   BUF_VIDEO_CINEPAK                = $02020000;
   {$EXTERNALSYM BUF_VIDEO_CINEPAK}
   BUF_VIDEO_SORENSON_V1            = $02030000;
   {$EXTERNALSYM BUF_VIDEO_SORENSON_V1}
   BUF_VIDEO_MSMPEG4_V2             = $02040000;
   {$EXTERNALSYM BUF_VIDEO_MSMPEG4_V2}
   BUF_VIDEO_MSMPEG4_V3             = $02050000;
   {$EXTERNALSYM BUF_VIDEO_MSMPEG4_V3}
   BUF_VIDEO_MJPEG                  = $02060000;
   {$EXTERNALSYM BUF_VIDEO_MJPEG}
   BUF_VIDEO_IV50                   = $02070000;
   {$EXTERNALSYM BUF_VIDEO_IV50}
   BUF_VIDEO_IV41                   = $02080000;
   {$EXTERNALSYM BUF_VIDEO_IV41}
   BUF_VIDEO_IV32                   = $02090000;
   {$EXTERNALSYM BUF_VIDEO_IV32}
   BUF_VIDEO_IV31                   = $020a0000;
   {$EXTERNALSYM BUF_VIDEO_IV31}
   BUF_VIDEO_ATIVCR1                = $020b0000;
   {$EXTERNALSYM BUF_VIDEO_ATIVCR1}
   BUF_VIDEO_ATIVCR2                = $020c0000;
   {$EXTERNALSYM BUF_VIDEO_ATIVCR2}
   BUF_VIDEO_I263                   = $020d0000;
   {$EXTERNALSYM BUF_VIDEO_I263}
   BUF_VIDEO_RV10                   = $020e0000;
   {$EXTERNALSYM BUF_VIDEO_RV10}
   BUF_VIDEO_RGB                    = $02100000;
   {$EXTERNALSYM BUF_VIDEO_RGB}
   BUF_VIDEO_YUY2                   = $02110000;
   {$EXTERNALSYM BUF_VIDEO_YUY2}
   BUF_VIDEO_JPEG                   = $02120000;
   {$EXTERNALSYM BUF_VIDEO_JPEG}
   BUF_VIDEO_WMV7                   = $02130000;
   {$EXTERNALSYM BUF_VIDEO_WMV7}
   BUF_VIDEO_WMV8                   = $02140000;
   {$EXTERNALSYM BUF_VIDEO_WMV8}
   BUF_VIDEO_MSVC                   = $02150000;
   {$EXTERNALSYM BUF_VIDEO_MSVC}
   BUF_VIDEO_DV                     = $02160000;
   {$EXTERNALSYM BUF_VIDEO_DV}
   BUF_VIDEO_REAL                   = $02170000;
   {$EXTERNALSYM BUF_VIDEO_REAL}
   BUF_VIDEO_VP31                   = $02180000;
   {$EXTERNALSYM BUF_VIDEO_VP31}
   BUF_VIDEO_H263                   = $02190000;
   {$EXTERNALSYM BUF_VIDEO_H263}
   BUF_VIDEO_3IVX                   = $021A0000;
   {$EXTERNALSYM BUF_VIDEO_3IVX}
   BUF_VIDEO_CYUV                   = $021B0000;
   {$EXTERNALSYM BUF_VIDEO_CYUV}
   BUF_VIDEO_DIVX5                  = $021C0000;
   {$EXTERNALSYM BUF_VIDEO_DIVX5}
   BUF_VIDEO_XVID                   = $021D0000;
   {$EXTERNALSYM BUF_VIDEO_XVID}
   BUF_VIDEO_SMC                    = $021E0000;
   {$EXTERNALSYM BUF_VIDEO_SMC}
   BUF_VIDEO_RPZA                   = $021F0000;
   {$EXTERNALSYM BUF_VIDEO_RPZA}
   BUF_VIDEO_QTRLE                  = $02200000;
   {$EXTERNALSYM BUF_VIDEO_QTRLE}
   BUF_VIDEO_MSRLE                  = $02210000;
   {$EXTERNALSYM BUF_VIDEO_MSRLE}
   BUF_VIDEO_DUCKTM1                = $02220000;
   {$EXTERNALSYM BUF_VIDEO_DUCKTM1}
   BUF_VIDEO_FLI                    = $02230000;
   {$EXTERNALSYM BUF_VIDEO_FLI}
   BUF_VIDEO_ROQ                    = $02240000;
   {$EXTERNALSYM BUF_VIDEO_ROQ}
   BUF_VIDEO_SORENSON_V3            = $02250000;
   {$EXTERNALSYM BUF_VIDEO_SORENSON_V3}
   BUF_VIDEO_MSMPEG4_V1             = $02260000;
   {$EXTERNALSYM BUF_VIDEO_MSMPEG4_V1}
   BUF_VIDEO_MSS1                   = $02270000;
   {$EXTERNALSYM BUF_VIDEO_MSS1}
   BUF_VIDEO_IDCIN                  = $02280000;
   {$EXTERNALSYM BUF_VIDEO_IDCIN}
   BUF_VIDEO_PGVV                   = $02290000;
   {$EXTERNALSYM BUF_VIDEO_PGVV}
   BUF_VIDEO_ZYGO                   = $022A0000;
   {$EXTERNALSYM BUF_VIDEO_ZYGO}
   BUF_VIDEO_TSCC                   = $022B0000;
   {$EXTERNALSYM BUF_VIDEO_TSCC}
   BUF_VIDEO_YVU9                   = $022C0000;
   {$EXTERNALSYM BUF_VIDEO_YVU9}
   BUF_VIDEO_VQA                    = $022D0000;
   {$EXTERNALSYM BUF_VIDEO_VQA}
   BUF_VIDEO_GREY                   = $022E0000;
   {$EXTERNALSYM BUF_VIDEO_GREY}
   BUF_VIDEO_XXAN                   = $022F0000;
   {$EXTERNALSYM BUF_VIDEO_XXAN}
   BUF_VIDEO_WC3                    = $02300000;
   {$EXTERNALSYM BUF_VIDEO_WC3}
   BUF_VIDEO_YV12                   = $02310000;
   {$EXTERNALSYM BUF_VIDEO_YV12}
   BUF_VIDEO_SEGA                   = $02320000;
   {$EXTERNALSYM BUF_VIDEO_SEGA}
   BUF_VIDEO_RV20                   = $02330000;
   {$EXTERNALSYM BUF_VIDEO_RV20}
   BUF_VIDEO_RV30                   = $02340000;
   {$EXTERNALSYM BUF_VIDEO_RV30}
   BUF_VIDEO_MVI2                   = $02350000;
   {$EXTERNALSYM BUF_VIDEO_MVI2}
   BUF_VIDEO_UCOD                   = $02360000;
   {$EXTERNALSYM BUF_VIDEO_UCOD}
   BUF_VIDEO_WMV9                   = $02370000;
   {$EXTERNALSYM BUF_VIDEO_WMV9}
   BUF_VIDEO_INTERPLAY              = $02380000;
   {$EXTERNALSYM BUF_VIDEO_INTERPLAY}
   BUF_VIDEO_RV40                   = $02390000;
   {$EXTERNALSYM BUF_VIDEO_RV40}
   BUF_VIDEO_PSX_MDEC               = $023A0000;
   {$EXTERNALSYM BUF_VIDEO_PSX_MDEC}
   BUF_VIDEO_YUV_FRAMES             = $023B0000;
   {$EXTERNALSYM BUF_VIDEO_YUV_FRAMES}
   BUF_VIDEO_HUFFYUV                = $023C0000;
   {$EXTERNALSYM BUF_VIDEO_HUFFYUV}
   BUF_VIDEO_IMAGE                  = $023D0000;
   {$EXTERNALSYM BUF_VIDEO_IMAGE}
   BUF_VIDEO_THEORA                 = $023E0000;
   {$EXTERNALSYM BUF_VIDEO_THEORA}

   BUF_AUDIO_BASE                   = $03000000;
   {$EXTERNALSYM BUF_AUDIO_BASE}
   BUF_AUDIO_UNKNOWN                = $03ff0000;
   {$EXTERNALSYM BUF_AUDIO_UNKNOWN}
   BUF_AUDIO_A52                    = $03000000;
   {$EXTERNALSYM BUF_AUDIO_A52}
   BUF_AUDIO_MPEG                   = $03010000;
   {$EXTERNALSYM BUF_AUDIO_MPEG}
   BUF_AUDIO_LPCM_BE                = $03020000;
   {$EXTERNALSYM BUF_AUDIO_LPCM_BE}
   BUF_AUDIO_LPCM_LE                = $03030000;
   {$EXTERNALSYM BUF_AUDIO_LPCM_LE}
   BUF_AUDIO_WMAV1                  = $03040000;
   {$EXTERNALSYM BUF_AUDIO_WMAV1}
   BUF_AUDIO_DTS                    = $03050000;
   {$EXTERNALSYM BUF_AUDIO_DTS}
   BUF_AUDIO_MSADPCM                = $03060000;
   {$EXTERNALSYM BUF_AUDIO_MSADPCM}
   BUF_AUDIO_MSIMAADPCM             = $03070000;
   {$EXTERNALSYM BUF_AUDIO_MSIMAADPCM}
   BUF_AUDIO_MSGSM                  = $03080000;
   {$EXTERNALSYM BUF_AUDIO_MSGSM}
   BUF_AUDIO_VORBIS                 = $03090000;
   {$EXTERNALSYM BUF_AUDIO_VORBIS}
   BUF_AUDIO_IMC                    = $030a0000;
   {$EXTERNALSYM BUF_AUDIO_IMC}
   BUF_AUDIO_LH                     = $030b0000;
   {$EXTERNALSYM BUF_AUDIO_LH}
   BUF_AUDIO_VOXWARE                = $030c0000;
   {$EXTERNALSYM BUF_AUDIO_VOXWARE}
   BUF_AUDIO_ACELPNET               = $030d0000;
   {$EXTERNALSYM BUF_AUDIO_ACELPNET}
   BUF_AUDIO_AAC                    = $030e0000;
   {$EXTERNALSYM BUF_AUDIO_AAC}
   BUF_AUDIO_DNET                   = $030f0000;
   {$EXTERNALSYM BUF_AUDIO_DNET}
   BUF_AUDIO_VIVOG723               = $03100000;
   {$EXTERNALSYM BUF_AUDIO_VIVOG723}
   BUF_AUDIO_DK3ADPCM               = $03110000;
   {$EXTERNALSYM BUF_AUDIO_DK3ADPCM}
   BUF_AUDIO_DK4ADPCM               = $03120000;
   {$EXTERNALSYM BUF_AUDIO_DK4ADPCM}
   BUF_AUDIO_ROQ                    = $03130000;
   {$EXTERNALSYM BUF_AUDIO_ROQ}
   BUF_AUDIO_QTIMAADPCM             = $03140000;
   {$EXTERNALSYM BUF_AUDIO_QTIMAADPCM}
   BUF_AUDIO_MAC3                   = $03150000;
   {$EXTERNALSYM BUF_AUDIO_MAC3}
   BUF_AUDIO_MAC6                   = $03160000;
   {$EXTERNALSYM BUF_AUDIO_MAC6}
   BUF_AUDIO_QDESIGN1               = $03170000;
   {$EXTERNALSYM BUF_AUDIO_QDESIGN1}
   BUF_AUDIO_QDESIGN2               = $03180000;
   {$EXTERNALSYM BUF_AUDIO_QDESIGN2}
   BUF_AUDIO_QCLP                   = $03190000;
   {$EXTERNALSYM BUF_AUDIO_QCLP}
   BUF_AUDIO_SMJPEG_IMA             = $031A0000;
   {$EXTERNALSYM BUF_AUDIO_SMJPEG_IMA}
   BUF_AUDIO_VQA_IMA                = $031B0000;
   {$EXTERNALSYM BUF_AUDIO_VQA_IMA}
   BUF_AUDIO_MULAW                  = $031C0000;
   {$EXTERNALSYM BUF_AUDIO_MULAW}
   BUF_AUDIO_ALAW                   = $031D0000;
   {$EXTERNALSYM BUF_AUDIO_ALAW}
   BUF_AUDIO_GSM610                 = $031E0000;
   {$EXTERNALSYM BUF_AUDIO_GSM610}
   BUF_AUDIO_EA_ADPCM               = $031F0000;
   {$EXTERNALSYM BUF_AUDIO_EA_ADPCM}
   BUF_AUDIO_WMAV2                  = $03200000;
   {$EXTERNALSYM BUF_AUDIO_WMAV2}
   BUF_AUDIO_COOK                   = $03210000;
   {$EXTERNALSYM BUF_AUDIO_COOK}
   BUF_AUDIO_ATRK                   = $03220000;
   {$EXTERNALSYM BUF_AUDIO_ATRK}
   BUF_AUDIO_14_4                   = $03230000;
   {$EXTERNALSYM BUF_AUDIO_14_4}
   BUF_AUDIO_28_8                   = $03240000;
   {$EXTERNALSYM BUF_AUDIO_28_8}
   BUF_AUDIO_SIPRO                  = $03250000;
   {$EXTERNALSYM BUF_AUDIO_SIPRO}
   BUF_AUDIO_WMAV3                  = $03260000;
   {$EXTERNALSYM BUF_AUDIO_WMAV3}
   BUF_AUDIO_INTERPLAY              = $03270000;
   {$EXTERNALSYM BUF_AUDIO_INTERPLAY}
   BUF_AUDIO_XA_ADPCM               = $03280000;
   {$EXTERNALSYM BUF_AUDIO_XA_ADPCM}
   BUF_AUDIO_WESTWOOD               = $03290000;
   {$EXTERNALSYM BUF_AUDIO_WESTWOOD}
   BUF_AUDIO_DIALOGIC_IMA           = $032A0000;
   {$EXTERNALSYM BUF_AUDIO_DIALOGIC_IMA}
   BUF_AUDIO_NSF                    = $032B0000;
   {$EXTERNALSYM BUF_AUDIO_NSF}
   BUF_AUDIO_FLAC                   = $032C0000;
   {$EXTERNALSYM BUF_AUDIO_FLAC}
   BUF_AUDIO_DV                     = $032D0000;
   {$EXTERNALSYM BUF_AUDIO_DV}
   BUF_AUDIO_WMAV                   = $032E0000;
   {$EXTERNALSYM BUF_AUDIO_WMAV}

   BUF_SPU_BASE                     = $04000000;
   {$EXTERNALSYM BUF_SPU_BASE}
   BUF_SPU_DVD                      = $04000000;
   {$EXTERNALSYM BUF_SPU_DVD}
   BUF_SPU_TEXT                     = $04010000;
   {$EXTERNALSYM BUF_SPU_TEXT}
   BUF_SPU_CC                       = $04020000;
   {$EXTERNALSYM BUF_SPU_CC}
   BUF_SPU_DVB                      = $04030000;
   {$EXTERNALSYM BUF_SPU_DVB}
   BUF_SPU_SVCD                     = $04040000;
   {$EXTERNALSYM BUF_SPU_SVCD}
   BUF_SPU_CVD                      = $04050000;
   {$EXTERNALSYM BUF_SPU_CVD}
   BUF_SPU_OGM                      = $04060000;
   {$EXTERNALSYM BUF_SPU_OGM}

   BUF_DEMUX_BLOCK                  = $05000000;
   {$EXTERNALSYM BUF_DEMUX_BLOCK}

   BUF_FLAG_KEYFRAME                = $0001;
   {$EXTERNALSYM BUF_FLAG_KEYFRAME}
   BUF_FLAG_FRAME_START             = $0002;
   {$EXTERNALSYM BUF_FLAG_FRAME_START}
   BUF_FLAG_FRAME_END               = $0004;
   {$EXTERNALSYM BUF_FLAG_FRAME_END}
   BUF_FLAG_HEADER                  = $0008;
   {$EXTERNALSYM BUF_FLAG_HEADER}
   BUF_FLAG_PREVIEW                 = $0010;
   {$EXTERNALSYM BUF_FLAG_PREVIEW}
   BUF_FLAG_END_USER                = $0020;
   {$EXTERNALSYM BUF_FLAG_END_USER}
   BUF_FLAG_END_STREAM              = $0040;
   {$EXTERNALSYM BUF_FLAG_END_STREAM}
   BUF_FLAG_FRAMERATE               = $0080;
   {$EXTERNALSYM BUF_FLAG_FRAMERATE}
   BUF_FLAG_SEEK                    = $0100;
   {$EXTERNALSYM BUF_FLAG_SEEK}
   BUF_FLAG_SPECIAL                 = $0200;
   {$EXTERNALSYM BUF_FLAG_SPECIAL}
   BUF_FLAG_NO_VIDEO                = $0400;
   {$EXTERNALSYM BUF_FLAG_NO_VIDEO}
   BUF_FLAG_FRAMING                 = $0800;
   {$EXTERNALSYM BUF_FLAG_FRAMING}

   BUF_SPECIAL_PALETTE              = 1;
   {$EXTERNALSYM BUF_SPECIAL_PALETTE}
   BUF_SPECIAL_IDCIN_HUFFMAN_TABLE  = 2;
   {$EXTERNALSYM BUF_SPECIAL_IDCIN_HUFFMAN_TABLE}
   BUF_SPECIAL_ASPECT               = 3;
   {$EXTERNALSYM BUF_SPECIAL_ASPECT}
   BUF_SPECIAL_DECODER_CONFIG       = 4;
   {$EXTERNALSYM BUF_SPECIAL_DECODER_CONFIG}
   BUF_SPECIAL_STSD_ATOM            = 5;
   {$EXTERNALSYM BUF_SPECIAL_STSD_ATOM}
   BUF_SPECIAL_LPCM_CONFIG          = 6;
   {$EXTERNALSYM BUF_SPECIAL_LPCM_CONFIG}
   BUF_SPECIAL_SPU_DVD_SUBTYPE      = 8;

   {$EXTERNALSYM BUF_SPECIAL_SPU_DVD_SUBTYPE}
   SPU_DVD_SUBTYPE_CLUT             = 1;
   {$EXTERNALSYM SPU_DVD_SUBTYPE_CLUT}
   SPU_DVD_SUBTYPE_PACKAGE          = 2;
   {$EXTERNALSYM SPU_DVD_SUBTYPE_PACKAGE}
   SPU_DVD_SUBTYPE_SUBP_CONTROL     = 3;
   {$EXTERNALSYM SPU_DVD_SUBTYPE_SUBP_CONTROL}
   SPU_DVD_SUBTYPE_NAV              = 4;
   {$EXTERNALSYM SPU_DVD_SUBTYPE_NAV}

   BUF_SPECIAL_SPU_DVB_DESCRIPTOR   = 9;
   {$EXTERNALSYM BUF_SPECIAL_SPU_DVB_DESCRIPTOR}

   NAME_MAX                         = 256;
   {$EXTERNALSYM NAME_MAX}
   XINE_NAME_MAX                    = NAME_MAX;
   {$EXTERNALSYM XINE_NAME_MAX}
   PATH_MAX                         = 768;
   {$EXTERNALSYM PATH_MAX}
   XINE_PATH_MAX                    = PATH_MAX;
   {$EXTERNALSYM XINE_PATH_MAX}
   CONFIG_TYPE_UNKNOWN              = 0;
   {$EXTERNALSYM CONFIG_TYPE_UNKNOWN}
   CONFIG_TYPE_RANGE                = 1;
   {$EXTERNALSYM CONFIG_TYPE_RANGE}
   CONFIG_TYPE_STRING               = 2;
   {$EXTERNALSYM CONFIG_TYPE_STRING}
   CONFIG_TYPE_ENUM                 = 3;
   {$EXTERNALSYM CONFIG_TYPE_ENUM}
   CONFIG_TYPE_NUM                  = 4;
   {$EXTERNALSYM CONFIG_TYPE_NUM}
   CONFIG_TYPE_BOOL                 = 5;
   {$EXTERNALSYM CONFIG_TYPE_BOOL}

   DEMUXER_PLUGIN_IFACE_VERSION     = 21;
   {$EXTERNALSYM DEMUXER_PLUGIN_IFACE_VERSION}
   DEMUX_OK                         = 0;
   {$EXTERNALSYM DEMUX_OK}
   DEMUX_FINISHED                   = 1;
   {$EXTERNALSYM DEMUX_FINISHED}
   DEMUX_CANNOT_HANDLE              = 0;
   {$EXTERNALSYM DEMUX_CANNOT_HANDLE}
   DEMUX_CAN_HANDLE                 = 1;
   {$EXTERNALSYM DEMUX_CAN_HANDLE}

   METHOD_BY_CONTENT                = 1;
   {$EXTERNALSYM METHOD_BY_CONTENT}
   METHOD_BY_EXTENSION              = 2;
   {$EXTERNALSYM METHOD_BY_EXTENSION}
   METHOD_EXPLICIT                  = 3;
   {$EXTERNALSYM METHOD_EXPLICIT}

   DEMUX_CAP_NOCAP                  = $00000000;
   {$EXTERNALSYM DEMUX_CAP_NOCAP}
   DEMUX_CAP_AUDIOLANG              = $00000008;
   {$EXTERNALSYM DEMUX_CAP_AUDIOLANG}
   DEMUX_CAP_SPULANG                = $00000010;
   {$EXTERNALSYM DEMUX_CAP_SPULANG}

   DEMUX_OPTIONAL_UNSUPPORTED       = 0;
   {$EXTERNALSYM DEMUX_OPTIONAL_UNSUPPORTED}
   DEMUX_OPTIONAL_SUCCESS           = 1;
   {$EXTERNALSYM DEMUX_OPTIONAL_SUCCESS}
   DEMUX_OPTIONAL_DATA_AUDIOLANG    = 2;
   {$EXTERNALSYM DEMUX_OPTIONAL_DATA_AUDIOLANG}
   DEMUX_OPTIONAL_DATA_SPULANG      = 3;
   {$EXTERNALSYM DEMUX_OPTIONAL_DATA_SPULANG}

   INPUT_PLUGIN_IFACE_VERSION       = 13;
   {$EXTERNALSYM INPUT_PLUGIN_IFACE_VERSION}

   INPUT_CAP_NOCAP                  = $00000000;
   {$EXTERNALSYM INPUT_CAP_NOCAP}
   INPUT_CAP_SEEKABLE               = $00000001;
   {$EXTERNALSYM INPUT_CAP_SEEKABLE}
   INPUT_CAP_BLOCK                  = $00000002;
   {$EXTERNALSYM INPUT_CAP_BLOCK}
   INPUT_CAP_AUDIOLANG              = $00000008;
   {$EXTERNALSYM INPUT_CAP_AUDIOLANG}
   INPUT_CAP_SPULANG                = $00000010;
   {$EXTERNALSYM INPUT_CAP_SPULANG}
   INPUT_CAP_PREVIEW                = $00000040;
   {$EXTERNALSYM INPUT_CAP_PREVIEW}
   INPUT_CAP_CHAPTERS               = $00000080;
   {$EXTERNALSYM INPUT_CAP_CHAPTERS}

   INPUT_OPTIONAL_UNSUPPORTED       = 0;
   {$EXTERNALSYM INPUT_OPTIONAL_UNSUPPORTED}
   INPUT_OPTIONAL_SUCCESS           = 1;
   {$EXTERNALSYM INPUT_OPTIONAL_SUCCESS}
   INPUT_OPTIONAL_DATA_AUDIOLANG    = 2;
   {$EXTERNALSYM INPUT_OPTIONAL_DATA_AUDIOLANG}
   INPUT_OPTIONAL_DATA_SPULANG      = 3;
   {$EXTERNALSYM INPUT_OPTIONAL_DATA_SPULANG}
   INPUT_OPTIONAL_DATA_PREVIEW      = 7;
   {$EXTERNALSYM INPUT_OPTIONAL_DATA_PREVIEW}

   MAX_MRL_ENTRIES                  = 255;
   {$EXTERNALSYM MAX_MRL_ENTRIES}
   MAX_PREVIEW_SIZE                 = 4096;
   {$EXTERNALSYM MAX_PREVIEW_SIZE}

   mrl_unknown                      = $00000;
   {$EXTERNALSYM mrl_unknown}
   mrl_dvd                          = $00001;
   {$EXTERNALSYM mrl_dvd}
   mrl_vcd                          = $00002;
   {$EXTERNALSYM mrl_vcd}
   mrl_net                          = $00004;
   {$EXTERNALSYM mrl_net}
   mrl_rtp                          = $00008;
   {$EXTERNALSYM mrl_rtp}
   mrl_stdin                        = $00010;
   {$EXTERNALSYM mrl_stdin}
   mrl_cda                          = $00020;
   {$EXTERNALSYM mrl_cda}
   mrl_file                         = $00040;
   {$EXTERNALSYM mrl_file}
   mrl_file_fifo                    = $00080;
   {$EXTERNALSYM mrl_file_fifo}
   mrl_file_chardev                 = $00100;
   {$EXTERNALSYM mrl_file_chardev}
   mrl_file_directory               = $00200;
   {$EXTERNALSYM mrl_file_directory}
   mrl_file_blockdev                = $00400;
   {$EXTERNALSYM mrl_file_blockdev}
   mrl_file_normal                  = $00800;
   {$EXTERNALSYM mrl_file_normal}
   mrl_file_symlink                 = $01000;
   {$EXTERNALSYM mrl_file_symlink}
   mrl_file_sock                    = $02000;
   {$EXTERNALSYM mrl_file_sock}
   mrl_file_exec                    = $04000;
   {$EXTERNALSYM mrl_file_exec}
   mrl_file_backup                  = $08000;
   {$EXTERNALSYM mrl_file_backup}
   mrl_file_hidden                  = $10000;
   {$EXTERNALSYM mrl_file_hidden}

   PREBUFFER_PTS_OFFSET             = 12000;
   {$EXTERNALSYM PREBUFFER_PTS_OFFSET}
   DISC_STREAMSTART                 = 0;
   {$EXTERNALSYM DISC_STREAMSTART}
   DISC_RELATIVE                    = 1;
   {$EXTERNALSYM DISC_RELATIVE}
   DISC_ABSOLUTE                    = 2;
   {$EXTERNALSYM DISC_ABSOLUTE}
   DISC_STREAMSEEK                  = 3;
   {$EXTERNALSYM DISC_STREAMSEEK}

   METRONOM_AV_OFFSET               = 2;
   {$EXTERNALSYM METRONOM_AV_OFFSET}
   METRONOM_ADJ_VPTS_OFFSET         = 3;
   {$EXTERNALSYM METRONOM_ADJ_VPTS_OFFSET}
   METRONOM_FRAME_DURATION          = 4;
   {$EXTERNALSYM METRONOM_FRAME_DURATION}
   METRONOM_SPU_OFFSET              = 5;
   {$EXTERNALSYM METRONOM_SPU_OFFSET}

   CLOCK_SCR_ADJUSTABLE             = 1;
   {$EXTERNALSYM CLOCK_SCR_ADJUSTABLE}

   TEXT_PALETTE_SIZE                = 11;
   {$EXTERNALSYM TEXT_PALETTE_SIZE}
   OSD_TEXT1                        = 0*TEXT_PALETTE_SIZE;
   {$EXTERNALSYM OSD_TEXT1}
   OSD_TEXT2                        = 1*TEXT_PALETTE_SIZE;
   {$EXTERNALSYM OSD_TEXT2}
   OSD_TEXT3                        = 2*TEXT_PALETTE_SIZE;
   {$EXTERNALSYM OSD_TEXT3}
   OSD_TEXT4                        = 3*TEXT_PALETTE_SIZE;
   {$EXTERNALSYM OSD_TEXT4}
   OSD_TEXT5                        = 4*TEXT_PALETTE_SIZE;
   {$EXTERNALSYM OSD_TEXT5}
   OSD_TEXT6                        = 5*TEXT_PALETTE_SIZE;
   {$EXTERNALSYM OSD_TEXT6}
   OSD_TEXT7                        = 6*TEXT_PALETTE_SIZE;
   {$EXTERNALSYM OSD_TEXT7}
   OSD_TEXT8                        = 7*TEXT_PALETTE_SIZE;
   {$EXTERNALSYM OSD_TEXT8}
   OSD_TEXT9                        = 8*TEXT_PALETTE_SIZE;
   {$EXTERNALSYM OSD_TEXT9}
   OSD_TEXT10                       = 9*TEXT_PALETTE_SIZE;
   {$EXTERNALSYM OSD_TEXT10}

   NUMBER_OF_TEXT_PALETTES              = 4;
   {$EXTERNALSYM NUMBER_OF_TEXT_PALETTES}
   TEXTPALETTE_WHITE_BLACK_TRANSPARENT  = 0;
   {$EXTERNALSYM TEXTPALETTE_WHITE_BLACK_TRANSPARENT}
   TEXTPALETTE_WHITE_NONE_TRANSPARENT   = 1;
   {$EXTERNALSYM TEXTPALETTE_WHITE_NONE_TRANSPARENT}
   TEXTPALETTE_WHITE_NONE_TRANSLUCID    = 2;
   {$EXTERNALSYM TEXTPALETTE_WHITE_NONE_TRANSLUCID}
   TEXTPALETTE_YELLOW_BLACK_TRANSPARENT = 3;
   {$EXTERNALSYM TEXTPALETTE_YELLOW_BLACK_TRANSPARENT}

   DECODER_MAX                      = 256;
   {$EXTERNALSYM DECODER_MAX}
   PLUGIN_MAX                       = 256;
   {$EXTERNALSYM PLUGIN_MAX}
   PLUGINS_PER_TYPE                 = 10;
   {$EXTERNALSYM PLUGINS_PER_TYPE}

   CACHE_CATALOG_VERSION            = 2;
   {$EXTERNALSYM CACHE_CATALOG_VERSION}
   CACHE_CATALOG_FILE               = '.xine/catalog.cache';
   {$EXTERNALSYM CACHE_CATALOG_FILE}
   CACHE_CATALOG_DIR                = '.xine';
   {$EXTERNALSYM CACHE_CATALOG_DIR}
   POST_PLUGIN_IFACE_VERSION        = 2;
   {$EXTERNALSYM POST_PLUGIN_IFACE_VERSION}
   SPU_DECODER_IFACE_VERSION        = 14;
   {$EXTERNALSYM SPU_DECODER_IFACE_VERSION}
   SPU_OUT_IFACE_VERSION            = 1;
   {$EXTERNALSYM SPU_OUT_IFACE_VERSION}

   VIDEO_DECODER_IFACE_VERSION      = 14;
   {$EXTERNALSYM VIDEO_DECODER_IFACE_VERSION}
   VO_PROP_INTERLACED               = 0;
   {$EXTERNALSYM VO_PROP_INTERLACED}
   VO_PROP_ASPECT_RATIO             = 1;
   {$EXTERNALSYM VO_PROP_ASPECT_RATIO}
   VO_PROP_HUE                      = 2;
   {$EXTERNALSYM VO_PROP_HUE}
   VO_PROP_SATURATION               = 3;
   {$EXTERNALSYM VO_PROP_SATURATION}
   VO_PROP_CONTRAST                 = 4;
   {$EXTERNALSYM VO_PROP_CONTRAST}
   VO_PROP_BRIGHTNESS               = 5;
   {$EXTERNALSYM VO_PROP_BRIGHTNESS}
   VO_PROP_COLORKEY                 = 6;
   {$EXTERNALSYM VO_PROP_COLORKEY}
   VO_PROP_AUTOPAINT_COLORKEY       = 7;
   {$EXTERNALSYM VO_PROP_AUTOPAINT_COLORKEY}
   VO_PROP_ZOOM_X                   = 8;
   {$EXTERNALSYM VO_PROP_ZOOM_X}
   VO_PROP_PAN_SCAN                 = 9;
   {$EXTERNALSYM VO_PROP_PAN_SCAN}
   VO_PROP_TVMODE                   = 10;
   {$EXTERNALSYM VO_PROP_TVMODE}
   VO_PROP_MAX_NUM_FRAMES           = 11;
   {$EXTERNALSYM VO_PROP_MAX_NUM_FRAMES}
   VO_PROP_ZOOM_Y                   = 13;
   {$EXTERNALSYM VO_PROP_ZOOM_Y}
   VO_PROP_DISCARD_FRAMES           = 14;
   {$EXTERNALSYM VO_PROP_DISCARD_FRAMES}
   VO_NUM_PROPERTIES                = 15;
   {$EXTERNALSYM VO_NUM_PROPERTIES}

   VO_ZOOM_STEP                     = 100;
   {$EXTERNALSYM VO_ZOOM_STEP}
   VO_ZOOM_MAX                      = 400;
   {$EXTERNALSYM VO_ZOOM_MAX}
   VO_ZOOM_MIN                      = 100;
   {$EXTERNALSYM VO_ZOOM_MIN}

   OVL_PALETTE_SIZE                 = 256;
   {$EXTERNALSYM OVL_PALETTE_SIZE}
   VO_NUM_RECENT_FRAMES             = 2;
   {$EXTERNALSYM VO_NUM_RECENT_FRAMES}

   ASPECT_AUTO                      = 0;
   {$EXTERNALSYM ASPECT_AUTO}
   ASPECT_ANAMORPHIC                = 1;
   {$EXTERNALSYM ASPECT_ANAMORPHIC}
   ASPECT_FULL                      = 2;
   {$EXTERNALSYM ASPECT_FULL}
   ASPECT_DVB                       = 3;
   {$EXTERNALSYM ASPECT_DVB}
   ASPECT_SQUARE                    = 4;
   {$EXTERNALSYM ASPECT_SQUARE}
   NUM_ASPECT_RATIOS                = 5;
   {$EXTERNALSYM NUM_ASPECT_RATIOS}
   VO_TOP_FIELD                     = 1;
   {$EXTERNALSYM VO_TOP_FIELD}
   VO_BOTTOM_FIELD                  = 2;
   {$EXTERNALSYM VO_BOTTOM_FIELD}
   VO_BOTH_FIELDS                   = VO_TOP_FIELD;
   {$EXTERNALSYM VO_BOTH_FIELDS}
   VO_PREDICTION_FLAG               = 4;
   {$EXTERNALSYM VO_PREDICTION_FLAG}
   VO_CAP_COPIES_IMAGE              = $00000001;
   {$EXTERNALSYM VO_CAP_COPIES_IMAGE}
   VO_CAP_YV12                      = $00000002;
   {$EXTERNALSYM VO_CAP_YV12}
   VO_CAP_YUY2                      = $00000004;
   {$EXTERNALSYM VO_CAP_YUY2}
   VO_CAP_HUE                       = $00000010;
   {$EXTERNALSYM VO_CAP_HUE}
   VO_CAP_SATURATION                = $00000020;
   {$EXTERNALSYM VO_CAP_SATURATION}
   VO_CAP_BRIGHTNESS                = $00000040;
   {$EXTERNALSYM VO_CAP_BRIGHTNESS}
   VO_CAP_CONTRAST                  = $00000080;
   {$EXTERNALSYM VO_CAP_CONTRAST}
   VO_CAP_COLORKEY                  = $00000100;
   {$EXTERNALSYM VO_CAP_COLORKEY}
   VO_CAP_AUTOPAINT_COLORKEY        = $00000200;
   {$EXTERNALSYM VO_CAP_AUTOPAINT_COLORKEY}

   VIDEO_OUT_DRIVER_IFACE_VERSION   = 14;
   {$EXTERNALSYM VIDEO_OUT_DRIVER_IFACE_VERSION}
   MAX_OBJECTS                      = 50;
   {$EXTERNALSYM MAX_OBJECTS}
   MAX_EVENTS                       = 50;
   {$EXTERNALSYM MAX_EVENTS}
   MAX_SHOWING                      = 5;
   {$EXTERNALSYM MAX_SHOWING}

   OVERLAY_EVENT_NULL               = 0;
   {$EXTERNALSYM OVERLAY_EVENT_NULL}
   OVERLAY_EVENT_SHOW               = 1;
   {$EXTERNALSYM OVERLAY_EVENT_SHOW}
   OVERLAY_EVENT_HIDE               = 2;
   {$EXTERNALSYM OVERLAY_EVENT_HIDE}
   OVERLAY_EVENT_MENU_BUTTON        = 3;
   {$EXTERNALSYM OVERLAY_EVENT_MENU_BUTTON}
   OVERLAY_EVENT_FREE_HANDLE        = 8;
   {$EXTERNALSYM OVERLAY_EVENT_FREE_HANDLE}

   XINE_MAX_EVENT_LISTENERS         = 50;
   {$EXTERNALSYM XINE_MAX_EVENT_LISTENERS}
   XINE_MAX_EVENT_TYPES             = 100;
   {$EXTERNALSYM XINE_MAX_EVENT_TYPES}
   XINE_VERSION_CODE                = XINE_MAJOR_VERSION*10000+XINE_MINOR_VERSION*100+XINE_SUB_VERSION;
   {$EXTERNALSYM XINE_VERSION_CODE}
   XINE_LOG_MSG                     = 0;
   {$EXTERNALSYM XINE_LOG_MSG}
   XINE_LOG_PLUGIN                  = 1;
   {$EXTERNALSYM XINE_LOG_PLUGIN}
   XINE_LOG_NUM                     = 2;
//   {$EXTERNALSYM XINE_LOG_NUM}
   XINE_STREAM_INFO_MAX             = 99;
   {$EXTERNALSYM XINE_STREAM_INFO_MAX}
   XINE_EVENT_PIDS_CHANGE           = $80000000;
   {$EXTERNALSYM XINE_EVENT_PIDS_CHANGE}
   PLUGIN_NONE                      = 0;
   {$EXTERNALSYM PLUGIN_NONE}
   PLUGIN_INPUT                     = 1;
   {$EXTERNALSYM PLUGIN_INPUT}
   PLUGIN_DEMUX                     = 2;
   {$EXTERNALSYM PLUGIN_DEMUX}
   PLUGIN_AUDIO_DECODER             = 3;
   {$EXTERNALSYM PLUGIN_AUDIO_DECODER}
   PLUGIN_VIDEO_DECODER             = 4;
   {$EXTERNALSYM PLUGIN_VIDEO_DECODER}
   PLUGIN_SPU_DECODER               = 5;
   {$EXTERNALSYM PLUGIN_SPU_DECODER}
   PLUGIN_AUDIO_OUT                 = 6;
   {$EXTERNALSYM PLUGIN_AUDIO_OUT}
   PLUGIN_VIDEO_OUT                 = 7;
   {$EXTERNALSYM PLUGIN_VIDEO_OUT}
   PLUGIN_POST                      = 8;
   {$EXTERNALSYM PLUGIN_POST}
   PLUGIN_MUST_PRELOAD              = 128;
   {$EXTERNALSYM PLUGIN_MUST_PRELOAD}
   PLUGIN_TYPE_MASK                 = 127;
   {$EXTERNALSYM PLUGIN_TYPE_MASK}
   MM_ACCEL_MLIB                    = $00000001;
   {$EXTERNALSYM MM_ACCEL_MLIB}
   MM_ACCEL_X86_MMX                 = $80000000;
   {$EXTERNALSYM MM_ACCEL_X86_MMX}
   MM_ACCEL_X86_3DNOW               = $40000000;
   {$EXTERNALSYM MM_ACCEL_X86_3DNOW}
   MM_ACCEL_X86_MMXEXT              = $20000000;
   {$EXTERNALSYM MM_ACCEL_X86_MMXEXT}
   MM_ACCEL_X86_SSE                 = $10000000;
   {$EXTERNALSYM MM_ACCEL_X86_SSE}
   MM_ACCEL_X86_SSE2                = $08000000;
   {$EXTERNALSYM MM_ACCEL_X86_SSE2}
   MM_ACCEL_PPC_ALTIVEC             = $04000000;
   {$EXTERNALSYM MM_ACCEL_PPC_ALTIVEC}
   MM_MMX                           = MM_ACCEL_X86_MMX;
   {$EXTERNALSYM MM_MMX}
   MM_3DNOW                         = MM_ACCEL_X86_3DNOW;
   {$EXTERNALSYM MM_3DNOW}
   MM_MMXEXT                        = MM_ACCEL_X86_MMXEXT;
   {$EXTERNALSYM MM_MMXEXT}
   MM_SSE                           = MM_ACCEL_X86_SSE;
   {$EXTERNALSYM MM_SSE}
   MM_SSE2                          = MM_ACCEL_X86_SSE2;
   {$EXTERNALSYM MM_SSE2}
   SCALEFACTOR                      = 65536;
   {$EXTERNALSYM SCALEFACTOR}
   CENTERSAMPLE                     = 128;
   {$EXTERNALSYM CENTERSAMPLE}
   T_ERROR                          = -1;
   {$EXTERNALSYM T_ERROR}
   T_EOF                            = 0;
   {$EXTERNALSYM T_EOF}
   T_EOL                            = 1;
   {$EXTERNALSYM T_EOL}
   T_SEPAR                          = 2;
   {$EXTERNALSYM T_SEPAR}
   T_M_START_1                      = 3;
   {$EXTERNALSYM T_M_START_1}
   T_M_START_2                      = 4;
   {$EXTERNALSYM T_M_START_2}
   T_M_STOP_1                       = 5;
   {$EXTERNALSYM T_M_STOP_1}
   T_M_STOP_2                       = 6;
   {$EXTERNALSYM T_M_STOP_2}
   T_EQUAL                          = 7;
   {$EXTERNALSYM T_EQUAL}
   T_QUOTE                          = 8;
   {$EXTERNALSYM T_QUOTE}
   T_STRING                         = 9;
   {$EXTERNALSYM T_STRING}
   T_IDENT                          = 10;
   {$EXTERNALSYM T_IDENT}
   T_DATA                           = 11;
   {$EXTERNALSYM T_DATA}
   T_C_START                        = 12;
   {$EXTERNALSYM T_C_START}
   T_C_STOP                         = 13;
   {$EXTERNALSYM T_C_STOP}
   T_TI_START                       = 14;
   {$EXTERNALSYM T_TI_START}
   T_TI_STOP                        = 15;
   {$EXTERNALSYM T_TI_STOP}
   T_DOCTYPE_START                  = 16;
   {$EXTERNALSYM T_DOCTYPE_START}
   T_DOCTYPE_STOP                   = 17;
   {$EXTERNALSYM T_DOCTYPE_STOP}
   XML_PARSER_CASE_INSENSITIVE      = 0;
   {$EXTERNALSYM XML_PARSER_CASE_INSENSITIVE}
   XML_PARSER_CASE_SENSITIVE        = 1;
   {$EXTERNALSYM XML_PARSER_CASE_SENSITIVE}
   XML_PARSER_OK                    = 0;
   {$EXTERNALSYM XML_PARSER_OK}
   XML_PARSER_ERROR                 = 1;
   {$EXTERNALSYM XML_PARSER_ERROR}
{$ENDIF}

type

   { xine.h records and type definitions }

   Puint32_t = ^uint32_t;
   Puint8_t = ^uint8_t;
   Pxine_t = ^xine_s;
   Pxine_stream_t = ^xine_stream_s;
   Pxine_audio_port_t = ^xine_audio_port_s;
   Pxine_video_port_t = ^xine_video_port_s;
   PPxine_audio_port_t = ^Pxine_audio_port_t;
   PPxine_video_port_t = ^Pxine_video_port_t;
   Pxine_ao_driver_t = Pxine_audio_port_t;
   Pxine_vo_driver_t = Pxine_video_port_t;
   Pxine_video_frame_t = ^xine_video_frame_s;
   Pxine_audio_frame_t = ^xine_audio_frame_s;
   xine_video_frame_s = record
      vpts: int64_t;
      duration: int64_t;
      width, height: Integer;
      colorspace: Integer;
      aspect_ratio: Double;
      pos_stream: Integer;
      pos_time: Integer;
      data: Puint8_t;
      xine_frame: Pointer;
   end;
   xine_audio_frame_s = record
      vpts: int64_t;
      num_samples: Integer;
      sample_rate: Integer;
      num_channels: Integer;
      bits_per_sample: Integer;
      pos_stream: off_t;
      pos_time: Integer;
      data: Puint8_t;
      xine_frame: Pointer;
   end;
   Pxine_post_t = ^xine_post_s;
   xine_post_s = record
      audio_input: ^Pxine_audio_port_t;
      video_input: ^Pxine_video_port_t;
      typ: Integer;
   end;
   Pxine_post_in_t = ^xine_post_in_s;
   Pxine_post_out_t = ^xine_post_out_s;
   xine_post_in_s = record
      name: PChar;
      typ: Integer;
      data: Pointer;
   end;
   xine_post_out_s = record
      name: PChar;
      typ: Integer;
      data: Pointer;
      rewire: function(self: Pxine_post_out_t; data: Pointer):Integer; cdecl;
   end;
   xine_log_cb_t = procedure (user_data:Pointer; section: Integer);
   xine_mrl_s = record
      origin: PChar;
      mrl: PChar;
      link: PChar;
      typ: uint32_t;
      size: off_t;
   end;
   Pxine_mrl_t = ^xine_mrl_s;
   PPxine_mrl_t = ^Pxine_mrl_t;
   x11_rectangle_t = record
      x,y,w,h: Integer;
   end;
   
   x11_visual_s = record
      display : PDisplay;
      screen : Integer;
      
      d: TWindow;
      user_data:Pointer;
      dest_size_cb : procedure(user_data:Pointer;
         video_width,video_height: Integer;
         video_pixel_aspect: Double;
         dest_width,dest_height:PInteger;
         dest_pixel_aspect: PDouble);
         cdecl;
      frame_output_cb : procedure (user_data:Pointer;
         video_width, video_height: Integer;
         video_pixel_aspect: Double;
         dest_x, dest_y, dest_width, dest_height: PInteger;
         dest_pixel_aspect: PDouble;
         win_x, win_y:PInteger);
         cdecl;
   end;
   x11_visual_t = x11_visual_s;
   fb_visual_s = record
      frame_output_cb : procedure (user_data:Pointer;
         video_width, video_height: Integer;
         video_pixel_aspect: Double;
         dest_x, dest_y, dest_width, dest_height: PInteger;
         dest_pixel_aspect: PDouble;
         win_x, win_y:PInteger);
         cdecl;
      user_data: Pointer;
   end;
   fb_visual_t = fb_visual_s;
   xine_health_check_s = record
      status : Integer;
      cdrom_dev, dvd_dev, msg, title, explanation : PChar;
   end;
   Pxine_health_check_t = ^xine_health_check_s;
   Pxine_cfg_entry_t = ^xine_cfg_entry_s;
   xine_config_cb_t = procedure (user_data:Pointer; entry: Pxine_cfg_entry_t);
      cdecl;
   xine_cfg_entry_s = record
      key: PChar;
      typ: Integer;
      unknown_value: PChar;
      str_value, str_default, str_sticky: PChar;
      num_value, num_default: Integer;
      range_min, range_max: Integer;
      enum_values: PPChar;
      description, help: PChar;
      exp_level: Integer;
      callback: xine_config_cb_t;
      callback_data: Pointer;
   end;
   xine_event_t = record
      typ: Integer;
      stream: Pxine_stream_t;
      data: Pointer;
      data_length: Integer;
      tv: timeval;
   end;
   Pxine_event_t = ^xine_event_t;
   xine_input_data_t = record
      event: xine_event_t;
      button: uint8_t;
      x,y: uint16_t;
   end;
   Pxine_input_data_t = ^xine_input_data_t;
   xine_ui_data_t = record
      num_buttons: Integer;
      str_len: Integer;
      str: array[0..255] of Char;
   end;
   Pxine_ui_data_t = ^xine_ui_data_t;
   xine_ui_message_data_s = record
      compatibility: xine_ui_data_t;
      typ: Integer;
      explanation: Integer;
      num_parameters: Integer;
      parameters: Integer;
      message: array[0..0] of Char;
   end;
   Pxine_ui_message_data_t = ^xine_ui_message_data_s;
   xine_format_change_data_t = record
      width, height, aspect: Integer;
   end;
   Pxine_format_change_data_t = ^xine_format_change_data_t;
   xine_audio_level_data_t = record
      left, right: Integer;
   end;
   Pxine_audio_level_data_t = ^xine_audio_level_data_t;
   xine_progress_data_t = record
      description: PChar;
      percent: Integer;
   end;
   Pxine_progress_data_t = ^xine_progress_data_t;
   xine_mrl_reference_data_s = record
      alternative: Integer;
      mrl: array[0..0] of Char;
   end;
   Pxine_mrl_reference_data_t = ^xine_mrl_reference_data_s;
{$IFDEF XINE_ENABLE_EXPERIMENTAL_FEATURES}
   xine_set_v4l2_data_s = record
      inpt, channel, radio: Integer;
      frequency, transmission, framerate_numerator, framerate_denominator,
         framelines: uint32_t;
      stardard_id: uint64_t;
      colorstandard, colorsubcarrier: uint32_t;
      frame_width, frame_height: Integer;
      spare: array[0..19] of uint32_t;
      session_id: int32_t;
   end;
   Pxine_set_v4l2_data_t = ^xine_set_v4l2_data_s;
   xine_set_mpeg_data_s = record
      bitrate_vbr, bitrate_mean, bitrate_peak, gop_size, gop_closure,
         b_frames, aspect_ratio: Integer;
      spare: array[0..19] of uint32_t;
   end;
   Pxine_set_mpeg_data_t = ^xine_set_mpeg_data_s;
   xine_pvr_save_data_s = record
      mode, id: Integer;
      name: array[0..255] of Char;
   end;
   xine_pvr_realtime_s = record
      mode: Integer;
   end;
   xine_pvr_pause_s = record
      mode: Integer;
   end;
   Pxine_pvr_save_data_t = ^xine_pvr_save_data_s;
   Pxine_pvr_realtime_t = ^xine_pvr_realtime_s;
   Pxine_pvr_pause_t = ^xine_pvr_pause_s;
{$ENDIF}
   Pxine_event_queue_t = ^xine_event_queue_s;
   xine_event_listener_cb_t = procedure (user_data: Pointer;
      event: Pxine_event_t); cdecl;
   Pxine_osd_t = ^xine_osd_s;
   xine_tvsystem = ( XINE_TVSYSTEM_PAL, XINE_TVSYSTEM_NTSC );

   { non xine.h records and type definitions }

   Pxine_list_t = ^xine_list_s;
   Pmetronom_clock_t = ^metronom_clock_s;
   Pmetronom_t = ^metronom_s;
   Pplugin_catalog_t = ^plugin_catalog_s;
   Pscratch_buffer_t = ^scratch_buffer_s;
   Pinput_plugin_t = ^input_plugin_s;
   Pinput_class_t = ^input_class_s;
   Pdemux_plugin_t = ^demux_plugin_s;
   Pvo_driver_t = ^vo_driver_s;
   Pfifo_buffer_t = ^fifo_buffer_s;
   Pvideo_decoder_t = ^video_decoder_s;
   Plrb_t = ^lrb_s;
   Paudio_decoder_t = ^audio_decoder_s;
   Pspu_functions_t = ^spu_functions_s;
   Pspu_decoder_class_t = ^spu_decoder_class_s;
   Pspu_decoder_t = ^spu_decoder_s;
   Posd_renderer_t = ^osd_renderer_s;
   Pao_driver_t = ^ao_driver_s;
   Paudio_decoder_class_t = ^audio_decoder_s;
   Paudio_fifo_t = Pointer;
   Puint16_t = ^uint16_t;
   Paudio_buffer_t = ^audio_buffer_s;
   Paudio_driver_class_t = ^audio_driver_class_s;
   Pextra_info_t = ^extra_info_s;
   Pbuf_element_t = ^buf_element_s;
   Pxine_bmiheader = ^xine_bmiheader;
   Pxine_waveformatex = ^xine_waveformatex;
   Pcfg_entry_t = ^cfg_entry_s;
   Pconfig_values_t = ^config_values_s;
   Pdemux_class_t = ^demux_class_s;
   Pscr_plugin_t = ^scr_plugin_s;
   PPscr_plugin_t = ^Pscr_plugin_t;
   Posd_object_t = ^osd_object_s;
   Posd_font_t = Pointer;
   Posd_ft2context_t = Pointer;
   Pplugin_node_t = ^plugin_node_s;
   Ppost_class_t = ^post_class_s;
   Ppost_plugin_t = ^post_plugin_s;
   Ppost_video_port_t = ^post_video_port_s;
   Ppost_audio_port_t = ^post_audio_port_s;
   Pint16_t = ^int16_t;
   Pspu_info_t = ^spu_info_s;
   Pvideo_decoder_class_t = ^video_decoder_class_s;
   Pvo_frame_t = ^vo_frame_s;
   Pimg_buf_fifo_t = ^img_buf_fifo_s;
   Pvo_overlay_t = ^vo_overlay_s;
   Pvideo_overlay_instance_t = ^video_overlay_instance_s;
   Prle_elem_t = ^rle_elem_s;
   Pvo_button_t = ^vo_button_s;
   Pvideo_overlay_object_t = ^video_overlay_object_s;
   Pvideo_overlay_event_t = ^video_overlay_event_s;
   Pvo_scale_rect_t = ^vo_scale_rect_s;
   Pvo_scale_t = ^vo_scale_s;
   PPuint8_t = ^Puint8_t;
   Pvo_driver_class_t = ^vo_driver_class_s;
   Pplugin_info_t = ^plugin_info_s;
   Pint8_t = ^int8_t;
   Pxine_node_t = ^xine_node_s;
   Ppthread_mutex_t = ^pthread_mutex_t;
   Ppthread_mutexattr_t = ^pthread_mutexattr_t;
   Pxine_mutex_t = ^xine_mutex_t;
   Pxml_property_s = ^xml_property_s;
   Pxml_node_s = ^xml_node_s;
   PPxml_node_s = ^Pxml_node_s;
   Pyuv_planes_t = ^yuv_planes_s;

   audio_decoder_class_s = record
      open_plugin: function(this: Paudio_decoder_class_t;
         stream: Pxine_stream_t):Paudio_decoder_t; cdecl;
      get_identifier: function(this: Paudio_decoder_class_t):PChar; cdecl;
      get_desciption: function(this:Paudio_decoder_class_t):PChar; cdecl;
      dispose: procedure(this:Paudio_decoder_class_t); cdecl;
   end;
   audio_decoder_s = record
      decode_data: procedure(this: Paudio_decoder_t;
         buf: Pbuf_element_t); cdecl;
      reset: procedure(this: Paudio_decoder_t); cdecl;
      discontinuity: procedure(this: Paudio_decoder_t); cdecl;
      dispose: procedure(this: Paudio_decoder_t); cdecl;
      node: Pointer;
   end;
   audio_buffer_s = record
      next: Paudio_buffer_t;
      mem: ^int16_t;
      mem_size, num_frames: Integer;
      vpts: int64_t;
      frame_header_count, frame_access_unit: uint32_t;
      extra_info: Pextra_info_t;
      stream: Pxine_stream_t;
   end;
   ao_format_s = record
      bits, rate : uint32_t;
      mode: Integer;
   end;
   ao_format_t = ao_format_s;
   ao_driver_s = record
      get_capabilities : function (this:Pao_driver_t):uint32_t; cdecl;
      open : function(this:Pao_driver_t; bits,rate:uint32_t;mode:Integer):Integer;
         cdecl;
      num_channels : function (self_gen:Pao_driver_t):Integer; cdecl;
      bytes_per_frame: function (self_gen:Pao_driver_t):Integer; cdecl;
      delay: function (self_gen:Pao_driver_t):Integer; cdecl;
      get_gap_tolerance: function  (self_gen:Pao_driver_t):Integer; cdecl;
      write: function (this:Pao_driver_t; audio_data:Puint16_t;
         num_samples: uint32_t):Integer; cdecl;
      close: procedure (this:Pao_driver_t); cdecl;
      exit: procedure (this:Pao_driver_t); cdecl;
      get_property: function (this:Pao_driver_t; prop:Integer):Integer;  cdecl;
      set_property: function (this:Pao_driver_t; prop,value:Integer):Integer;
         cdecl;
      control: function (this:Pao_driver_t; cmd: Integer):Integer; cdecl;
      node: Pointer;
   end;
   xine_audio_port_s = record
      get_capabilities: function(this: Pxine_audio_port_t):uint32_t; cdecl;
      get_property: function(this:Pxine_audio_port_t;
         prop: Integer):Integer; cdecl;
      set_property: function(this:Pxine_audio_port_t;
         prop, value: Integer):Integer; cdecl;
      open: function(this: Pxine_audio_port_t; stream: Pxine_stream_t;
         bits, rate: uint32_t; mode: Integer):Integer; cdecl;
      get_buffer: function(this: Pxine_audio_port_t):Paudio_buffer_t; cdecl;
      put_buffer: procedure(this: Pxine_audio_port_t;
         buf: Paudio_buffer_t; stream: Pxine_stream_t);cdecl;
      close: procedure(this: Pxine_audio_port_t; stream: Pxine_stream_t);cdecl;
      exit: procedure(this: Pxine_audio_port_t);cdecl;
      control: function(this:Pxine_audio_port_t; cmd: Integer):Integer; cdecl;
      flush: procedure(this: Pxine_audio_port_t);cdecl;
      driver: Pao_driver_t;
      driver_lock: pthread_mutex_t;
      clock: Pmetronom_clock_t;
      xine: Pxine_t;
      streams: Pxine_list_t;
      streams_lock: pthread_mutex_t;
      audio_loop_running, audio_paused: Integer;
      audio_thread: pthread_t;
      audio_step: Integer;
      frames_per_kpts: int32_t;
      input, output: ao_format_t;
      frame_rate_factor: Double;
      resample_conf, force_rate, do_resample, gap_tolerance: Integer;
      free_fifo, out_fifo: Paudio_fifo_t;
      last_audio_vpts: int64_t;
      frame_buf: array[0..1] of Paudio_buffer_t;
      zero_space: int16_t;
      passthrough_offset: int64_t;
      flush_audio_driver, allow_full_ao_fill_gap, do_compress: Integer;
      compression_factor, compression_factor_max: Double;
   end;
   audio_driver_class_s = record
     open_plugin: function(this: Paudio_driver_class_t;
        data: Pointer): Pao_driver_t;cdecl;
     get_identifier: function(this: Paudio_driver_class_t):PChar; cdecl;
     get_description: function(this: Paudio_driver_class_t):PChar; cdecl;
     dispose: procedure(this: Paudio_driver_class_t); cdecl;
   end;

   img_buf_fifo_s = record
      first: Pvo_frame_t;
      last: Pvo_frame_t;
      num_buffers, locked_for_read: Integer;
      mutex: pthread_mutex_t;
      not_empty: pthread_cond_t;
   end;
   vo_frame_s = record
      free: procedure(vo_img: Pvo_frame_t);cdecl;
      copy: procedure(vo_img: Pvo_frame_t; src: PPuint8_t );cdecl;
      field: procedure(vo_img: Pvo_frame_t; which_field:Integer); cdecl;
      draw: function(vo_img: Pvo_frame_t; stream: Pxine_stream_t):Integer;
         cdecl;
      displayed: procedure(vo_img: Pvo_frame_t);cdecl;
      dispose: procedure(vo_img: Pvo_frame_t);cdecl;
      pts, vpts: int64_t;
      bad_frame, duration: Integer;
      base: array[0..2] of Puint8_t;
      pitches: array[0..2] of Integer;
      top_field_first, repeat_first_field: Integer;
      pan_scan_x, pan_scan_y: Integer;
      width, height, ratio, format, drawn, copy_called: Integer;
      port: Pxine_video_port_t;
      driver: Pvo_driver_t;
      next: Pvo_frame_t;
      lock_counter: Integer;
      mutex: pthread_mutex_t;
      id, is_first: Integer;
   end;
   xine_video_port_s = record
      get_capabilities: function(this: Pxine_video_port_t):uint32_t; cdecl;
      open: function(this: Pxine_video_port_t; stream: Pxine_stream_t;
         bits, rate: uint32_t; mode: Integer):Integer; cdecl;
      get_frame: function(this: Pxine_video_port_t; width, height: uint32_t;
         ratio_code, format, flags: Integer):Pvo_frame_t; cdecl;
      get_last_frame: function(this: Pxine_video_port_t):Pvo_frame_t; cdecl;
      enable_ovl: procedure(this: Pxine_video_port_t; ovl_enable: Integer);
         cdecl;
      close: procedure(this: Pxine_video_port_t; stream: Pxine_stream_t);cdecl;
      exit: procedure(this: Pxine_video_port_t);cdecl;
      get_overlay_instance: function(this: Pxine_video_port_t):
         Pvideo_overlay_instance_t; cdecl;
      flush: procedure(this: Pxine_video_port_t);cdecl;
      driver: Pvo_driver_t;
   end;
   vo_driver_s = record
      get_capabilities : function(self : Pvo_driver_t) : uint32_t; cdecl;
      alloc_frame : function(self :Pvo_driver_t): Pvo_frame_t; cdecl;
      update_frame_format : procedure (self : Pvo_driver_t; img : Pvo_frame_t;
         width, height :uint32_t; ratio_code, format, flags : Integer); cdecl;
      display_frame : procedure (self : Pvo_driver_t; img : Pvo_frame_t); cdecl;
      overlay_begin: procedure (self : Pvo_driver_t; img : Pvo_frame_t;
         changed: Integer); cdecl;
      overlay_blend : procedure (self : Pvo_driver_t; img : Pvo_frame_t;
         overlay : Pvo_overlay_t); cdecl;
      overlay_end: procedure (self : Pvo_driver_t;
         img : Pvo_frame_t); cdecl;
      get_property : function (self : Pvo_driver_t; prop : Integer) : Integer;
         cdecl;
      set_property : function (self : Pvo_driver_t;
         prop, value : Integer) : Integer; cdecl;
      get_property_min_max : function (self : Pvo_driver_t; prop: Integer;
         min,max :PInteger) : Integer; cdecl;
      gui_data_exchange : function (self : Pvo_driver_t; data_type: Integer;
         data : Pointer):Integer; cdecl;
      redraw_needed : function (self : Pvo_driver_t): Integer; cdecl;
      dispose : procedure (self : Pvo_driver_t); cdecl;
      node: Pointer;
   end;
   vo_driver_class_s = record
      open_plugin: function(this: Pvo_driver_class_t;
         visual: Pointer):Pvo_driver_class_t; cdecl;
      get_identifier: function(this: Pvo_driver_class_t):PChar; cdecl;
      get_desciption: function(this:Pvo_driver_class_t):PChar; cdecl;
      dispose: procedure(this:Pvo_driver_class_t); cdecl;
   end;
   rle_elem_s = record
      len, color: uint16_t;
   end;
   vo_overlay_s = record
      rle: Prle_elem_t;
      data_size, num_rle, x, y, width, height: Integer;
      color: array[0..256-1] of uint32_t;
      trans: array[0..256-1] of uint8_t;
      rgb_clut, clip_top, clip_bottom, clip_left, clip_right: Integer;
      clip_color: array[0..256-1] of uint32_t;
      clip_trans: array[0..256-1] of uint8_t;
      clip_rgb_clut: Integer;
   end;
   video_overlay_instance_s = record
      init: procedure(this_gen: Pvideo_overlay_instance_t);cdecl;
      dispose: procedure(this_gen: Pvideo_overlay_instance_t);cdecl;
      get_handle: function(this_gen: Pvideo_overlay_instance_t;
         object_type:Integer):int32_t; cdecl;
      free_handle: procedure(this_gen: Pvideo_overlay_instance_t;
         handle: int32_t); cdecl;
      add_event: function(this_gen: Pvideo_overlay_instance_t;
         event: Pointer):int32_t; cdecl;
      flush_events: procedure(this_gen: Pvideo_overlay_instance_t);cdecl;
      redraw_needed: function(this_gen: Pvideo_overlay_instance_t;
         vpts: int64_t):Integer; cdecl;
      multiple_overlay_blend: procedure(this_gen: Pvideo_overlay_instance_t;
         vpts: int64_t; output: Pvo_driver_t; vo_img: Pvo_frame_t;
         enabled: Integer); cdecl;
   end;

   buf_element_s = record
      next: Pbuf_element_t;
      mem, content: PChar;
      size, max_size: int32_t;
      typ: uint32_t;
      pts, disc_off: int64_t;
      input_pos, input_length: off_t;
      input_time: Integer;
      decoder_flags: uint32_t;
      decoder_info: array[0..3] of uint32_t;
      free_buffer: procedure( buf: Pbuf_element_t); cdecl;
      source: Pointer;
   end;
   spu_dvb_descriptor = record
      lang: array[0..3] of Char;
      comp_page_id: Integer;
      aux_page_id: Integer;
   end;
   palette_entry_s = record
      r,g,b: uint8_t;
   end;
   Tfifo_buffer_cb_t = procedure(fifo: Pfifo_buffer_t; buf: Pbuf_element_t;
         data_cb: Pointer);cdecl;
   fifo_buffer_s = record
      first, last: Pbuf_element_t;
      fifo_size: Integer;
      mutex: pthread_mutex_t;
      not_empty: pthread_cond_t;
      put: procedure ( fifo: Pfifo_buffer_t; buf: Pbuf_element_t); cdecl;
      get: function (fifo: Pfifo_buffer_t):Pbuf_element_t; cdecl;
      clear: procedure (fifo: Pfifo_buffer_t); cdecl;
      size: function (fifo: Pfifo_buffer_t):Integer; cdecl;
      dispose: procedure (fifo: Pfifo_buffer_t); cdecl;
      buffer_pool_alloc: function (this: Pfifo_buffer_t):Pbuf_element_t; cdecl;
      buffer_pool_try_alloc:function(this:Pfifo_buffer_t):Pbuf_element_t;cdecl;
      insert: procedure(fifo: Pfifo_buffer_t; buf: Pbuf_element_t); cdecl;
      register_put_cb: procedure(fifo: Pfifo_buffer_t; cb: Tfifo_buffer_cb_t;
        cb_data: Pointer); cdecl;
      register_get_cb: procedure(fifo: Pfifo_buffer_t; cb: Tfifo_buffer_cb_t;
        cb_data: Pointer); cdecl;
      buffer_pool_top: Pbuf_element_t;
      buffer_pool_mutex: pthread_mutex_t;
      buffer_pool_cond_not_empty: pthread_cond_t;
      buffer_pool_num_empty: Integer;
      buffer_pool_capacity: Integer;
      buffer_pool_buf_size: Integer;
      buffer_pool_base: Pointer;
      put_cb: Tfifo_buffer_cb_t;
      get_cb: Tfifo_buffer_cb_t;
      put_cb_data: Pointer;
      get_cb_data: Pointer;
   end;
   xine_bmiheader = record
      biSize: int32_t;
      biWidth: int32_t;
      biHeight: int32_t;
      biPlanes: int16_t;
      biBitCount: int16_t;
      biCompression: uint32_t;
      biSizeImage: int32_t;
      biXPelsPerMeter: int32_t;
      biYPelsPerMeter: int32_t;
      biClrUsed: int32_t;
      biClrImportant: int32_t;
   end;
   xine_waveformatex = record
      wFormatTag: int16_t;
      nChannels: int16_t;
      nSamplesPerSec: int32_t;
      nAvgBytesPerSec: int32_t;
      nBlockAlign: int32_t;
      wBitsPerSample: int16_t;
      cbSize:int16_t;
   end;

   cfg_entry_s = record
      next : Pcfg_entry_t;
      config : Pconfig_values_t;
      key : PChar;
      typ : Integer;
      unknown_value : Pchar;
      str_value : PChar;
      str_default : Pchar;
      str_sticky : PChar;
      num_value : Integer;
      num_default : Integer;
      range_min : Integer;
      range_max : Integer;
      enum_values : PPChar;
      description : PChar;
      help : PChar;
      exp_level: Integer;
      callback : xine_config_cb_t;
      callback_data : Pointer;
   end;
   config_values_s = record
      register_string : function(self : Pconfig_values_t;
         key,def_value,description,help: Pchar;
         exp_level: Integer; changed_cb :xine_config_cb_t;
         cb_data: Pointer): PChar; cdecl;
      register_range : function(self : Pconfig_values_t;
         key :PChar; def_value, min, max : Integer; description, help : PChar;
         exp_level: Integer; changed_cb :xine_config_cb_t;
         cb_data: Pointer):Integer; cdecl;
      register_enum : function (self : Pconfig_values_t;
         key :PChar; def_value: Integer; values : PPChar;
         description, help:PChar; exp_level: Integer;
         changed_cb :xine_config_cb_t; cb_data: Pointer):Integer; cdecl;
      register_num : function (self : Pconfig_values_t;
         key :PChar; def_value: Integer; description, help :PChar;
         exp_level: Integer; changed_cb :xine_config_cb_t;
         cb_data: Pointer):Integer; cdecl;
      register_bool :function (self : Pconfig_values_t;
         key :PChar; def_value: Integer; description, help :PChar;
         exp_level: Integer; changed_cb :xine_config_cb_t;
         cb_data: Pointer):Integer; cdecl;
      update_num :procedure(self : Pconfig_values_t; key: Pchar; value: Integer);
         cdecl;
      update_string :procedure (self : Pconfig_values_t; key, value: Pchar);
         cdecl;
      parse_enum : function (str :Pchar; values: PPchar): Integer; cdecl;
      lookup_entry : function (self : Pconfig_values_t;key:Pchar): Pcfg_entry_t;
         cdecl;
      unregister_callback: procedure (self : Pconfig_values_t; key : PChar);
         cdecl;
      dispose: procedure (self : Pconfig_values_t); cdecl;
      first, last, curr : Pcfg_entry_t;
      config_lock: pthread_mutex_t;
   end;

   demux_class_s = record
      open_plugin: function ( this: Pdemux_class_t; stream: Pxine_stream_t;
         input: Pinput_plugin_t): Pdemux_plugin_t; cdecl;
      get_description: function( this: Pdemux_class_t): PChar; cdecl;
      get_identifier: function( this: Pdemux_class_t): PChar; cdecl;
      get_mimetypes: function( this: Pdemux_class_t): PChar; cdecl;
      get_extensions: function( this: Pdemux_class_t): PChar; cdecl;
      dispose: procedure( this: Pdemux_class_t ); cdecl;
   end;
   demux_plugin_s = record
      send_headers: procedure ( this : Pdemux_plugin_t); cdecl;
      seek: function ( this: Pdemux_plugin_t; start_pos: off_t;
         start_time: Integer):Integer; cdecl;
      send_chunk: function ( this: Pdemux_plugin_t ): Integer; cdecl;
      dispose: procedure ( this: Pdemux_plugin_t ); cdecl;
      get_status: function ( this: Pdemux_plugin_t): Integer; cdecl;
      get_stream_length: function (this: Pdemux_plugin_t): Integer; cdecl;
      get_video_frame: function ( this: Pdemux_plugin_t; timestamp: Integer;
         width, height, ratio_code, duration, format: PInteger;
         img: Puint8_t):Integer; cdecl;
      got_video_frame_cb: procedure ( this: Pdemux_plugin_t;
         frame: Pvo_frame_t); cdecl;
      get_capabilities: function(this: Pdemux_plugin_t):uint32_t; cdecl;
      get_optional_data: function(this: Pdemux_plugin_t; data: Pointer;
         data_type: Integer):Integer; cdecl;
      demux_class: Pdemux_class_t;
   end;

   input_class_s = record
      open_plugin: function ( this: Pinput_class_t; stream: Pxine_stream_t;
         mrl: PChar): Pinput_plugin_t; cdecl;
      get_identifier: function( this: Pinput_class_t): PChar; cdecl;
      get_description: function( this: Pinput_class_t): PChar; cdecl;
      get_dir: function( this: Pinput_class_t; filename: PChar;
         nFiles: PInteger): PPxine_mrl_t; cdecl;
      get_autoplay_list: function( this: Pinput_class_t;
         num_files: Integer): PPChar; cdecl;
      dispose: procedure( this: Pinput_class_t ); cdecl;
      eject_media: function( this: Pinput_class_t ):Integer; cdecl;
   end;
   input_plugin_s = record
      get_capabilities: function(this: Pinput_plugin_t):uint32_t; cdecl;
      read: function(this: Pinput_plugin_t; buf: PChar; nlen: off_t):off_t;
         cdecl;
      read_plugin: function(this: Pinput_plugin_t; fifo: Pfifo_buffer_t;
         len: off_t): Pbuf_element_t; cdecl;
      seek: function(this: Pinput_plugin_t; offset: off_t;
         origin: Integer):off_t; cdecl;
      get_current_pos: function(this: Pinput_plugin_t):off_t; cdecl;
      get_length: function(this: Pinput_plugin_t):off_t; cdecl;
      get_blocksize: function(this: Pinput_plugin_t):uint32_t; cdecl;
      get_mrl: function(this: Pinput_plugin_t):PChar; cdecl;
      get_optional_data: function(this: Pinput_plugin_t; data: Pointer;
         data_type: Integer):Integer; cdecl;
      dispose: procedure(this: Pinput_plugin_t); cdecl;
      input_class: Pinput_class_t;
   end;

   lrb_s = record
     max_num_entries, cur_num_entries: Integer;
     newest, oldest: Pbuf_element_t;
     fifo: Pfifo_buffer_t;
   end;

   metronom_s = record
      set_audio_rate: procedure(this: Pmetronom_t; pts_per_sample: int64_t);
         cdecl;
      got_video_frame: procedure(this: Pmetronom_t; frame: Pvo_frame_t);
         cdecl;
      got_audio_samples: function(this: Pmetronom_t; pts: int64_t;
         nsamples: Integer):int64_t; cdecl;
      got_spu_packet: function(this: Pmetronom_t; pts: int64_t):int64_t;
         cdecl;
      handle_audio_discontinuity: procedure(this: Pmetronom_t; typ: Integer;
         disc_off: int64_t); cdecl;
      handle_video_discontinuity: procedure(this: Pmetronom_t; typ: Integer;
         disc_off: int64_t); cdecl;
      set_option: procedure(this: Pmetronom_t; option: Integer;
         value: int64_t); cdecl;
      get_option: function(this: Pmetronom_t; option: Integer):int64_t; cdecl;
      exit: procedure(this: Pmetronom_t); cdecl;
      stream: Pxine_stream_t;
      clock: Pmetronom_clock_t;
      pts_per_sample, video_vpts, spu_vpts, audio_vpts, vpts_offset,
         video_drift, video_drift_step: int64_t;
      audio_samples: Integer;
      audio_drift_step, av_offset: int64_t;
      lock: pthread_mutex_t;
      have_audio, video_discontinuity_count, audio_discontinuity_count,
         discontinuity_handled_count: Integer;
      video_discontinuity_reached, audio_discontinuity_reached,
         cancel: pthread_cond_t;
      force_video_jump, force_audio_jump: Integer;
      img_duration: int64_t;
      img_cpt: Integer;
      last_video_pts: int64_t;
   end;
   metronom_clock_s = record
      set_option: procedure(this: Pmetronom_clock_t; option: Integer;
         value: int64_t); cdecl;
      get_option: function(this: Pmetronom_clock_t;
         option: Integer):int64_t; cdecl;
      start_clock: procedure(this: Pmetronom_clock_t; pts: int64_t); cdecl;
      stop_clock: procedure(this: Pmetronom_clock_t); cdecl;
      resume_clock: procedure(this: Pmetronom_clock_t); cdecl;
      get_current_time: function(this: Pmetronom_clock_t):int64_t; cdecl;
      adjust_clock: procedure(this: Pmetronom_clock_t;
         desired_pts: int64_t); cdecl;
      set_speed: function(this: Pmetronom_clock_t; speed: Integer):Integer;
         cdecl;
      register_scr: function(this: Pmetronom_clock_t;
         scr: Pscr_plugin_t): Integer; cdecl;
      unregister_scr: procedure(this: Pmetronom_clock_t; scr: Pscr_plugin_t);
         cdecl;
      exit: procedure(this: Pmetronom_clock_t); cdecl;
      scr_master: Pscr_plugin_t;
      scr_list: PPscr_plugin_t;
      sync_thread: pthread_t;
      thread_running, scr_adjustable: Integer;
      speed: Integer;
      lock: pthread_mutex_t;
      cancel: pthread_cond_t;
   end;
   scr_plugin_s = record
      inteface_version: Integer;
      get_priority: function(this: Pscr_plugin_t):Integer; cdecl;
      set_speed: function(this: Pscr_plugin_t; speed: Integer):Integer;
         cdecl;
      adjust: procedure(this: Pscr_plugin_t; vpts: int64_t); cdecl;
      start: procedure(this: Pscr_plugin_t; start_vpts: int64_t); cdecl;
      get_current: function(this: Pscr_plugin_t):int64_t; cdecl;
      exit: procedure(this: Pscr_plugin_t); cdecl;
      clock: Pmetronom_clock_t;
   end;

   plugin_node_s = record
      filename: PChar;
      info: Pplugin_info_t;
      plugin_class: Pointer;
      ref: Integer;
      filesize: off_t;
      filemtime: time_t;
   end;
   plugin_catalog_s = record
      input, demux, spu, audio, video, aout, vout, post, cache: Pxine_list_t;
      audio_decoder_map : array[0..256-1,0..10-1] of
         Pplugin_node_t;
      video_decoder_map : array[0..256-1,0..10-1] of
         Pplugin_node_t;
      spu_decoder_map : array[0..256-1,0..10-1] of
         Pplugin_node_t;
      ids: array[0..10-1] of PChar;
      lock: pthread_mutex_t;
   end;

   post_class_s = record
      open_plugin: function(this: Ppost_class_t; inputs: Integer;
         audio_target: PPxine_audio_port_t;
         video_target: PPxine_video_port_t):Ppost_plugin_t; cdecl;
      get_identifier: function(this: Ppost_class_t):PChar; cdecl;
      get_description: function(this: Ppost_class_t):PChar; cdecl;
      dispose: procedure(this: Ppost_class_t); cdecl;
   end;
   post_plugin_s = record
      xine_post: xine_post_s;
      input, output: Pxine_list_t;
      dispose: procedure(this: Ppost_plugin_t); cdecl;
      input_ids, output_ids: PPChar;
      node: Pointer;
   end;
   post_video_port_s = record
      port: xine_video_port_s;
      original_port: Pxine_video_port_t;
      frame: vo_frame_s;
      post: Ppost_plugin_t;
   end;
   post_audio_port_s = record
      port: xine_audio_port_s;
      original_port: Pxine_audio_port_t;
      post: Ppost_plugin_t;
   end;

   scratch_buffer_s = record
      scratch_printf: procedure(this: Pscratch_buffer_t; format: PChar;
         ap: Pointer); cdecl;
      get_content: function(this: Pscratch_buffer_t):PPChar; cdecl;
      dispose: procedure(this: Pscratch_buffer_t); cdecl;
      lines, ordered: PPChar;
      num_lines, cur: Integer;
   end;

   spu_decoder_class_s = record
      open_plugin: function(this: Pspu_decoder_class_t;
         stream: Pxine_stream_t):Pspu_decoder_t; cdecl;
      get_identifier: function(this: Pspu_decoder_class_t):PChar; cdecl;
      get_description: function(this: Pspu_decoder_class_t):PChar; cdecl;
      dispose: procedure(this: Pspu_decoder_class_t); cdecl;
   end;
   spu_decoder_s = record
      decode_data: procedure ( this: Pspu_decoder_t;
         buf: Pbuf_element_t); cdecl;
      reset: procedure ( this: Pspu_decoder_t); cdecl;
      discontinuity: procedure ( this: Pspu_decoder_t); cdecl;
      dispose: procedure ( this: Pspu_decoder_t); cdecl;
      get_interact_info: function (this: Pspu_decoder_t;
         data: Pointer): Integer; cdecl;
      set_button: procedure (this: Pspu_decoder_t;
         button, mode: int32_t); cdecl;
      node: Pointer;
   end;

   spu_functions_s = record
      get_capabilities: function(this: Pspu_functions_t):uint32_t;cdecl;
      connect: procedure (this: Pspu_functions_t; metronom: Pmetronom_t); cdecl;
      open: function ( this: Pspu_functions_t; bits, rate: uint32_t;
         mode: Integer): Integer; cdecl;
      write_spu_data: procedure (this: Pspu_functions_t; spu_data: Pint16_t;
         num_samples: uint32_t; pts: int64_t); cdecl;
      close: procedure (this: Pspu_functions_t); cdecl;
      exit: procedure (this: Pspu_functions_t); cdecl;
      get_property : function (self : Pspu_functions_t;
         prop : Integer) : Integer; cdecl;
      set_property : function (self : Pspu_functions_t;
         prop, value : Integer) : Integer; cdecl;
   end;
   spu_info_s = record
      interface_version: Integer;
      id: PChar;
      description: PChar;
      priority: Integer;
   end;

   video_decoder_class_s = record
      open_plugin: function(this: Pvideo_decoder_class_t;
         stream: Pxine_stream_t):Pvideo_decoder_t; cdecl;
      get_identifier: function(this: Pvideo_decoder_class_t):PChar; cdecl;
      get_desciption: function(this:Pvideo_decoder_class_t):PChar; cdecl;
      dispose: procedure(this:Pvideo_decoder_class_t); cdecl;
   end;
   video_decoder_s = record
      decode_data: procedure ( this: Pvideo_decoder_t;
         buf: Pbuf_element_t); cdecl;
      reset: procedure ( this: Pvideo_decoder_t); cdecl;
      discontinuity: procedure ( this: Pvideo_decoder_t); cdecl;
      flush: procedure ( this: Pvideo_decoder_t); cdecl;
      dispose: procedure ( this: Pvideo_decoder_t); cdecl;
      node: Pointer;
   end;

   vo_button_s = record
      typ, clip_top, clip_bottom, clip_left, clip_right, up, down, left,
         right: int32_t;
      select_color: array[0..256] of uint32_t;
      select_trans: array[0..256] of uint8_t;
      select_event: xine_event_t;
      active_color: array[0..256] of uint32_t;
      active_trans: array[0..256] of uint8_t;
      active_event: xine_event_t;
      clip_rgb_clut: int32_t;
   end;
   video_overlay_object_s = record
      handle: int32_t;
      object_type: uint32_t;
      pts: int64_t;
      overlay: Pvo_overlay_t;
      plette_type: uint32_t;
      palette: Puint32_t;
      buttonN: int32_t;
      button: array[0..31] of vo_button_s;
   end;
   video_overlay_event_s = record
      event_type: uint32_t;
      vpts: int64_t;
      vo_object: video_overlay_object_s;
   end;

   osd_object_s = record
      next: Posd_object_t;
      renderer: Posd_renderer_t;
      width, height: Integer;
      area: Puint8_t;
      display_x, display_y: Integer;
      x1, y1, x2, y2 : Integer;
      color: array[0..256-1] of uint32_t;
      trans: array[0..256-1] of uint8_t;
      handle: int32_t;
      font: Posd_font_t;
   end;
   xine_osd_s = record
      osd: osd_object_s;
   end;
   osd_renderer_s = record
      new_object : function (self:Posd_renderer_t;
         width,height:Integer):Posd_object_t; cdecl;
      free_object : procedure (osd_to_close:Posd_object_t); cdecl;
      show : function (osd:Posd_object_t;vpts:int64_t ):Integer; cdecl;
      hide : function (osd:Posd_object_t;vpts:int64_t ):Integer; cdecl;
      line : procedure (osd:Posd_object_t;x1,y1,x2,y2,color: Integer );cdecl;
      filled_rect : procedure (osd:Posd_object_t;x1,y1,x2,y2,color: Integer  );
         cdecl;
      set_palette : procedure (osd:Posd_object_t; color: Puint32_t;
         trans: Puint8_t );cdecl;
      set_text_palette : procedure (osd: Posd_object_t;
         palette_number,color_base : Integer );cdecl;
      get_palette : procedure (osd:Posd_object_t; color: Puint32_t;
         trans: Puint8_t ); cdecl;
      set_position : procedure (osd:Posd_object_t; x,y: Integer); cdecl;
      set_font : function (osd:Posd_object_t; fontname: PChar;
         size: Integer):Integer; cdecl;
      render_text : function (osd:Posd_object_t; x1, y1: Integer;
         text: PChar; color_base: Integer):Integer; cdecl;
      get_text_size : function (osd:Posd_object_t; text:Pchar;
         width, height: PInteger):Integer;  cdecl;
      close : procedure (self:Posd_renderer_t); cdecl;
      clear : procedure (osd:Posd_object_t ); cdecl;
      draw_bitmap: procedure (osd: Posd_object_t; bitmap: Puint8_t;
         x1, y1, width, height: Integer; palette_map: Puint8_t); cdecl;
      osd_mutex: pthread_mutex_t;
      video_overlay: Pvideo_overlay_instance_t;
      event: video_overlay_event_s;
      osds: Posd_object_t;
      fonts: Posd_font_t;
      textpalette: Integer;
      config: Pconfig_values_t;
   end;

   vo_scale_rect_s = record
      x,y,w,h: Integer;
   end;
   vo_scale_s = record
      support_zoom, scaling_disabled, delivered_width, delivered_height,
         delivered_ratio_code, displayed_xoffset, displayed_yoffset,
         displayed_width, displayed_height: Integer;
      zoom_factor_x, zoom_factor_y : Double;
      user_ratio, gui_x, gui_y, gui_width, gui_height, gui_win_x,
         gui_win_y: Integer;
      gui_pixel_aspect, video_pixel_aspect: Double;
      output_width, output_height, output_xoffset, output_yoffset,
         force_redraw: Integer;
      user_data: Pointer;
      frame_output_cb : procedure (user_data:Pointer;
         video_width, video_height: Integer;
         video_pixel_aspect: Double;
         dest_x, dest_y, dest_width, dest_height: PInteger;
         dest_pixel_aspect: PDouble;
         win_x, win_y:PInteger);
         cdecl;
      dest_size_cb : procedure(user_data:Pointer;
         video_width,video_height: Integer;
         video_pixel_aspect: Double;
         dest_width,dest_height:PInteger;
         dest_pixel_aspect: PDouble);
         cdecl;
      border: array[0..3] of vo_scale_rect_s;
      output_horizontal_position, output_vertical_position: Double;
   end;

   xine_s = record
      config: Pconfig_values_t;
      plugin_catalog: Pplugin_catalog_t;
      demux_strategy:Integer;
      logbuffers: array[0..2-1] of Pscratch_buffer_t;
      verbosity: Integer;
      streams: Pxine_list_t;
      stream_lock: pthread_mutex_t;
      clock: Pmetronom_clock_t;
   end;
   extra_info_s = record
      input_pos, input_length: off_t;
      input_time: Integer;
      frame_number: uint32_t;
      seek_count: Integer;
      vpts: int64_t;
      invalid, total_time: Integer;
   end;
   xine_event_queue_s = record
      events: Pxine_list_t;
      lock: pthread_mutex_t;
      new_event: pthread_cond_t;
      stream: Pxine_stream_t;
      listener_thread: ^pthread_t;
      callback: xine_event_listener_cb_t;
      user_data: Pointer;
   end;
   xine_stream_s = record
      xine: Pxine_t;
      status: Integer;
      input_plugin: Pinput_plugin_t;
      eject_class: Pinput_class_t;
      content_detection_method: Integer;
      demux_plugin: Pdemux_plugin_t;
      metronom: Pmetronom_t;
      input_pos, input_length: off_t;
      input_time: Integer;
      video_out: Pxine_video_port_t;
      video_driver: Pvo_driver_t;
      video_fifo: Pfifo_buffer_t;
      video_thread: pthread_t;
      video_decoder_plugin: Pvideo_decoder_t;
      video_decoder_streamtype, video_in_discontinuity, video_channel: Integer;
      audio_out: Pxine_audio_port_t;
      audio_fifo: Pfifo_buffer_t;
      audio_temp: Plrb_t;
      audio_thread: pthread_t;
      audio_decoder_plugin: Paudio_decoder_t;
      audio_decoder_stream_type: Integer;
      audio_track_map: array[0..49] of uint32_t;
      audio_track_map_entries: Integer;
      audio_type: uint32_t;
      audio_channel_user, audio_channel_auto: Integer;
      spu_out: Pspu_functions_t;
      spu_thread: pthread_t;
      spu_decoder_plugin: Pspu_decoder_t;
      spu_decoder_streamtype, spu_channel_user, spu_channel_auto:Integer;
      spu_channel_letterbox, spu_channel_pan_scan, spu_channel:Integer;
      frontend_lock: pthread_mutex_t;
      osd_lock: pthread_mutex_t;
      osd_renderer: Posd_renderer_t;
      stream_info: array[0..99-1] of Integer;
      meta_info: array[0..99-1] of PChar;
      first_frame_flag: Integer;
      first_frame_lock: pthread_mutex_t;
      first_frame_reached: pthread_cond_t;
      counter_lock: pthread_mutex_t;
      counter_changed: pthread_cond_t;
      header_count_audio, header_count_video: Integer;
      finished_count_audio, finished_count_video: Integer;
      event_queues: Pxine_list_t;
      event_queues_lock: pthread_mutex_t;
      demux_thread: pthread_t;
      demux_thread_running: Integer;
      demux_lock: pthread_mutex_t;
      demux_action_pending: Integer;
      err: Integer;
      next_video_port: Pxine_video_port_t;
      next_audio_port: Pxine_audio_port_t;
      next_video_port_lock, next_audio_port_lock: pthread_mutex_t;
      next_video_port_wired, next_audio_port_wired: pthread_cond_t;
      metronom_prebuffer: int64_t;
   end;
   xine_pids_data_t = record
      vpid, apid: Integer;
   end;

   plugin_info_t = record
      typ, api: uint8_t;
      id: PChar;
      version: uint32_t;
      special_info: Pointer;
      init: procedure(xine: Pxine_t; data: Pointer); cdecl;
   end;
   vo_info_t = record
      priority, visual_type: Integer;
   end;
   ao_info_t = record
      priority: Integer;
   end;
   decoder_info_t = record
      supported_types: Puint32_t;
      priority: Integer;
   end;
   post_info_t = record
      typ: uint32_t;
   end;

   xine_mutex_t = record
      mutex: pthread_mutex_t;
      id: array[0..79] of Char;
      locked_by: PChar;
   end;

   xine_node_s = record
      next, prev: Pxine_node_t;
      content: Pointer;
      priority: Integer;
   end;
   xine_list_s = record
      first, last, cur: Pxine_node_t;
   end;
   yuv_planes_s = record
      y,u,v: PByte;
      row_width, row_count: Cardinal;
   end;

   plugin_info_s = record
      typ, API: uint8_t;
      id: PChar;
      version: uint32_t;
      special_info: Pointer;
      init: procedure(xine: Pxine_t; data: Pointer); cdecl;
   end;
   clut_t = record
      cb, cr, y, foo: uint8_t;
   end;

   xml_property_s = record
      name, value: PChar;
      next: Pxml_property_s;
   end;
   xml_node_s = record
      name, data: PChar;
      props: Pxml_property_s;
      child, next: Pxml_node_s;
   end;
   
   { xine.h procedures and functions }

   function  xine_open (stream: Pxine_stream_t; mrl: PChar): Integer;
      cdecl; external XINESHAREDLIB;

   function xine_get_version_string : PChar; cdecl; external XINESHAREDLIB;
   procedure xine_get_version(major, minor, sub : PInteger ); 
      cdecl; external XINESHAREDLIB;
   function xine_check_version(major, minor, sub: Integer):Integer; 
      cdecl; external XINESHAREDLIB;
   function xine_new : Pxine_t; cdecl; external XINESHAREDLIB;
   procedure xine_init (self: Pxine_t); cdecl; external XINESHAREDLIB;
   function xine_open_audio_driver (self: Pxine_t; id: PChar;
      data: Pointer): Pxine_audio_port_t; cdecl; external XINESHAREDLIB;
   function xine_open_video_driver (self: Pxine_t; id: PChar; visual: Integer;
      data: Pointer): Pxine_video_port_t; cdecl; external XINESHAREDLIB;
   procedure xine_close_audio_driver (self: Pxine_t;
      driver: Pxine_audio_port_t); cdecl; external XINESHAREDLIB;
   procedure xine_close_video_driver (self: Pxine_t;
      driver: Pxine_video_port_t); cdecl; external XINESHAREDLIB;
   procedure xine_exit(self: Pxine_t); cdecl; external XINESHAREDLIB;
   function xine_stream_new (self:Pxine_t; ao: Pxine_audio_port_t;
      vo: Pxine_video_port_t):Pxine_stream_t; cdecl; external XINESHAREDLIB;
   function xine_stream_master_slave (master, slave: Pxine_stream_t;
      affection: Integer):Integer; cdecl; external XINESHAREDLIB;
   function xine_play (stream: Pxine_stream_t;
      start_pos, start_count: Integer): Integer; cdecl; external XINESHAREDLIB;
   function xine_trick_mode (stream: Pxine_stream_t;
      mode, value:Integer):Integer; cdecl; external XINESHAREDLIB;
   procedure xine_stop(stream: Pxine_stream_t); cdecl; external XINESHAREDLIB;
   procedure xine_close(stream: Pxine_stream_t); cdecl; external XINESHAREDLIB;
   function xine_eject(stream: Pxine_stream_t): Integer;
      cdecl; external XINESHAREDLIB;
   procedure xine_dispose(stream: Pxine_stream_t);
      cdecl; external XINESHAREDLIB;
   procedure xine_engine_set_param(self: Pxine_t; param, value:Integer);
      cdecl; external XINESHAREDLIB;
   function xine_engine_get_param(self: Pxine_t; param: Integer):Integer;
      cdecl; external XINESHAREDLIB;
   procedure xine_set_param(stream: Pxine_stream_t; param, value:Integer);
      cdecl; external XINESHAREDLIB;
   function xine_get_param(stream: Pxine_stream_t; param: Integer):Integer;
      cdecl; external XINESHAREDLIB;
   function xine_get_current_frame(stream: Pxine_stream_t;
      width, height, ratio_code, format: PInteger; img: Puint8_t): Integer;
      cdecl; external XINESHAREDLIB;
{$IFDEF XINE_ENABLE_EXPERIMENTAL_FEATURES}
   function xine_new_framegrab_video_port( self: Pxine_t):Pxine_video_port_t;
      cdecl; external XINESHAREDLIB;
   function xine_get_next_video_frame( port: Pxine_video_port_t;
      frame: Pxine_video_frame_t): Integer; cdecl; external XINESHAREDLIB;
   procedure xine_free_video_frame( port: Pxine_video_port_t;
      frame: Pxine_video_frame_t); cdecl; external XINESHAREDLIB;
   function xine_new_framegrab_audio_port( self: Pxine_t ):Pxine_audio_port_t;
      cdecl; external XINESHAREDLIB;
   function xine_get_next_audio_frame( port: Pxine_audio_port_t;
      frame: Pxine_video_audio_t): Integer; cdecl; external XINESHAREDLIB;
   procedure xine_free_audio_frame( port: Pxine_audio_port_t;
      frame: Pxine_audio_frame_t); cdecl; external XINESHAREDLIB;
   function xine_get_video_frame(self: Pxine_t; timestamp: Integer;
      width, height, ratio_code, duration, format: PInteger;
      img: Puint8_t):Integer; cdecl; external XINESHAREDLIB;
{$ENDIF}
   function xine_post_init(xine: Pxine_t; name: PChar; inputs: Integer;
      audio_target: PPxine_audio_port_t;
      video_target: PPxine_video_port_t):Pxine_post_t;
      cdecl; external XINESHAREDLIB;
   function xine_list_post_plugins(xine: Pxine_t):PPChar; 
      cdecl; external XINESHAREDLIB;
   function xine_list_post_plugins_typed(xine: Pxine_t; typ: Integer):PPChar;
      cdecl; external XINESHAREDLIB;
   function xine_post_list_inputs(self: Pxine_post_t):PPChar; 
      cdecl; external XINESHAREDLIB;
   function xine_post_list_outputs(self: Pxine_post_t):PPChar; 
      cdecl; external XINESHAREDLIB;
   function xine_post_input(self: Pxine_post_t; name: PChar):Pxine_post_in_t;
      cdecl; external XINESHAREDLIB;
   function xine_post_output(self: Pxine_post_t; name: PChar):Pxine_post_out_t;
      cdecl; external XINESHAREDLIB;
   function xine_post_wire(source: Pxine_post_out_t;
      target: Pxine_post_in_t):Integer; cdecl; external XINESHAREDLIB;
   function xine_post_wire_audio_t(source: Pxine_post_out_t; 
      target: Pxine_post_in_t):Integer; cdecl; external XINESHAREDLIB;
   function xine_get_video_source(stream: Pxine_stream_t):Pxine_post_out_t;
      cdecl; external XINESHAREDLIB;
   function xine_get_audio_source(stream: Pxine_stream_t):Pxine_post_out_t;
      cdecl; external XINESHAREDLIB;
   procedure xine_post_dispose(xine: Pxine_t; self: Pxine_post_t); 
      cdecl; external XINESHAREDLIB;
   function xine_get_log_section_count(self: Pxine_t):Integer;
      cdecl; external XINESHAREDLIB;
   function xine_get_names(self: Pxine_t): PPChar;
      cdecl; external XINESHAREDLIB;
   procedure xine_log(self: Pxine_t; buf: Integer; format: PChar);
       varargs; cdecl; external XINESHAREDLIB;
   function xine_get_log(self: Pxine_t; buf: Integer): PPChar;
      cdecl; external XINESHAREDLIB;
   procedure xine_register_log_cb(self: Pxine_t; cb: xine_log_cb_t;
      user_data: Pointer); cdecl; external XINESHAREDLIB;
   function xine_get_error(stream: Pxine_stream_t): Integer;
      cdecl; external XINESHAREDLIB;
   function xine_get_status(stream: Pxine_stream_t): Integer;
      cdecl; external XINESHAREDLIB;
   function xine_get_audio_lang(stream: Pxine_stream_t; channel: Integer;
      lang: PChar):Integer; cdecl; external XINESHAREDLIB;
   function xine_get_spu_lang(stream: Pxine_stream_t; channel: Integer;
      lang: PChar):Integer; cdecl; external XINESHAREDLIB;
   function xine_get_pos_length(stream: Pxine_stream_t;
      pos_stream, pos_time, length_time: PInteger):Integer;
      cdecl; external XINESHAREDLIB;
   function xine_get_stream_info(stream: Pxine_stream_t;
      info: Integer): uint32_t; cdecl; external XINESHAREDLIB;
   function xine_get_meta_info (stream: Pxine_stream_t;
      info: Integer): PChar; cdecl; external XINESHAREDLIB;
   function xine_get_browsable_input_plugin_ids(self: Pxine_t): PPChar;
      cdecl; external XINESHAREDLIB;
   function xine_get_browse_mrls(self: Pxine_t; plugin_id, start_mrl: PChar;
      num_mrls: Integer):PPxine_mrl_t; cdecl; external XINESHAREDLIB;
   function xine_get_autoplay_input_plugin_ids(self: Pxine_t):PPChar;
      cdecl; external XINESHAREDLIB;
   function xine_get_autoplay_mrls(self: Pxine_t; plugin_id: PChar;
      num_mrls: PInteger): PPChar; cdecl; external XINESHAREDLIB;
   function xine_get_file_extensions(self: Pxine_t):PChar;
      cdecl; external XINESHAREDLIB;
   function xine_get_mime_types(self: Pxine_t):PChar;
      cdecl; external XINESHAREDLIB;
   function xine_get_demux_for_mime_type(self: Pxine_t; mime_type:PChar):PChar;
      cdecl; external XINESHAREDLIB;   
   function xine_get_input_plugin_description(self: Pxine_t;
      plugin_id: PChar):PChar; cdecl; external XINESHAREDLIB;
   function xine_list_audio_output_plugins(self:Pxine_t):PPChar;
      cdecl; external XINESHAREDLIB;
   function xine_list_video_output_plugins(self:Pxine_t):PPChar;
      cdecl; external XINESHAREDLIB;
   function xine_gui_send_vo_data(stream: Pxine_stream_t; typ: Integer;
      data: Pointer): Integer; cdecl; external XINESHAREDLIB;
   function xine_port_send_gui_data(vo: Pxine_video_port_t; typ: Integer;
      data: Pointer): Integer; cdecl; external XINESHAREDLIB;
   function xine_health_check(chkptr: Pxine_health_check_t;
      check_num: Integer): Pxine_health_check_t;
      cdecl; external XINESHAREDLIB;
   function xine_config_register_string (self : Pxine_t;
      key,def_value,description,help: Pchar; exp_level: Integer;
      changed_cb: xine_config_cb_t;
      cb_data: Pointer): PChar; cdecl; external XINESHAREDLIB;
   function xine_config_register_range(self : Pxine_t;
      key :PChar; def_value, min, max : Integer; description, help : PChar;
      exp_level: Integer; changed_cb: xine_config_cb_t;
      cb_data: Pointer):Integer; cdecl; external XINESHAREDLIB;
   function xine_config_register_enum(self : Pxine_t;
      key :PChar; def_value: Integer; values : PPChar;
      description, help: PChar; exp_level: Integer;
      changed_cb: xine_config_cb_t;
      cb_data: Pointer):Integer; cdecl; external XINESHAREDLIB;
   function xine_config_register_num(self : Pxine_t;
      key :PChar; def_value: Integer; description, help :PChar;
      exp_level: Integer; changed_cb : xine_config_cb_t;
      cb_data: Pointer):Integer; cdecl; external XINESHAREDLIB;
   function xine_config_register_bool(self : Pxine_t;
      key :PChar; def_value: Integer; description, help :PChar;
      exp_level: Integer; changed_cb : xine_config_cb_t;
      cb_data: Pointer):Integer; cdecl; external XINESHAREDLIB;
   function xine_config_get_first_entry(self: Pxine_t;
      entry: Pxine_cfg_entry_t):Integer; cdecl; external XINESHAREDLIB;
   function xine_config_get_next_entry(self: Pxine_t;
      entry: Pxine_cfg_entry_t):Integer; cdecl; external XINESHAREDLIB;
   procedure xine_config_lookup_entry(self: Pxine_t; key: PChar;
      entry: Pxine_cfg_entry_t); cdecl; external XINESHAREDLIB;
   procedure xine_config_update_entry(self: Pxine_t;
      entry: Pxine_cfg_entry_t); cdecl; external XINESHAREDLIB;
   procedure xine_config_load(self: Pxine_t; cfg_filename: PChar);
      cdecl; external XINESHAREDLIB;
   procedure xine_config_save(self: Pxine_t; cfg_filename: PChar);
      cdecl; external XINESHAREDLIB;
   procedure xine_config_reset(self: Pxine_t); cdecl; external XINESHAREDLIB;
   function xine_event_new_queue(stream:Pxine_stream_t):Pxine_event_queue_t;
      cdecl; external XINESHAREDLIB;
   procedure xine_event_dispose_queue(queue: Pxine_event_queue_t);
      cdecl; external XINESHAREDLIB;
   function xine_event_get(queue: Pxine_event_queue_t):Pxine_event_t;
      cdecl; external XINESHAREDLIB;
   function xine_event_wait(queue: Pxine_event_queue_t):Pxine_event_t;
      cdecl; external XINESHAREDLIB;
   procedure xine_event_free(event: Pxine_event_t);
      cdecl; external XINESHAREDLIB;
   procedure xine_event_create_listener_thread(queue: Pxine_event_queue_t;
      callback: xine_event_listener_cb_t;
      user_data: Pointer); cdecl; external XINESHAREDLIB;
   procedure xine_event_send(stream: Pxine_stream_t;
      event: Pxine_event_t); cdecl; external XINESHAREDLIB;
   function xine_osd_new(self: Pxine_stream_t; x, y: Integer;
      width, height: Integer): Pxine_osd_t; cdecl; external XINESHAREDLIB;
   procedure xine_osd_draw_point(self: Pxine_osd_t;
      x, y, color: Integer); cdecl; external XINESHAREDLIB;
   procedure xine_osd_draw_line (self: Pxine_osd_t;
      x1, y1, x2, y2, color: Integer); cdecl; external XINESHAREDLIB;
   procedure xine_osd_draw_rect (self: Pxine_osd_t;
      x1, y1, x2, y2, color, filled: Integer ); cdecl; external XINESHAREDLIB;
   procedure xine_osd_draw_text (self: Pxine_osd_t;
      x1, y1: Integer; text: PChar; color_base: Integer);
      cdecl; external XINESHAREDLIB;
   procedure xine_osd_draw_bitmap (self: Pxine_osd_t; bitmap: Puint8_t;
      x1, y1, width, height: Integer; palette_map: Puint8_t); 
      cdecl; external XINESHAREDLIB;   
   procedure xine_osd_get_text_size (self: Pxine_osd_t;
      text: PChar; width, height: PInteger); cdecl; external XINESHAREDLIB;
   procedure xine_osd_set_font (self: Pxine_osd_t; fontname: PChar;
      size: Integer); cdecl; external XINESHAREDLIB;
   procedure xine_osd_set_position(self: Pxine_osd_t;
      x, y: Integer); cdecl; external XINESHAREDLIB;
   procedure xine_osd_show (self: Pxine_osd_t; vpts: int64_t);
      cdecl; external XINESHAREDLIB;
   procedure xine_osd_hide (self: Pxine_osd_t; vpts: int64_t);
      cdecl; external XINESHAREDLIB;
   procedure xine_osd_clear (self: Pxine_osd_t); cdecl; external XINESHAREDLIB;
   procedure xine_osd_free (self: Pxine_osd_t); cdecl; external XINESHAREDLIB;
   procedure xine_osd_set_palette (self: Pxine_osd_t;
      color: Puint32_t; trans: Puint8_t); cdecl; external XINESHAREDLIB;
   procedure xine_osd_set_text_palette (self: Pxine_osd_t;
      palette_number, color_base: Integer ); cdecl; external XINESHAREDLIB;
   procedure xine_osd_get_palette (self: Pxine_osd_t;
      color: Puint32_t; trans: Puint8_t); cdecl; external XINESHAREDLIB;
   function xine_tvmode_init (self: Pxine_t):Integer; 
      cdecl; external XINESHAREDLIB;
   function xine_tvmode_use (self: Pxine_t; use_tvmode: Integer):Integer;
      cdecl; external XINESHAREDLIB;
   procedure xine_tvmode_set_tvsystem(self: Pxine_t; system: xine_tvsystem);
      cdecl; external XINESHAREDLIB;
   function xine_tvmode_switch(self: Pxine_t; typ, width, height: Integer;
      fps: Double):Integer; cdecl; external XINESHAREDLIB;
   procedure xine_tvmode_size(self: Pxine_t; width, height: PInteger;
      pixelratio, fps: PDouble); cdecl; external XINESHAREDLIB;
   procedure xine_tvmode_exit(self: Pxine_t); cdecl; external XINESHAREDLIB;

   { non xine.h functions and procedures }

   function ao_new_port(xine: Pxine_t; driver: Pao_driver_t;
      grab_only: Integer):Pxine_audio_port_t; cdecl; external XINESHAREDLIB;

   function fifo_buffer_new(num_buffers: Integer;
      buffer_size: uint32_t): Pfifo_buffer_t; cdecl; external XINESHAREDLIB;
   function fourcc_to_buf_video(fourcc_int: uint32_t):uint32_t; 
      cdecl; external XINESHAREDLIB;
   function buf_video_name(buf_type: uint32_t):PChar; 
      cdecl; external XINESHAREDLIB;
   function formattag_to_buf_audio(formattag: uint32_t):uint32_t; 
      cdecl; external XINESHAREDLIB;
   function buf_audio_name(buf_type: uint32_t):PChar; 
      cdecl; external XINESHAREDLIB;
   procedure xine_bmiheader_le2me(bih: Pxine_bmiheader); 
      cdecl; external XINESHAREDLIB;
   procedure xine_waveformatex_le2me(wavex: Pxine_waveformatex); 
      cdecl; external XINESHAREDLIB;

   function xine_config_init: Pconfig_values_t; cdecl; external XINESHAREDLIB;
   function xine_config_change_opt( config: Pconfig_values_t;
      opt: PChar):Integer; cdecl; external XINESHAREDLIB;

   function lrb_new(max_num_entries: Integer; fifo: Pfifo_buffer_t):Plrb_t;
      cdecl; external XINESHAREDLIB;
   procedure lrb_drop(this: Plrb_t); cdecl; external XINESHAREDLIB;
   procedure lrb_add(this: Plrb_t; buf: Pbuf_element_t); 
      cdecl; external XINESHAREDLIB;
   procedure lrb_feedback(this: Plrb_t; fifo: Pfifo_buffer_t);
      cdecl; external XINESHAREDLIB;
   procedure lrb_flush(this: Plrb_t); cdecl; external XINESHAREDLIB;

   function metronome_init(have_audio: Integer;
      stream: Pxine_stream_t):Pmetronom_t; cdecl; external XINESHAREDLIB;
   function metronome_clock_init: Pmetronom_clock_t; 
      cdecl; external XINESHAREDLIB;

   function osd_renderer_init(video_overlay: Pvideo_overlay_instance_t;
      config: Pconfig_values_t): Posd_renderer_t; 
      cdecl; external XINESHAREDLIB;

   procedure scan_plugins(this: Pxine_t); cdecl; external XINESHAREDLIB;
   procedure dispose_plugins(this: Pxine_t); cdecl; external XINESHAREDLIB;

   function post_intercept_video_port(post: Ppost_plugin_t;
      port: Pxine_video_port_t):Pxine_video_port_t; 
      cdecl; external XINESHAREDLIB;
   procedure post_intercept_video_frame(frame: Pvo_frame_t;
      port: Ppost_video_port_t); cdecl; external XINESHAREDLIB;
   procedure post_restore_video_frame(frame: Pvo_frame_t;
      port: Ppost_video_port_t); cdecl; external XINESHAREDLIB;
   function post_intercept_audio_port(post: Ppost_plugin_t;
      port: Pxine_audio_port_t):Pxine_audio_port_t; 
      cdecl; external XINESHAREDLIB;

   procedure audio_out_resample_stereo(input_samples: Pint16_t;
      in_samples: uint32_t; output_samples: Pint16_t;
      out_samples: uint32_t); cdecl; external XINESHAREDLIB;
   procedure audio_out_resample_mono(input_samples: Pint16_t;
      in_samples: uint32_t; output_samples: Pint16_t;
      out_samples: uint32_t); cdecl; external XINESHAREDLIB;
   procedure audio_out_resample_4channel(input_samples: Pint16_t;
      in_samples: uint32_t; output_samples: Pint16_t;
      out_samples: uint32_t); cdecl; external XINESHAREDLIB;
   procedure audio_out_resample_5channel(input_samples: Pint16_t;
      in_samples: uint32_t; output_samples: Pint16_t;
      out_samples: uint32_t); cdecl; external XINESHAREDLIB;
   procedure audio_out_resample_6channel(input_samples: Pint16_t;
      in_samples: uint32_t; output_samples: Pint16_t;
      out_samples: uint32_t); cdecl; external XINESHAREDLIB;
   procedure audio_out_resample_8to16(input_samples: Pint8_t;
      output_samples: Pint16_t; samples: uint32_t);
      cdecl; external XINESHAREDLIB;
   procedure audio_out_resample_16to8(input_samples: Pint16_t;
      output_samples: Pint8_t; samples: uint32_t);
      cdecl; external XINESHAREDLIB;
   procedure audio_out_resample_monotostereo(input_samples: Pint16_t;
      output_samples: Pint16_t; frames: uint32_t);
      cdecl; external XINESHAREDLIB;
   procedure audio_out_resample_stereotomono(input_samples: Pint16_t;
      output_samples: Pint16_t; frames: uint32_t);
      cdecl; external XINESHAREDLIB;

   function new_scratch_buffer(num_lines: Integer):Pscratch_buffer_t;
      cdecl; external XINESHAREDLIB;

   function video_overlay_new_instance: Pvideo_overlay_instance_t;
      cdecl; external XINESHAREDLIB;
   function vo_new_port(xine: Pxine_t; driver: Pvo_driver_t;
      grabonly: Integer): Pxine_video_port_t;
      cdecl; external XINESHAREDLIB;

   procedure vo_scale_compute_ideal_size(self: Pvo_scale_t); 
      cdecl; external XINESHAREDLIB;
   procedure vo_scale_compute_output_size(self: Pvo_scale_t); 
      cdecl; external XINESHAREDLIB;
   function vo_scale_redraw_needed(self: Pvo_scale_t):Integer; 
      cdecl; external XINESHAREDLIB;
   procedure vo_scale_translate_gui2video(self: Pvo_scale_t; x,y: Integer;
      vid_x, vid_y: PInteger); cdecl; external XINESHAREDLIB;
   function vo_scale_aspect_ratio_name(a: Integer):PChar; 
      cdecl; external XINESHAREDLIB;
   procedure vo_scale_init(self: Pvo_scale_t;
      support_zoom, scaling_disabled: Integer; config: Pconfig_values_t);
      cdecl; external XINESHAREDLIB;

   function xine_buffer_init(chunk_size: Integer):Pointer; 
      cdecl; external XINESHAREDLIB;
   function _xine_buffer_free(buf: Pointer):Pointer; 
      cdecl; external XINESHAREDLIB;
   function xine_buffer_dup(buf: Pointer):Pointer; 
      cdecl; external XINESHAREDLIB;
   function _xine_buffer_copyin(buf:Pointer; index: Integer; data: Pointer;
      len: Integer):Pointer; cdecl; external XINESHAREDLIB;
   procedure xine_buffer_copyout(buf:Pointer; index: Integer; data: Pointer;
      len: Integer); cdecl; external XINESHAREDLIB;
   function _xine_buffer_strcat(buf: Pointer; data: PChar):Pointer; 
      cdecl; external XINESHAREDLIB;
   function _xine_buffer_strcpy(buf: Pointer; index: Integer;
      data: PChar):Pointer; cdecl; external XINESHAREDLIB;
   function _xine_buffer_strchr(buf: Pointer; ch: Integer):Pointer; 
      cdecl; external XINESHAREDLIB;
   function xine_buffer_get_size(buf: Pointer):Integer; 
      cdecl; external XINESHAREDLIB;
   function _xine_buffer_ensure_size(buf:Pointer; size: Integer):Pointer; 
      cdecl; external XINESHAREDLIB;

   function xine_health_check_kernel
      (chkptr: Pxine_health_check_t):Pxine_health_check_t;
      cdecl; external XINESHAREDLIB;
   function xine_health_check_mtrr
      (chkptr: Pxine_health_check_t):Pxine_health_check_t;
      cdecl; external XINESHAREDLIB;
   function xine_health_check_cdrom
      (chkptr: Pxine_health_check_t):Pxine_health_check_t;
      cdecl; external XINESHAREDLIB;
   function xine_health_check_dvdrom
      (chkptr: Pxine_health_check_t):Pxine_health_check_t;
      cdecl; external XINESHAREDLIB;
   function xine_health_check_dma
      (chkptr: Pxine_health_check_t):Pxine_health_check_t;
      cdecl; external XINESHAREDLIB;
   function xine_health_check_x
      (chkptr: Pxine_health_check_t):Pxine_health_check_t;
      cdecl; external XINESHAREDLIB;
   function xine_health_check_xv
      (chkptr: Pxine_health_check_t):Pxine_health_check_t;
      cdecl; external XINESHAREDLIB;

   procedure xine_handle_stream_end(stream: Pxine_stream_t;
      non_user: Integer);cdecl; external XINESHAREDLIB;
   function xine_message(stream: Pxine_stream_t; typ: Integer):Integer;
       varargs; cdecl; external XINESHAREDLIB;
   function find_input_plugin (stream: Pxine_stream_t;
      mrl: PChar):Pinput_plugin_t; cdecl; external XINESHAREDLIB;
   function find_demux_plugin (stream: Pxine_stream_t;
      input: Pinput_plugin_t):Pdemux_plugin_t; cdecl; external XINESHAREDLIB;
   function find_demux_plugin_by_name (stream: Pxine_stream_t; name: PChar;
      input: Pinput_plugin_t):Pdemux_plugin_t; cdecl; external XINESHAREDLIB;
   function find_demux_plugin_last_probe (stream: Pxine_stream_t; name: PChar;
      input: Pinput_plugin_t):Pdemux_plugin_t; cdecl; external XINESHAREDLIB;
   procedure video_decoder_init(stream: Pxine_stream_t);
      cdecl; external XINESHAREDLIB;
   procedure video_decoder_shutdown(stream: Pxine_stream_t);
      cdecl; external XINESHAREDLIB;
   procedure audio_decoder_init(stream: Pxine_stream_t);
      cdecl; external XINESHAREDLIB;
   procedure audio_decoder_shutdown(stream: Pxine_stream_t);
      cdecl; external XINESHAREDLIB;
   procedure extra_info_reset( extra_info: Pextra_info_t );
      cdecl; external XINESHAREDLIB;
   procedure extra_info_merge( dst, srd: Pextra_info_t );
      cdecl; external XINESHAREDLIB;
   procedure xine_get_current_info (stream: Pxine_stream_t;
      extra_info: Pextra_info_t; size: Integer);
      cdecl; external XINESHAREDLIB;
   procedure xine_demux_flush_engine (stream: Pxine_stream_t);
      cdecl; external XINESHAREDLIB;
   procedure xine_demux_control_nop (stream: Pxine_stream_t;flags: uint32_t);
      cdecl; external XINESHAREDLIB;
   procedure xine_demux_control_newpts (stream: Pxine_stream_t;
      pts: int64_t; flags: uint32_t);
      cdecl; external XINESHAREDLIB;
   procedure xine_demux_control_headers_done (stream: Pxine_stream_t);
      cdecl; external XINESHAREDLIB;
   procedure xine_demux_control_start (stream: Pxine_stream_t);
      cdecl; external XINESHAREDLIB;
   procedure xine_demux_control_end (stream: Pxine_stream_t; flags: uint32_t);
      cdecl; external XINESHAREDLIB;
   function xine_demux_start_thread (stream: Pxine_stream_t):Integer;
      cdecl; external XINESHAREDLIB;
   function xine_demux_stop_thread (stream: Pxine_stream_t):Integer;
      cdecl; external XINESHAREDLIB;
   function xine_demux_read_header (input: Pinput_plugin_t;
      buffer: PByte; size: off_t):Integer; cdecl; external XINESHAREDLIB;
   function xine_demux_check_extension (mrl, extensions: PChar):Integer;
      cdecl; external XINESHAREDLIB;
   function xine_read_abort (stream: Pxine_stream_t; fd: Integer;
      buf: PChar; todo: off_t):off_t; cdecl; external XINESHAREDLIB;
   function get_video_decoder (stream: Pxine_stream_t;
      stream_type: uint8_t):Pvideo_decoder_t; cdecl; external XINESHAREDLIB;
   procedure free_video_decoder (stream: Pxine_stream_t;
      decoder: Pvideo_decoder_t); cdecl; external XINESHAREDLIB;
   function get_audio_decoder (stream: Pxine_stream_t;
      stream_type: uint8_t):Paudio_decoder_t; cdecl; external XINESHAREDLIB;
   procedure free_audio_decoder (stream: Pxine_stream_t;
      decoder: Paudio_decoder_t); cdecl; external XINESHAREDLIB;
   function get_spu_decoder (stream: Pxine_stream_t;
      stream_type: uint8_t):Pspu_decoder_t; cdecl; external XINESHAREDLIB;
   procedure free_spu_decoder (stream: Pxine_stream_t;
      decoder: Pspu_decoder_t); cdecl; external XINESHAREDLIB;
   function xine_load_video_output_plugin(this: Pxine_t; id: PChar;
      visual_type: Integer; visual: Pointer):Pvo_driver_t;
      cdecl; external XINESHAREDLIB;
   function xine_load_audio_output_plugin (this: Pxine_t;
      id: PChar):Pao_driver_t; cdecl; external XINESHAREDLIB;
   procedure xine_set_speed (stream: Pxine_stream_t; speed: Integer);
      cdecl; external XINESHAREDLIB;
   procedure xine_select_spu_channel(stream: Pxine_stream_t; channel: Integer);
      cdecl; external XINESHAREDLIB;
   function xine_get_audio_channel (stream: Pxine_stream_t):Integer;
      cdecl; external XINESHAREDLIB;
   function xine_get_spu_channel (stream: Pxine_stream_t):Integer;
      cdecl; external XINESHAREDLIB;

   function xine_mutex_init (mutex: Pxine_mutex_t;
      mutexattr: Ppthread_mutexattr_t; id: PChar):Integer;
      cdecl; external XINESHAREDLIB;
   function xine_mutex_lock (mutex: Pxine_mutex_t; who: PChar):Integer;
      cdecl; external XINESHAREDLIB;
   function xine_mutex_unlock (mutex: Pxine_mutex_t; who: PChar):Integer;
      cdecl; external XINESHAREDLIB;
   function xine_mutex_destroy (mutex: Pxine_mutex_t):Integer;
      cdecl; external XINESHAREDLIB;
   procedure xine_probe_fast_memcpy(config: Pconfig_values_t);
      cdecl; external XINESHAREDLIB;
   function xine_mm_accel: uint32_t; cdecl; external XINESHAREDLIB;
   procedure xine_profiler_init; cdecl; external XINESHAREDLIB;
   function xine_profiler_allocate_slot(labl: PChar):Integer;
      cdecl; external XINESHAREDLIB;
   procedure xine_profiler_start_count(id: Integer); 
      cdecl; external XINESHAREDLIB;
   procedure xine_profiler_stop_count(id: Integer); 
      cdecl; external XINESHAREDLIB;
   procedure xine_profiler_print_results; 
      cdecl; external XINESHAREDLIB;
   function xine_xmalloc(size: size_t):Pointer; cdecl; external XINESHAREDLIB;
   function xine_xmalloc_aligned(alignment, size: size_t;
      base: PPointer):Pointer; cdecl; external XINESHAREDLIB;
   function xine_get_homedir: PChar; cdecl; external XINESHAREDLIB;
   function xine_chomp(str: PCHar):PChar; cdecl; external XINESHAREDLIB;
   procedure xine_usec_sleep(usec: Cardinal); cdecl; external XINESHAREDLIB;
   procedure xine_strdupa(dest, src: PChar); cdecl; external XINESHAREDLIB;
   procedure init_yuv_conversion; cdecl; external XINESHAREDLIB;
   procedure init_yuv_planes(yuv_planes: Pyuv_planes_t;
      width, height: Integer); cdecl; external XINESHAREDLIB;
   procedure free_yuv_planes(yuv_planes: Pyuv_planes_t); 
      cdecl; external XINESHAREDLIB;
   procedure xine_print_trace; cdecl; external XINESHAREDLIB;
   function xine_list_new: Pxine_list_t; cdecl; external XINESHAREDLIB;
   procedure xine_list_free(l: Pxine_list_t); cdecl; external XINESHAREDLIB;
   function xine_list_is_empty(l: Pxine_list_t):Integer;
      cdecl; external XINESHAREDLIB;
   function xine_list_first_content (l: Pxine_list_t):Pointer;
      cdecl; external XINESHAREDLIB;
   function xine_list_next_content (l: Pxine_list_t):Pointer;
      cdecl; external XINESHAREDLIB;
   function xine_list_last_content (l: Pxine_list_t):Pointer;
      cdecl; external XINESHAREDLIB;
   function xine_list_prev_content (l: Pxine_list_t):Pointer;
      cdecl; external XINESHAREDLIB;
   procedure xine_list_append_priority_content (l: Pxine_list_t;
      content:Pointer; priority: Integer); cdecl; external XINESHAREDLIB;
   procedure xine_list_append_content (l: Pxine_list_t; content:Pointer);
      cdecl; external XINESHAREDLIB;
   procedure xine_list_insert_content (l: Pxine_list_t; content:Pointer);
      cdecl; external XINESHAREDLIB;
   procedure xine_list_delete_current (l: Pxine_list_t);
      cdecl; external XINESHAREDLIB;

   procedure lexer_init(buf: PChar; size: Integer); 
      cdecl; external XINESHAREDLIB;
   function lexer_get_token(tok: PChar; token_size: Integer):Integer;
      cdecl; external XINESHAREDLIB;

   procedure xml_parser_init(buf: PChar; size, mode: Integer);
      cdecl; external XINESHAREDLIB;
   function xml_parser_build_tree(root_node: PPxml_node_s):Integer;
      cdecl; external XINESHAREDLIB;
   procedure xml_parser_free_tree(root_node: Pxml_node_s);
      cdecl; external XINESHAREDLIB;

implementation

end.















