{
                             xineAudioPlugin.pas
                             -------------------
    copyright            : (C) 2002 by Ryan Rusaw
    email                : rrusaw@sasktel.net

 ***************************************************************************
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************
}
unit xineaudioplugin;
{$mode objfpc}{$H+}
interface

uses
  SysUtils, Classes, xine;

type
  TaudioPlugins = ( adNull, adAlsa, adOss, adArts, adEsd, adAuto );
  TxineAudioPlugin = class(TComponent)
  private
    { Private declarations }
    ao_driver: Pxine_ao_driver_t;
    myAudioDriver : TaudioPlugins;
    procedure setAudioDriver(driver: TaudioPlugins);
  protected
    { Protected declarations }
  public
    { Public declarations }
    property AoDriver: Pxine_ao_driver_t read ao_driver;
    procedure Initialize(xine: Pxine_t);
  published
    { Published declarations }
    property audioDriver: TaudioPlugins read myAudioDriver
      write setAudioDriver default adNull;
  end;

const
  audNames : array[0..5] of PChar = ( 'null', 'alsa', 'oss', 'arts', 'esd', 'auto' );

procedure Register;

implementation

uses
  xineengine;

procedure Register;
begin
  RegisterComponents('Pluto', [TxineAudioPlugin]);
end;

procedure TxineAudioPlugin.setAudioDriver(driver: TaudioPlugins);
begin
     myAudioDriver := driver;
end;

procedure TxineAudioPlugin.Initialize(xine: Pxine_t);
begin
     // Select Audio Plugin
     ao_driver := xine_open_audio_driver(xine,audNames[ord(myAudioDriver)],Nil);
end;

end.
 
